;--------------------------------
;TP-C1.INC	ho	02-MAR-94
;--------------------------------
;454Ah-4F34h

		IDENT	TP-C1.INC

;Compiler: Pre- and Postparation
$Compile:	LD	(CErrSP),SP	;save SP of Menu in case of error
		LD	HL,(TextEnd)
		INC	HL
		LD	(PatchList),HL	;reserve max. 256 entries with
		INC	H		;2 words each = 1 K
		INC	H
		INC	H
		INC	H
		LD	(L7BE1),HL
		LD	HL,(CDatEnd)
		LD	(CDatStart),HL
		XOR	A
		LD	H,A
		LD	L,A
		LD	(L7B91),A
		LD	(L7B92),A
		LD	(L7B94),A
		LD	(CEofReached),A	;not at end of file
		LD	(DirUUsed),A	;directive U not yet encountered
		LD	(PatchLen),A	;no patches yet
		LD	(CInclude),A	;not in include file
		LD	(OvlyNumber),A	;start with name 000
		LD	(ObjSecFlags),A	;sector does not need to be read in
					;first or written back afterwards
		LD	(ObjOffset),HL	;no offset (only with overlay files)
		LD	(CLines),HL	;no line compiled yet
		CALL	Alive1
		DEC	HL		;=-1
		LD	(ObjFCB+33),HL	;no sector output yet
		LD	A,13
		LD	(L7B93),A
		LD	A,11110101B	;default compiler directives
		;	  CBVXUARI	(1 denotes +, 0 -)
		LD	(CDirektiv),A
		LD	A,4		;default max. WITH depth
		LD	(CDirektW),A
		LD	HL,(TextStart)
		LD	(MainPtr),HL	;pointer in main file (in memory)
		LD	(MainLnStart),HL ;beginning of line
		LD	IX,LineBuffer	;begin with empty line
		LD	(IX),0
		LD	HL,(CCodeStart)
		CALL	SeekObj
		LD	HL,(MaxMem)
		DEC	HL
		LD	(DefSymEnd),HL
		LD	D,H
		LD	E,L
		LD	BC,DefSymLen	;length of predefined symbols
		OR	A
		SBC	HL,BC
		LD	(TmpSymStart),HL
		LD	(SymStart),HL
		LD	(SymEnd),HL
		CALL	ChkCOverflow	;does it fit in?
		LD	HL,DefSymTab-1
		LDDR
		CALL	$Program	;this is where it happens!
		LD	A,(CCmpZiel)
		DEC	A		;destination = file?
		JR	NZ,$Compile1	;no ->
		CALL	FlushPatch
		CALL	WriteObjSec
$Compile1:	LD	(CCodeEnd),IY	;store end of code
		XOR	A		;error code 0 (ok)
		JP	ErrAlwaysA

;compile program
;Method: top-down, recursive descend
;Here too: much pre- and postparing
$Program:	CALL	ScanSpace	;space/comment/directive
		CALL	CompareNam
		DEFW	PROGRAMnam	;'PROGRAM'?
		JR	NZ,$Program3	;no -> is ok
	;only parse PROGRAM line, has no meaning
		CALL	L4692		;program name
		CALL	ScanRundAuf	;parameters given?
		JR	NZ,$Program2	;no -> is ok
$Program1: ;read away parameters
		CALL	L4692
		CALL	ScanComma
		JR	Z,$Program1
		CALL	NeedRundZu
$Program2:	CALL	NeedSemi
$Program3: ;ok, now generate the following head:
	;	LD	SP,TPA
	;	LD	HL,BufferAddress (memory end-80h)
	;	LD	BC,DirC * 256 + DirU
	;	CALL	InitCharIO
	;	LD	HL,ProgramEnd	(end of code)
	;	LD	DE,StackPointer	 (end of data)
	;	LD	BC,MemoryEnd
	;	LD	A,StandAloneFlag
	;	CALL	InitMem
		LD	A,31h		;LD SP,nn
		LD	HL,TPA
		CALL	CmpOutAHL
		LD	HL,LineBuffer
		LD	A,(CCmpZiel)
		OR	A		;memory?
		JR	Z,$Program4	;yes -> take buffer of compiler, don't
		LD	DE,80h		;allokate extra space again
		CALL	AllocDat
$Program4:	CALL	CmpOutLDHL
		LD	A,(CDirektiv)
		BIT	7,A		;directive C
		LD	D,0
		JR	Z,$Program5
		DEC	D
$Program5:	PUSH	DE		;save it. We don't know directive U yet
		LD	A,01h		;LD BC,
		CALL	CmpOutA
		PUSH	IY		;save position
		CALL	CmpOutHL	;just reserve space here
		LD	HL,InitCharIO
		CALL	CmpOutCALL
		LD	A,21h		;LD HL,
		CALL	CmpOutA
		PUSH	IY		;we don't know the program end yet
		CALL	CmpOutHL
		LD	A,11h		;LD DE,
		CALL	CmpOutA
		PUSH	IY		;we don't know end of data yet
		CALL	CmpOutHL
		LD	HL,(CDatEnd)	;end of memory
		CALL	CmpOutLDBC
		LD	A,(CCmpZiel)
		LD	H,A
		LD	L,3Eh		;LD A,StandAloneFlag
		CALL	CmpOutHL
		LD	HL,InitMem
		CALL	CmpOutCALL
		CALL	$Block		;this is where it happens!
		CALL	L52FC
		LD	A,(IX)		;END.<--
		CP	'.'
		CALL	ErrIfNZero
		DEFB	10		;'.' expected
	;in the end:
	;	JP	HaltProgram
		LD	HL,HaltProgram
		CALL	CmpOutJP
		POP	HL		;that's where the end of the data area belongs
		LD	DE,(CDatStart)
		CALL	PatchDE
		POP	HL		;that's where the end of code belongs
		CALL	PatchIY		;this is the current PC (in IY)
		POP	HL		;that's where the directive U is still missing
		POP	DE
		LD	A,(DirUUsed)
		LD	E,A
		JP	PatchDE		;finished!

;scan identifier, but don't keep name
L4692:		LD	HL,(TmpSymStart)
		PUSH	HL
		CALL	ScanNewSym
		POP	HL
		LD	(TmpSymStart),HL
		RET

;LABEL,CONST,TYPE,VAR,procedure-/function declaration,BEGIN
$Block:	;reserve space for WITH table
		LD	A,(CDirektW)
		PUSH	AF
		ADD	A,A		;*2
		LD	E,A
		LD	D,0
		CALL	AllocDat
		PUSH	HL		;save address of table
		CALL	CmpOutJPOP
		PUSH	IY		;save PC
		PUSH	HL
		CALL	CmpOutHL
$Block1:	CALL	CompareTbl
		dbw	1,BlockTbl
		CALL	ErrIfNZero
		DEFB	12		;BEGIN expected
		LD	A,(HL)
$Block2:	CP	1		;LABEL?
		JR	NZ,$Block3
		CALL	L488E
		JR	$Block1

$Block3:	CP	2		;CONST?
		JR	NZ,$Block4
		CALL	L48B7
		JR	$Block2

$Block4:	CP	3		;TYPE?
		JR	NZ,$Block5
		CALL	L4AEB
		JR	$Block2

$Block5:	CP	4		;VAR?
		JR	NZ,$Block6
		CALL	L4B2A
		LD	HL,(CDatStart)
		EX	(SP),HL
		JR	$Block2

$Block6:	CP	7		;OVERLAY?
		JP	NZ,$Block7
	;OVERLAY
		LD	A,(CCmpZiel)
		OR	A		;destination = Memory?
		CALL	ErrIfZero
		DEFB	77		;Overlays are not allowed in direct mode
	;put together overlay file name
		LD	HL,ObjFCB+1	;copy name
		LD	DE,OvlyName
		LD	BC,8
		LDIR
		LD	HL,OvlyNumber
		LD	A,(HL)		;extension = continuous number
		INC	(HL)
		EX	DE,HL
		LD	(HL),'0'	;first digit always 0
		INC	HL
		LD	B,'0'-1		;next digit tens
$Overlay1:	INC	B
		SUB	10
		JR	NC,$Overlay1
		LD	(HL),B
		INC	HL
		ADD	A,'0'+10	;at last ones
		LD	(HL),A
	;put together header of overlay area in main program
		LD	HL,Overlay
		CALL	CmpOutCALL
		LD	HL,-1
		CALL	CmpOutHL
		LD	HL,OvlyName	;copy name
		LD	B,11
$Overlay2:	LD	A,(HL)
		CALL	CmpOutA
		INC	HL
		DJNZ	$Overlay2
	;save old values on stack
		LD	A,(CCmpZiel)
		DEC	A		;destination = file?
		JR	NZ,$Overlay3	;no -> continue
		CALL	FlushPatch
		XOR	A
		LD	(PatchLen),A
		CALL	WriteObjSec
$Overlay3:	LD	HL,(ObjOffset)
		PUSH	HL
		LD	HL,(CFilePC)
		PUSH	HL
		LD	HL,(OvlyCodeMax)
		PUSH	HL
		LD	(CFilePC),IY
		LD	HL,0
		LD	(OvlyCodeMax),HL
		LD	HL,-FCBSize	;reserve space for old ObjFCB on stack
		ADD	HL,SP
		LD	SP,HL
		EX	DE,HL
		LD	HL,ObjFCB
		LD	BC,FCBSize
		LDIR
	;prepare ObjFCB for overlay file, open file
		LD	A,(CCmpZiel)
		DEC	A		;destination = file?
		JR	NZ,$Overlay5	;no -> continue
		LD	HL,OvlyName
		LD	DE,ObjFCB+1
		LD	BC,11
		LDIR
		EX	DE,HL
		LD	B,24
$Overlay4:	LD	(HL),0
		INC	HL
		DJNZ	$Overlay4
		LD	DE,ObjFCB
		PUSH	DE
		LD	C,DeleteFile
		CALL	SBDOS
		POP	DE
		LD	C,MakeFile
		CALL	SBDOS
		INC	A
		CALL	ErrIfZero
		DEFB	92		;Directory full
$Overlay5:	XOR	A
		LD	(ObjSecFlags),A
		LD	(ObjSecPtr),A
		LD	HL,(CDatStart)
		LD	(OvlyDatMax),HL
$Overlay6: ;process one overlay procedure/function
		CALL	CompareTbl
		dbw	1,ProcFuncTbl
		CALL	ErrIfNZero
		DEFB	16		;PROCEDURE or FUNCTION expected
		LD	A,(HL)
		PUSH	IY		;save PC
		LD	HL,(ObjFCB+33)
		LD	(ObjOffset),HL
		LD	HL,(CDatStart)
		PUSH	HL
		LD	HL,(OvlyDatMax)
		PUSH	HL
		LD	E,0FFh
		CALL	L4B3A		;this is where it happens
	;data consumption: calculate new maximum
		LD	B,H
		LD	C,L
		POP	DE
		LD	HL,(CDatStart)
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		JR	C,$Overlay7
		EX	DE,HL
$Overlay7:	LD	(OvlyDatMax),HL
		POP	HL		;old CDatStart
		LD	(CDatStart),HL
		POP	DE		;start PC
		PUSH	BC
		PUSH	DE
		LD	A,(CCmpZiel)
		DEC	A		;destination = file?
		CALL	Z,FlushPatch	;yes -> make patches now
		XOR	A
		LD	(PatchLen),A
	;determine code size and fill to multiple of sector size
		POP	DE		;start PC
		PUSH	DE
$Overlay8:	PUSH	IY
		POP	HL
		OR	A
		SBC	HL,DE		;HL= length
		LD	A,L
		AND	7Fh
		JR	Z,$Overlay9
		XOR	A
		CALL	CmpOutA
		JR	$Overlay8

$Overlay9: ;convert code size to number of sectors, determine new maximum
		ADD	HL,HL
		LD	E,H
		LD	D,0
		RL	D
		LD	HL,(OvlyCodeMax)
		SBC	HL,DE
		JR	NC,$Overlay10
		LD	(OvlyCodeMax),DE
$Overlay10:	POP	IY
		POP	HL
		INC	HL
		LD	(HL),E
		INC	HL
		LD	(HL),D
	;overlay procedure/-function following?
		CALL	CompareNam
		DEFW	OVERLAYnam
		JR	Z,$Overlay6	;yes -> ends up in same file
	;finished with overlay file, allocate max. data consumption, close file
		LD	HL,(OvlyDatMax)
		LD	(CDatStart),HL
		LD	A,(CCmpZiel)
		DEC	A		;destination = file?
		JR	NZ,$Overlay11	;no -> continue
		LD	DE,ObjFCB
		LD	C,CloseFile
		CALL	SBDOS
$Overlay11: ;restore old values from stack
		LD	HL,0
		ADD	HL,SP
		LD	DE,ObjFCB	;FCB of previous ObjFile
		LD	BC,FCBSize
		LDIR
		LD	SP,HL
		LD	DE,(OvlyCodeMax)
		POP	HL
		LD	(OvlyCodeMax),HL
		POP	HL
		LD	(CFilePC),HL
		POP	HL
		LD	(ObjOffset),HL
		XOR	A
		LD	(ObjSecFlags),A
		LD	HL,-1		;no sector is read in
		LD	(ObjFCB+33),HL
		PUSH	IY
		POP	HL		;advance to end of object file
		CALL	SeekObj
$Overlay12: ;create template in main file
		LD	B,SecSize
$Overlay13:	XOR	A
		CALL	CmpOutA
		DJNZ	$Overlay13
		DEC	DE
		LD	A,D
		OR	E
		JR	NZ,$Overlay12
		JP	$Block1

$Block7:	CP	8		;BEGIN?
		JR	Z,$Block8	;yes ->
	 ;procedure-/function declaration
		LD	E,0
		CALL	L4B3A
		JP	$Block1

$Block8: ;BEGIN
		CALL	L4E8A
		POP	DE
		POP	HL
		PUSH	DE
		PUSH	IY
		POP	DE
		DEC	DE
		DEC	DE
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		JR	Z,$Block9
		CALL	PatchIY
		JR	$Block10

$Block9:	DEC	HL
		CALL	SeekObj
$Block10:	POP	DE
		POP	HL
		LD	(L7BCA),HL
		POP	AF
		LD	(L7BC6),A
		RET

;Label
L488E:		LD	DE,0100h	;item =1 (label)
		CALL	WriteSymDE
		LD	A,(IX)
		CALL	IsAlnum
		CALL	ScanNewSym1
		LD	A,(L7B94)
		CALL	WriteSymA
		LD	B,3
L48A5:		LD	A,0FFh
		CALL	WriteSymA
		DJNZ	L48A5
		CALL	EnterSymbol
		CALL	ScanComma
		JR	Z,L488E
		JP	NeedSemi

;Const
L48B7:		LD	HL,(TmpSymStart)
		PUSH	HL		;keep pointer to insert item later
		LD	DE,0000h	;for now, only reserve space
		CALL	WriteSymDE
		CALL	ScanNewSym
		CALL	ScanEqual	;'='?
		JR	NZ,L4901	;no -> then typified constant
	;real constant
		CALL	L6A0D
		LD	A,B
		CALL	WriteSymA
		LD	A,B
		CP	9
		JR	NZ,L48E3
		EXX
		PUSH	HL
		PUSH	DE
		PUSH	BC
		LD	B,3
L48DB:		POP	DE
		CALL	WriteSymDE
		DJNZ	L48DB
		JR	L48FA

L48E3:		CP	8
		JR	NZ,L48F6
		LD	HL,L7A57
		LD	A,C
		INC	C
L48EC:		CALL	WriteSymA
		LD	A,(HL)
		INC	HL
		DEC	C
		JR	NZ,L48EC
		JR	L48FA

L48F6:		EX	DE,HL
		CALL	WriteSymDE
L48FA:		CALL	EnterSymbol
		LD	D,2		;item =2 (constant)
		JR	L4928

L4901:	;typified constant = predefined variable
		CALL	NeedColon
		XOR	A
		CALL	WriteSymA
		CALL	WriteSymIY
		LD	HL,(TmpSymStart)
		PUSH	HL
		CALL	WriteSymDE
		CALL	EnterSymbol
		CALL	L4F9B
		POP	HL
		LD	DE,(L7B5A)
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		CALL	NeedEqual
		CALL	L4937
		LD	D,4		;item =4 (variable)
L4928:		POP	HL		;insert item
		LD	(HL),D
		CALL	NeedSemi
		CALL	CompareTbl	;different item follows?
		dbw	1,BlockTbl
		JR	NZ,L48B7	;no -> next constant
		LD	A,(HL)
		RET

L4937:	;typified constant: value
		LD	A,(L7B5C)
		CP	4
		JR	C,L4946
		CP	8
		JR	NC,L4946
		CALL	ErrAlways
		DEFB	61		;Files and pointers are not allowed here

L4946:		CP	1
		JR	NZ,L49A1
		CALL	L6D2A
		LD	HL,(L7B60)
		CALL	L5271
		LD	HL,(L7B6D)
		LD	DE,(L7B6B)
		OR	A
		SBC	HL,DE
		INC	HL
		PUSH	HL
		LD	HL,(L7B5E)
		CALL	L5287
		POP	DE
		LD	A,(L7B5C)
		CP	12
		JR	NZ,L4978
		LD	A,D
		OR	A
		JR	NZ,L4978
		CALL	ScanRundAuf
		JR	NZ,L498A
		JR	L497B

L4978:		CALL	NeedRundAuf
L497B:		PUSH	DE
		CALL	L4937
		POP	DE
		DEC	DE
		LD	A,D
		OR	E
		JR	Z,L499A
		CALL	NeedComma
		JR	L497B

L498A:		PUSH	DE
		CALL	L69FD
		POP	DE
		LD	A,C
		CP	E
		CALL	ErrIfNZero
		DEFB	50		;String constant length does not match type
		CALL	CmpOutChrArr
		JR	L499D

L499A:		CALL	NeedRundZu
L499D:		CALL	L6D49		;JP .. would be better
		RET

L49A1:		CP	2
		JR	NZ,L49FA
		CALL	L6D2A
		CALL	NeedRundAuf
		LD	A,(L7B5D)
		LD	C,A
		LD	HL,(L7B62)
		PUSH	HL
		LD	HL,0
L49B6:		PUSH	BC
		PUSH	HL
		LD	B,4
		CALL	ScanExistSym
		CALL	ErrIfNZero
		DEFB	41		;Unknown identifier or syntax error
		CALL	L5276
		POP	DE
		LD	HL,(L7B58)
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		CALL	ErrIfNZero
		DEFB	69		;Invalid ordering of fields
		LD	DE,(L7B62)
		ADD	HL,DE
		PUSH	HL
		CALL	NeedColon
		CALL	L4937
		POP	HL
		POP	BC
		CALL	ScanSemi
		JR	Z,L49B6
		CALL	NeedRundZu
		POP	DE
		EX	DE,HL
		OR	A
		SBC	HL,DE
L49EB:		LD	A,H
		OR	L
		JR	Z,L49F6
		XOR	A
		CALL	CmpOutA
		DEC	HL
		JR	L49EB

L49F6:		CALL	L6D49		;JP would be better
		RET

L49FA:		CP	3
		JR	NZ,L4A7A
		CALL	L6D2A
		LD	HL,(L7B62)
		LD	(L7B6F),HL
		LD	HL,(L7B5E)
		CALL	L5287
		CALL	NeedEckAuf
		LD	(L7BA9),IX
		CALL	EmptySet
		LD	IX,(L7BA9)
		CALL	ScanEckZu
		JR	Z,L4A4B
L4A20:		CALL	L4ACA
		PUSH	HL
		CALL	CompareNam
		DEFW	DOTDOTnam
		JR	NZ,L4A37
		CALL	L4ACA
		LD	(L7BA9),IX
		CALL	RangeToSet
		JR	L4A3F

L4A37:		POP	HL
		LD	(L7BA9),IX
		CALL	ElemToSet
L4A3F:		LD	IX,(L7BA9)
		CALL	ScanComma
		JR	Z,L4A20
		CALL	NeedEckZu
L4A4B:		LD	HL,L7A57
		LD	BC,32
		LD	(L7BA9),IX
		CALL	StoreSet
		LD	IX,(L7BA9)
		LD	HL,L7A57
		LD	A,(L7B5E)
		RRA
		RRA
		RRA
		AND	1Fh
		LD	E,A
		LD	D,0
		ADD	HL,DE
		LD	A,(L7B6F)
		LD	B,A
L4A6F:		LD	A,(HL)
		CALL	CmpOutA
		INC	HL
		DJNZ	L4A6F
		CALL	L6D49
		RET

L4A7A:		CP	8
		JR	NZ,L4A99
		CALL	L69FD
		LD	A,(L7B62)
		DEC	A
		SUB	C
		LD	B,A
		JR	NC,L4A8D
		ADD	A,C
		LD	C,A
		LD	B,0
L4A8D:		CALL	CmpOutString
		INC	B
L4A91:		DEC	B
		RET	Z
		XOR	A
		CALL	CmpOutA
		JR	L4A91

L4A99:		CP	9
		JR	NZ,L4ABC
		CALL	L69EA
		LD	A,B
		CP	9
		JR	Z,L4AAF
		CP	10
		CALL	ErrIfNZero
		DEFB	25		;Integer or real constant expected
		CALL	Int2Real
		EXX
L4AAF:		EXX
		PUSH	BC
		PUSH	DE
		PUSH	HL
		LD	B,3
L4AB5:		POP	HL
		CALL	CmpOutHL
		DJNZ	L4AB5
		RET

L4ABC:		CALL	L4ACA
		LD	A,(L7B62)
		DEC	A
		LD	A,L
		JP	Z,CmpOutA
		JP	CmpOutHL

L4ACA:		CALL	L69EA
		LD	A,(L7B5C)
		CP	B
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
		LD	DE,(L7B5E)
		CALL	CCompInts
		JR	C,L4AE7
		LD	DE,(L7B60)
		CALL	CCompInts
		RET	C
		RET	Z
L4AE7:		CALL	ErrAlways
		DEFB	45		;Constant out of range

;Type
L4AEB:		LD	HL,(TmpSymStart)
		PUSH	HL
L4AEF:		LD	HL,(TmpSymStart)
		PUSH	HL
		LD	DE,0000h
		CALL	WriteSymDE
		CALL	ScanNewSym
		LD	HL,(TmpSymStart)
		PUSH	HL
		CALL	WriteSymDE
		CALL	EnterSymbol
		CALL	NeedEqual
		CALL	L4F9B
		POP	HL
		LD	DE,(L7B5A)
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		POP	HL
		LD	(HL),3		;item =3 (type)
		CALL	NeedSemi
		CALL	CompareTbl	;different item follows?
		dbw	1,BlockTbl
		JR	NZ,L4AEF	;no -> next type
		LD	A,(HL)
		POP	HL
		PUSH	AF
		CALL	L5295
		POP	AF
		RET

;Var
L4B2A:		CALL	L4F35
		CALL	NeedSemi
		CALL	CompareTbl	;different item follows?
		dbw	1,BlockTbl
		JR	NZ,L4B2A	;no -> next variable
		LD	A,(HL)
		RET

;(overlay) procedure/function
;flag in E (0= no overlay, 0FFh= overlay), item in A (5= proc, 6= func)
L4B3A:		LD	B,A
		LD	C,0
		SUB	5
		LD	(L7B97),A	;flag whether func (1= yes, 0=no)
		LD	A,E
		LD	(L7B99),A	;flag whether overlay (-1=yes, 0=no)
		LD	A,(CDirektiv)
		LD	(WrkDirektiv),A
		PUSH	BC
		CALL	SearchSym
		JP	Z,L4C61
		POP	DE
		CALL	WriteSymDE
		CALL	ScanNewSym
		LD	HL,(SymEnd)
		PUSH	HL
		LD	HL,(SymStart)
		LD	(SymEnd),HL
		LD	HL,(TmpSymStart)
		PUSH	HL
		CALL	WriteSymDE
		CALL	WriteSymDE
		CALL	WriteSymDE
		CALL	WriteSymDE
		LD	DE,(ObjOffset)
		CALL	WriteSymDE
		LD	DE,0000h
		CALL	WriteSymDE
		CALL	ScanRundAuf
		LD	B,0
		JR	NZ,L4BDA
L4B88:		PUSH	BC
		LD	HL,(TmpSymStart)
		PUSH	HL
		CALL	WriteSymDE
		CALL	WriteSymDE
		CALL	CompareNam
		DEFW	VARnam
		LD	BC,0
		JR	NZ,L4B9E
		DEC	C
L4B9E:		PUSH	BC
		CALL	ScanNewSym
		POP	BC
		INC	B
		CALL	ScanComma
		JR	Z,L4B9E
		PUSH	BC
		CALL	ScanColon
		JR	NZ,L4BB8
		LD	A,C
		LD	(L7B8F),A
		CALL	L4F18
		JR	L4BC3

L4BB8:		INC	C
		CALL	ErrIfNZero
		DEFB	2		;':' expected
		LD	HL,L7512
		LD	(L7B5A),HL
L4BC3:		POP	BC
		POP	HL
		LD	(HL),B
		DEC	HL
		LD	(HL),C
		LD	DE,(L7B5A)
		DEC	HL
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		POP	BC
		INC	B
		CALL	ScanSemi
		JR	Z,L4B88
		CALL	NeedRundZu
L4BDA:		PUSH	BC
		LD	A,(L7B97)
		OR	A
		JR	Z,L4C07
		CALL	NeedColon
		XOR	A
		LD	(L7B8F),A
		CALL	L4F18
		LD	A,(L7B5C)
		CP	8
		JR	NC,L4BF8
		CP	4
		CALL	ErrIfNZero
		DEFB	48		;Invalid result type
L4BF8:		POP	BC
		POP	HL
		PUSH	HL
		PUSH	BC
		LD	DE,-4
		ADD	HL,DE
		LD	DE,(L7B5A)
		LD	(HL),D
		DEC	HL
		LD	(HL),E
L4C07:		POP	BC
		POP	DE
		POP	HL
		LD	(SymEnd),HL
		PUSH	DE
		PUSH	BC
		CALL	EnterSymbol
		CALL	NeedSemi
		LD	A,(L7B99)
		OR	A
		JR	NZ,L4C44
		CALL	CompareNam
		DEFW	FORWARDnam
		JR	NZ,L4C2C
		PUSH	IY
		POP	DE
		CALL	CmpOutJP
		LD	A,0FFH
		JR	L4C38

L4C2C:		CALL	CompareNam
		DEFW	EXTERNALnam
		JR	NZ,L4C44
		CALL	L69F2
		EX	DE,HL
		XOR	A
L4C38:		POP	BC
		POP	HL
		LD	(HL),A
		DEC	HL
		LD	(HL),B
		DEC	HL
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		JP	NeedSemi

L4C44:		POP	BC
		POP	HL
		PUSH	HL
		LD	(HL),0
		DEC	HL
		LD	(HL),B
		DEC	HL
		PUSH	IY
		POP	DE
		LD	A,(L7B99)
		OR	A
		JR	Z,L4C5B
		EX	DE,HL
		LD	BC,-16
		ADD	HL,BC
		EX	DE,HL
L4C5B:		LD	(HL),D
		DEC	HL
		LD	(HL),E
		POP	HL
		JR	L4C76

L4C61:		LD	A,(HL)
		OR	A
		CALL	ErrIfZero
		DEFB	43		;Duplicate identifier or label
		LD	A,(L7B99)
		OR	A
		CALL	ErrIfNZero
		DEFB	76		;?
		CALL	AcceptIt
		POP	DE
		CALL	NeedSemi
L4C76:		EX	DE,HL
		LD	A,(CDirektiv)
		LD	HL,(CDatStart)
		BIT	2,A
		JR	Z,L4C84
		LD	HL,0
L4C84:		LD	(L7B83),HL
		LD	HL,(SymEnd)
		PUSH	HL
		LD	HL,(TmpSymStart)
		LD	(SymEnd),HL
		PUSH	HL
		EX	DE,HL
		LD	A,(HL)
		LD	(HL),0
		DEC	HL
		LD	B,(HL)
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		OR	A
		JR	Z,L4CA7
		PUSH	HL
		EX	DE,HL
		INC	HL
		CALL	PatchIY
		POP	HL
L4CA7:		LD	A,(L7B97)
		OR	A
		JR	Z,L4CD2
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		PUSH	HL
		EX	DE,HL
		CALL	L5287
		LD	A,(L7B5C)
		LD	(L7B87),A
		LD	HL,(L7B62)
		LD	A,L
		LD	(L7B88),A
		EX	DE,HL
		CALL	AllocDat
		LD	(L7B89),HL
		EX	DE,HL
		POP	HL
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		DEC	HL
		JR	L4CD6

L4CD2:		LD	DE,-4
		ADD	HL,DE
L4CD6:		LD	DE,-4
		ADD	HL,DE
		PUSH	HL
		LD	C,0
		LD	A,B
		OR	A
		JR	Z,L4D2B
L4CE1:		LD	A,(HL)
		ADD	A,C
		LD	C,A
		PUSH	BC
		LD	B,(HL)
		DEC	HL
		LD	A,(HL)
		LD	(L7B8F),A
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		PUSH	HL
		EX	DE,HL
		LD	(L7B5A),HL
		CALL	L5287
		LD	HL,(TmpSymStart)
		EX	(SP),HL
		PUSH	BC
L4CFD:		PUSH	BC
		LD	DE,0400h
		CALL	WriteSymDE
L4D04:		LD	A,(HL)
		CALL	WriteSymA
		BIT	7,(HL)
		DEC	HL
		JR	Z,L4D04
		PUSH	HL
		CALL	WriteSymA
		CALL	WriteSymDE
		CALL	WriteSymDE
		CALL	EnterSymbol
		POP	HL
		POP	BC
		DJNZ	L4CFD
		POP	BC
		EX	(SP),HL
		XOR	A
		LD	(L7B90),A
		CALL	L4F52
		POP	HL
		POP	BC
		DJNZ	L4CE1
L4D2B:		LD	B,C
		PUSH	BC
		LD	HL,(TmpSymStart)
		PUSH	HL
		LD	HL,(L7B83)
		PUSH	HL
		LD	HL,(L7B89)
		PUSH	HL
		LD	A,(L7B87)
		PUSH	AF
		LD	A,(L7B88)
		PUSH	AF
		LD	A,(L7B97)
		PUSH	AF
		LD	HL,L7B94
		INC	(HL)
		CALL	$Block
		POP	AF
		LD	(L7B97),A
		POP	AF
		LD	(L7B88),A
		POP	AF
		LD	(L7B87),A
		POP	HL
		LD	(L7B89),HL
		POP	HL
		LD	(L7B83),HL
		LD	(L7B85),DE
		LD	A,H
		OR	L
		JR	Z,L4D79
		SBC	HL,DE
		JR	Z,L4D79
		CALL	CmpOutLDBC
		EX	DE,HL
		CALL	CmpOutLDHL
		LD	HL,PushVars
		CALL	CmpOutCALL
L4D79:		POP	HL
		POP	BC
		INC	B
		DEC	B
		JP	Z,L4DF3
		CALL	CmpOutCopy
		  DEFB	2
		  POP	IY
L4D86:		PUSH	BC
		INC	HL
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		ADD	HL,DE
		PUSH	HL
		DEC	HL
		DEC	HL
L4D8F:		BIT	7,(HL)
		DEC	HL
		JR	Z,L4D8F
		CALL	L5276
		LD	A,(L7B57)
		OR	A
		JR	NZ,L4DD4
		LD	A,(L7B5C)
		CP	3
		JR	C,L4DBD
		JR	Z,L4DE6
		CP	4
		JR	Z,L4DE3
		CP	8
		JR	C,L4DBD
		JR	Z,L4DE6
		CP	10
		JR	NC,L4DE3
		CALL	CmpOutCopy
		  DEFB	3
		  POP	HL
		  POP	DE
		  POP	BC
		JR	L4DE6

L4DBD:		CALL	CmpOutPOPHL
		LD	HL,(L7B58)
		CALL	CmpOutLDDE
		LD	HL,(L7B62)
		CALL	CmpOutLDBC
		CALL	CmpOutCopy
		  DEFB	2
		  LDIR
		JR	L4DE9

L4DD4:		XOR	A
		LD	(L7B57),A
		LD	A,4
		LD	(L7B5C),A
		LD	HL,2
		LD	(L7B62),HL
L4DE3:		CALL	CmpOutPOPHL
L4DE6:		CALL	L661B
L4DE9:		POP	HL
		POP	BC
		DJNZ	L4D86
		CALL	CmpOutCopy
		  DEFB	2
		  PUSH	IY
L4DF3:		CALL	L52FC
		LD	HL,L7B94
		DEC	(HL)
		LD	A,(L7B97)
		OR	A
		JR	Z,L4E46
		LD	HL,(L7B89)
		LD	A,(L7B87)
		CP	8
		JR	NZ,L4E24
		LD	B,A
		CALL	CmpOutCopy
		  DEFB	2
		  POP	IY
		LD	A,21h		;LD HL,nn
		CALL	CmpOutAHL
		LD	HL,LoadString
		CALL	CmpOutCALL
		CALL	CmpOutCopy
		  DEFB	2
		  PUSH	IY
		JR	L4E46

L4E24:		CP	9
		JR	NZ,L4E35
		LD	A,21h		;LD HL,nn
		CALL	CmpOutAHL
		LD	HL,LoadReal
		CALL	CmpOutCALL
		JR	L4E46

L4E35:		LD	A,2Ah		;LD HL,(nn)
		CALL	CmpOutAHL
		LD	A,(L7B88)
		DEC	A
		JR	NZ,L4E46
		CALL	CmpOutCopy
		  DEFB	2
		  LD	H,0
L4E46:		LD	HL,(L7B83)
		LD	A,H
		OR	L
		JR	Z,L4E74
		LD	DE,(L7B85)
		SBC	HL,DE
		JR	Z,L4E74
		LD	A,(L7B97)
		OR	A
		JR	Z,L4E65
		LD	A,(L7B87)
		CP	8
		LD	A,0D9h		;EXX
		CALL	NZ,CmpOutA
L4E65:		CALL	CmpOutLDBC
		EX	DE,HL
		CALL	CmpOutLDDE
		LD	HL,PopVars
		CALL	CmpOutJP
		JR	L4E79

L4E74:		CALL	CmpOutCopy
		  DEFB	1
		  RET
L4E79:		CALL	NeedSemi
		POP	DE
		POP	HL
		LD	(TmpSymStart),HL
		LD	(SymStart),HL
		POP	HL
		LD	(SymEnd),HL
		EX	DE,HL
		RET

L4E8A:		LD	HL,(TmpSymStart)
L4E8D:		LD	DE,(SymEnd)
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		RET	Z
		INC	HL
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		ADD	HL,DE
		LD	A,(HL)
		CP	6
		JR	Z,L4EA4
		CP	5
		JR	NZ,L4E8D
L4EA4:		PUSH	HL
		DEC	HL
		DEC	HL
L4EA7:		BIT	7,(HL)
		DEC	HL
		JR	Z,L4EA7
		LD	A,(HL)
		OR	A
		CALL	ErrIfNZero
		DEFB	73		;Undefined FORWARD procedure(s)
		POP	HL
		JR	L4E8D

L4EB5:		LD	HL,(TmpSymStart)
		PUSH	HL
		LD	B,0
L4EBB:		PUSH	BC
		LD	D,4
		LD	A,(L7B91)
		LD	E,A
		CALL	WriteSymDE
		CALL	ScanNewSym
		CALL	WriteSymA
		CALL	WriteSymDE
		CALL	WriteSymDE
		CALL	EnterSymbol
		POP	BC
		INC	B
		CALL	ScanComma
		JR	Z,L4EBB
		POP	HL
		RET

L4EDD:		LD	HL,(TmpSymStart)
		PUSH	HL
		CALL	L4F9B
		POP	HL
		CALL	L5295
		CALL	CompareNam
		DEFW	ABSOLUTEnam
		LD	A,0
		JR	NZ,L4F14
		LD	A,(L7B91)
		OR	A
		CALL	ErrIfNZero
		DEFB	75		;Illegal use of ABSOLUTE
		LD	BC,0400h
		CALL	ScanExistSym
		JR	NZ,L4F0C
		LD	A,(HL)
		LD	(L7B8F),A
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
		JR	L4F0F

L4F0C:		CALL	L69F2
L4F0F:		LD	(L7B7F),HL
		LD	A,0FFh
L4F14:		LD	(L7B90),A
		RET

L4F18:		CALL	L4FC8
		CALL	ErrIfNZero
		DEFB	36		;Type identifier expected
		XOR	A
		LD	(L7B90),A
		LD	A,(L7B8F)
		OR	A
		RET	NZ
		LD	A,(L7B5C)
		CP	5
		RET	C
		CP	8
		RET	NC
		CALL	ErrAlways
		DEFB	67		;Files must be VAR parameters

;END OF TP-C1.INC
;----------------
