;--------------------------------
;TP-C2.INC	ho	02-MAR-94
;--------------------------------
;4F35h-5A31h

		IDENT	TP-C2.INC

L4F35:		CALL	L4EB5
		PUSH	HL
		PUSH	BC
		CALL	NeedColon
		XOR	A
		LD	(L7B8F),A
		CALL	L4EDD
		POP	BC
		LD	A,(L7B90)
		OR	A
		JR	Z,L4F51
		LD	A,B
		DEC	A
		CALL	ErrIfNZero
		DEFB	75		;Illegal use of ABSOLUTE
L4F51:		POP	HL
L4F52:		PUSH	BC
		PUSH	HL
		LD	A,(L7B8F)
		LD	HL,2
		OR	A
		JR	NZ,L4F60
		LD	HL,(L7B62)
L4F60:		EX	DE,HL
		LD	A,(L7B91)
		OR	A
		JR	NZ,L4F72
		LD	A,(L7B90)
		OR	A
		JR	NZ,L4F72
		CALL	AllocDat
		JR	L4F7B

L4F72:		LD	HL,(L7B7F)
		PUSH	HL
		ADD	HL,DE
		LD	(L7B7F),HL
		POP	HL
L4F7B:		EX	DE,HL
		POP	HL
		DEC	HL
L4F7E:		DEC	HL
		BIT	7,(HL)
		JR	Z,L4F7E
		DEC	HL
		LD	A,(L7B8F)
		LD	(HL),A
		DEC	HL
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		DEC	HL
		LD	DE,(L7B5A)
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		DEC	HL
		DEC	HL
		DEC	HL
		POP	BC
		DJNZ	L4F52
		RET

L4F9B:		CALL	L4FC8
		RET	Z
		CALL	CompareNam
		DEFW	PACKEDnam
		CALL	L4FDB
		RET	Z
		CALL	L5039
		RET	Z
		CALL	L5106
		RET	Z
		CALL	L5140
		RET	Z
		CALL	L516B
		RET	Z
		CALL	L51A5
		RET	Z
		CALL	L51C5
		RET	Z
		CALL	L5210
		RET	Z
		CALL	ErrAlways
		DEFB	36		;Type identifier expected

L4FC8:		LD	BC,0300h
		CALL	ScanExistSym
		RET	NZ
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
		LD	(L7B5A),HL
		CALL	L5287
		XOR	A
		RET

L4FDB:		CALL	CompareNam
		DEFW	ARRAYnam
		RET	NZ
		CALL	NeedEckAuf
		LD	B,0
L4FE6:		PUSH	BC
		CALL	L523B
		POP	BC
		LD	HL,(L7B5A)
		PUSH	HL
		LD	HL,(L7B60)
		LD	DE,(L7B5E)
		OR	A
		SBC	HL,DE
		INC	HL
		LD	A,H
		OR	L
		CALL	ErrIfZero
		DEFB	98		;Memory overflow
		PUSH	HL
		INC	B
		CALL	ScanComma
		JR	Z,L4FE6
		PUSH	BC
		CALL	NeedEckZu
		CALL	NeedOF
		CALL	L4F9B
		POP	BC
L5012:		LD	HL,(L7B5A)
		LD	(L7B5E),HL
		LD	HL,(L7B62)
		POP	DE
		PUSH	BC
		CALL	CMultInt
		CALL	ErrIfCarry
		DEFB	98		;Memory overflow
		POP	BC
		LD	(L7B62),HL
		POP	HL
		LD	(L7B60),HL
		LD	A,1
		LD	(L7B5C),A
		PUSH	BC
		CALL	L5254
		POP	BC
		DJNZ	L5012
		RET

L5039:		CALL	CompareNam
		DEFW	RECORDnam
		RET	NZ
		LD	A,(L7B9A)
		PUSH	AF
		LD	A,(L7B91)
		PUSH	AF
		LD	HL,L7B92
		INC	(HL)
		LD	A,(HL)
		LD	(L7B91),A
		LD	HL,(L7B7F)
		PUSH	HL
		LD	HL,(L7B81)
		PUSH	HL
		LD	HL,0
		LD	(L7B7F),HL
		LD	(L7B81),HL
		XOR	A
		LD	(L7B9A),A
		CALL	L508B
		LD	HL,(L7B81)
		LD	(L7B62),HL
		POP	HL
		LD	(L7B81),HL
		POP	HL
		LD	(L7B7F),HL
		LD	A,(L7B91)
		LD	(L7B5D),A
		POP	AF
		LD	(L7B91),A
		POP	AF
		LD	(L7B9A),A
		LD	A,2
		LD	(L7B5C),A
		JP	L5254

L508B:		CALL	L50F9
		RET	Z
		CALL	CompareNam
		DEFW	CASEnam
		JR	Z,L50B0
		CALL	L4F35
		LD	HL,(L7B7F)
		LD	DE,(L7B81)
		OR	A
		SBC	HL,DE
		JR	C,L50A9
		ADD	HL,DE
		LD	(L7B81),HL
L50A9:		CALL	ScanSemi
		JR	Z,L508B
		JR	L50E8

L50B0:		CALL	L4FC8
		CALL	NZ,L4F35
		CALL	NeedOF
L50B9:		CALL	L50F9
		RET	Z
		LD	HL,(L7B7F)
		PUSH	HL
L50C1:		CALL	L69EA
		CALL	ScanComma
		JR	Z,L50C1
		CALL	NeedColon
		CALL	NeedRundAuf
		LD	A,(L7B9A)
		PUSH	AF
		LD	A,0FFH
		LD	(L7B9A),A
		CALL	L508B
		POP	AF
		LD	(L7B9A),A
		POP	HL
		LD	(L7B7F),HL
		CALL	ScanSemi
		JR	Z,L50B9
L50E8:		LD	A,(L7B9A)
		OR	A
		JP	NZ,NeedRundZu
		CALL	CompareNam
		DEFW	ENDnam
		RET	Z
		CALL	ErrAlways
		DEFB	14		;END expected

L50F9:		LD	A,(L7B9A)
		OR	A
		JP	NZ,ScanRundZu
		CALL	CompareNam
		DEFW	ENDnam
		RET

L5106:		CALL	CompareNam
		DEFW	SETnam
		RET	NZ
		CALL	NeedOF
		CALL	L523B
		LD	HL,(L7B60)
		LD	DE,(L7B5E)
		LD	A,H
		OR	D
		CALL	ErrIfNZero
		DEFB	70		;Set base type out of range
		SRL	L
		SRL	L
		SRL	L
		SRL	E
		SRL	E
		SRL	E
		LD	A,L
		INC	A
		SUB	E
		LD	L,A
		LD	(L7B62),HL
		LD	HL,(L7B5A)
		LD	(L7B5E),HL
		LD	A,3
		LD	(L7B5C),A
		JP	L5254

L5140:		CALL	ScanCaret
		RET	NZ
		LD	DE,0
		CALL	WriteSymDE
		LD	HL,(TmpSymStart)
		PUSH	HL
		CALL	ScanEgalSym
		CALL	EnterSymbol
		POP	HL
		LD	(L7B5E),HL
		LD	A,4
		LD	(L7B5C),A
		LD	A,0FFH
		LD	(L7B5D),A
		LD	HL,2
		LD	(L7B62),HL
		JP	L5254

L516B:		CALL	CompareNam
		DEFW	FILEnam
		RET	NZ
		CALL	CompareNam
		DEFW	OFnam
		JR	NZ,L5197
		CALL	L4F9B
		LD	A,(L7B5C)
		CP	5
		JR	C,L518A
		CP	8
		JR	NC,L518A
		CALL	ErrAlways
		DEFB	68		;File components may not be files

L518A:		LD	HL,(L7B5A)
		LD	(L7B5E),HL
		LD	A,5
		LD	HL,AuxInPtr
		JR	L519C

L5197:		LD	A,7
		LD	HL,030h
L519C:		LD	(L7B5C),A
		LD	(L7B62),HL
		JP	L5254

L51A5:		CALL	CompareNam
		DEFW	STRINGnam
		RET	NZ
		CALL	NeedEckAuf
		CALL	L69F2
		INC	H
		DEC	H
		CALL	ErrIfNZero
		DEFB	49		;Invalid string length
		INC	L
		DEC	L
		CALL	ErrIfZero
		DEFB	49		;Invalid string length
		CALL	NeedEckZu
		INC	HL
		LD	A,8
		JR	L519C

L51C5:		CALL	ScanRundAuf
		RET	NZ
		LD	HL,-1
L51CC:		PUSH	HL
		LD	DE,0200h
		CALL	WriteSymDE
		CALL	ScanNewSym
		LD	A,(L7B93)
		CALL	WriteSymA
		POP	DE
		INC	DE
		PUSH	DE
		CALL	WriteSymDE
		CALL	EnterSymbol
		POP	HL
		CALL	ScanComma
		JR	Z,L51CC
		CALL	NeedRundZu
		PUSH	HL
		LD	HL,L7B93
		LD	A,(HL)
		INC	(HL)
		POP	HL
		LD	DE,0
L51F8:		LD	(L7B5C),A
		LD	(L7B5E),DE
		LD	(L7B60),HL
		LD	A,D
		OR	H
		LD	HL,1
		JR	Z,L520A
		INC	HL
L520A:		LD	(L7B62),HL
		JP	L5254

L5210:		CALL	L6A0D
		RET	NZ
		LD	A,B
		PUSH	AF
		CP	10
		CALL	ErrIfCarry
		DEFB	51		;Invalid subrange base type
		PUSH	HL
		CALL	CompareNam
		DEFW	DOTDOTnam
		CALL	ErrIfNZero
		DEFB	11		;'..' expected
		CALL	L69EA
		POP	DE
		POP	AF
		PUSH	AF
		CP	B
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
		CALL	CCompInts
		CALL	ErrIfCarry
		DEFB	52		;Lower bound > upper bound
		POP	AF
		JR	L51F8

L523B:		CALL	L5210
		RET	Z
		CALL	L51C5
		RET	Z
		CALL	L4FC8
		CALL	ErrIfNZero
		DEFB	30		;Simple type expected
		LD	A,(L7B5C)
		CP	10
		RET	NC
		CALL	ErrAlways
		DEFB	30		;Simple type expected

L5254:		LD	DE,0800h
		CALL	WriteSymDE
		LD	HL,(TmpSymStart)
		LD	(L7B5A),HL
		LD	HL,L7B5C
		LD	B,8
L5265:		LD	A,(HL)
		CALL	WriteSymA
		INC	HL
		DJNZ	L5265
		CALL	EnterSymbol
		XOR	A
		RET

L5271:		LD	DE,L7B69
		JR	L528A

L5276:		LD	A,(HL)
		DEC	HL
		LD	(L7B57),A
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		LD	(L7B58),DE
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
L5287:		LD	DE,L7B5C
L528A:		PUSH	BC
		LD	B,8
L528D:		LD	A,(HL)
		LD	(DE),A
		DEC	HL
		INC	DE
		DJNZ	L528D
		POP	BC
		RET

L5295:		LD	(L7B79),HL
		LD	HL,(TmpSymStart)
L529B:		LD	BC,(L7B79)
		OR	A
		SBC	HL,BC
		ADD	HL,BC
		RET	Z
		INC	HL
		LD	C,(HL)
		INC	HL
		LD	B,(HL)
		ADD	HL,BC
		LD	A,(HL)
		CP	8
		JR	NZ,L529B
		LD	(HL),0
		PUSH	HL
		DEC	HL
		DEC	HL
		LD	A,(HL)
		CP	4
		JR	NZ,L52F8
		DEC	HL
		LD	A,(HL)
		OR	A
		JR	Z,L52F8
		LD	(HL),0
		DEC	HL
		PUSH	HL
		LD	E,(HL)
		DEC	HL
		LD	D,(HL)
		LD	HL,(TmpSymStart)
L52C7:		LD	BC,(DefSymEnd)
		OR	A
		SBC	HL,BC
		ADD	HL,BC
		CALL	ErrIfZero
		DEFB	42		;Undefined pointer type in preceding type definitions
		INC	HL
		LD	C,(HL)
		INC	HL
		LD	B,(HL)
		ADD	HL,BC
		LD	A,(HL)
		CP	3
		JR	NZ,L52C7
		PUSH	HL
		PUSH	DE
		DEC	HL
		DEC	HL
L52E1:		LD	A,(DE)
		CP	(HL)
		JR	Z,L52E9
		POP	DE
		POP	HL
		JR	L52C7

L52E9:		BIT	7,(HL)
		DEC	HL
		DEC	DE
		JR	Z,L52E1
		POP	BC
		POP	BC
		LD	B,(HL)
		DEC	HL
		LD	C,(HL)
		POP	HL
		LD	(HL),C
		DEC	HL
		LD	(HL),B
L52F8:		POP	HL
		JP	L529B

L52FC:		XOR	A
		LD	(L7B95),A
		LD	(L7BC9),A
		CALL	BEGINcc
		LD	(L7BA4),IY
		CALL	CmpOutJP
		LD	HL,(TmpSymStart)
L5310:		LD	DE,(SymStart)
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		JR	NC,L5363
		INC	HL
		LD	C,(HL)
		INC	HL
		LD	B,(HL)
		INC	HL
		LD	A,(HL)
		INC	HL
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		PUSH	HL
		PUSH	BC
		LD	B,A
		LD	A,D
		OR	E
		JR	Z,L533A
		EX	DE,HL
		DEC	HL
		LD	A,(HL)
		LD	C,A
		INC	A
		CALL	ErrIfZero
		DEFB	40		;Undefined label
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		JR	L5340

L533A:		LD	DE,(L7BA4)
		LD	C,0
L5340:		POP	HL
L5341:		LD	A,B
		SUB	C
		JR	NZ,L534A
		CALL	PatchDE
		JR	L5360

L534A:		CALL	ErrIfCarry
		DEFB	71		;Invalid GOTO
		PUSH	DE
		PUSH	AF
		CALL	PatchIY
		POP	AF
		LD	B,A
L5355:		CALL	CmpOutPOPHL
		DJNZ	L5355
		LD	A,0C3h		;JP nn
		POP	HL
		CALL	CmpOutAHL
L5360:		POP	HL
		JR	L5310

L5363:		LD	HL,(L7BA4)
		INC	HL
		PUSH	IY
		POP	DE
		DEC	DE
		DEC	DE
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		JP	NZ,PatchIY
		DEC	HL
		JP	SeekObj

;'BEGIN'
BEGINcc:	CALL	Statement
		CALL	CompareNam
		DEFW	ENDnam		;end?
		RET	Z		;yes -> return
		CALL	L6F50		;need ';'
		JR	BEGINcc		;continue

Statement:	LD	A,0FFh
		LD	(L7B98),A
		LD	A,(CDirektiv)	;freeze compiler directives while
		LD	(WrkDirektiv),A	;processing one statement
		BIT	3,A		;direktive U?
		JR	Z,L539C
		LD	A,0FFh		;RST 38h
		LD	(DirUUsed),A	;note that BreakHandler is needed
		CALL	CmpOutA
L539C:		CALL	CompareTbl
		dbw	2,StatemTbl	;BEGIN,IF,WHILE,REPEAT,FOR
		JR	Z,L53CB		;CASE,GOTO,WITH,INLINE
		CALL	L67B2
		JP	Z,L57EA
		LD	BC,0500h
		CALL	ScanExistSym
		JP	Z,L573D
		LD	BC,0100h
		CALL	ScanExistSym
		JR	Z,L53D0		;Label
		LD	BC,0600h
		CALL	ScanExistSym
		JP	Z,L591F
		CALL	CompareTbl
		dbw	2,ProcTbl	;procedure call
		RET	NZ
L53CB:		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		EX	DE,HL
		JP	(HL)

;Label
L53D0:		CALL	NeedColon
		LD	A,(L7B94)
		CP	(HL)
		CALL	ErrIfNZero
		DEFB	72		;Label not within current block
		DEC	HL
		LD	A,(HL)
		INC	A
		CALL	ErrIfNZero
		DEFB	43		;Duplicate identifier or label
		LD	A,(L7B95)
		LD	(HL),A
		PUSH	IY		;save PC
		POP	DE
		DEC	HL
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		JR	Statement

;'IF'
IFcc:		CALL	L5EB0
		CALL	CmpOutCopy
		  DEFB	3
		  BIT	0,L
		  DEFB	0CAh		;JP Z,nn
		PUSH	IY
		CALL	CmpOutHL
		CALL	CompareNam
		DEFW	THENnam
		CALL	ErrIfNZero
		DEFB	17		;THEN expected
		CALL	Statement
		CALL	CompareNam
		DEFW	ELSEnam
		JR	NZ,L5420
		CALL	CmpOutJPOP
		POP	HL
		PUSH	IY
		CALL	CmpOutHL
		CALL	PatchIY
		CALL	Statement
L5420:		POP	HL
		JP	PatchIY

;'WHILE'
WHILEcc:	PUSH	IY
		CALL	L5EB0
		CALL	CompareNam
		DEFW	DOnam
		CALL	ErrIfNZero
		DEFB	13		;DO expected
		CALL	CmpOutCopy
		  DEFB	3
		  BIT	0,L
		  DEFB	0CAh		;JP Z,nn
		PUSH	IY
		CALL	CmpOutHL
		CALL	Statement
		POP	DE
		POP	HL
		LD	A,0C3h		;JP nn
		CALL	CmpOutAHL
		EX	DE,HL
		JP	PatchIY

;'REPEAT'
REPEATcc:	PUSH	IY
L544E:		CALL	Statement
		CALL	CompareNam
		DEFW	UNTILnam
		JR	Z,L545D
		CALL	L6F50
		JR	L544E

L545D:		CALL	L5EB0
		CALL	CmpOutCopy
		  DEFB	3
		  BIT	0,L
		  DEFB	0CAh		;JP Z,nn
		POP	HL
		JP	CmpOutHL

;'FOR'
FORcc:		LD	BC,0400h
		CALL	ScanExistSym
		CALL	ErrIfNZero
		DEFB	41		;Unknown identifier or syntax error
		CALL	L5276
		LD	A,(L7B57)
		OR	A
		JR	NZ,L5485
		LD	A,(L7B5C)
		CP	10
		JR	NC,L5489
L5485:		CALL	ErrAlways
		DEFB	30		;Simple type expected

L5489:		CALL	L6D2A
		LD	A,(L7B5C)
		PUSH	AF
		CALL	NeedAssign
		CALL	L5EE8
		CALL	CmpOutPUSHHL
		POP	AF
		PUSH	AF
		CP	B
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
		CALL	CompareTbl
		dbw	1,ForTbl
		CALL	ErrIfNZero
		DEFB	18		;TO or DOWNTO expected
		LD	E,(HL)
		PUSH	DE
		CALL	L5EE8
		POP	DE
		POP	AF
		PUSH	DE
		CP	B
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
		CALL	CompareNam
		DEFW	DOnam
		CALL	ErrIfNZero
		DEFB	13		;DO expected
		CALL	CmpOutCopy
		  DEFB	1
		  POP	DE
		POP	DE
		CALL	L6D63
		PUSH	DE
		LD	A,E
		LD	HL,ForTo
		CP	'#'			;23H
		JR	Z,L54D5
		LD	HL,ForDownTo
L54D5:		CALL	CmpOutCALL
		PUSH	IY
		CALL	CmpOutCopy
		  DEFB	6
		  LD	A,D
		  OR	E
		  JP	Z,0
		  PUSH	DE
		CALL	L661B
		LD	HL,L7B95
		INC	(HL)
		CALL	Statement
		LD	HL,L7B95
		DEC	(HL)
		POP	HL
		POP	DE
		CALL	L6D49
		PUSH	HL
		LD	HL,(L7B58)
		LD	A,2Ah		;LD HL,(nn)
		CALL	CmpOutAHL
		LD	A,(L7B62)
		DEC	A
		JR	NZ,L550C
		CALL	CmpOutCopy
		  DEFB	2
		  LD	H,0
L550C:		LD	A,E
		CALL	CmpOutA
		CALL	CmpOutCopy
		  DEFB	3
		  POP	DE
		  DEC	DE
		  DEFB	0C3h		;JP nn
		POP	HL
		CALL	CmpOutHL
		INC	HL
		INC	HL
		INC	HL
		JP	PatchIY

;'CASE'
CASEcc:		CALL	L5EBB
		LD	(L7B9C),A
		XOR	A
		LD	(L7B9B),A
		CALL	NeedOF
		LD	B,0
		PUSH	BC
L5531:		LD	B,1
L5533:		PUSH	BC
		LD	HL,L7B9B
		BIT	7,(HL)
		JR	Z,L5549
		CALL	CmpOutCopy
		  DEFB	1
		  ADD	HL,DE
		BIT	4,(HL)
		JR	Z,L5549
		CALL	CmpOutCopy
		  DEFB	1
		  ADD	HL,BC
L5549:		CALL	L69EA
		LD	A,(L7B9C)
		CP	B
		CALL	ErrIfNZero
		DEFB	46		;Constant and CASE selector type does not match
		CALL	CmpOutLDDE
		PUSH	HL
		CALL	CompareNam
		DEFW	DOTDOTnam
		POP	HL
		JR	NZ,L5582
		PUSH	HL
		CALL	L69EA
		LD	A,(L7B9C)
		CP	B
		CALL	ErrIfNZero
		DEFB	46		;Constant and CASE selector type does not match
		POP	DE
		OR	A
		SBC	HL,DE
		INC	HL
		CALL	CmpOutLDBC
		CALL	CmpOutCopy
		  DEFB	6
		  OR	A
		  SBC	HL,DE
		  OR	A
		  SBC	HL,BC
		LD	A,0DAh		;JP C,nn
		JR	L558B

L5582:		CALL	CmpOutCopy
		  DEFB	3
		  OR	A
		  SBC	HL,DE
		LD	A,0CAh		;JP Z,nn
L558B:		LD	(L7B9B),A
		CALL	ScanColon
		POP	BC
		JR	Z,L55A5
		LD	A,(L7B9B)
		CALL	CmpOutA
		PUSH	IY
		CALL	CmpOutHL
		CALL	NeedComma
		INC	B
		JR	L5533

L55A5:		PUSH	IY
		POP	DE
		INC	DE
		INC	DE
		INC	DE
L55AB:		DEC	B
		JR	Z,L55B4
		POP	HL
		CALL	PatchDE
		JR	L55AB

L55B4:		LD	A,(L7B9B)
		RES	3,A
		CALL	CmpOutA
		POP	BC
		PUSH	IY
		INC	B
		PUSH	BC
		CALL	CmpOutHL
		LD	A,(L7B9B)
		PUSH	AF
		LD	A,(L7B9C)
		PUSH	AF
		CALL	Statement
		POP	AF
		LD	(L7B9C),A
		POP	AF
		LD	(L7B9B),A
		CALL	ScanSemi
		LD	E,1
		JR	Z,L55DF
		DEC	E
L55DF:		PUSH	DE
		CALL	CompareNam
		DEFW	ENDnam
		POP	DE
		JR	Z,L561E
		CALL	CmpOutJPOP
		POP	BC
		POP	HL
		PUSH	IY
		PUSH	BC
		PUSH	DE
		CALL	CmpOutHL
		CALL	PatchIY
		CALL	CompareNam
		DEFW	ELSEnam
		POP	DE
		JR	Z,L560F
		DEC	E
		JP	Z,L5531
		LD	A,(L7B98)
		OR	A
		CALL	ErrIfZero
		DEFB	14		;END expected
		CALL	ErrAlways
		DEFB	41		;Unknown identifier or syntax error

L560F:		CALL	Statement
		CALL	CompareNam
		DEFW	ENDnam
		JR	Z,L561E
		CALL	L6F50
		JR	L560F

L561E:		POP	BC
L561F:		POP	HL
		CALL	PatchIY
		DJNZ	L561F
		RET

;'GOTO'
GOTOcc:		LD	BC,0100h
		CALL	ScanExistSym
		CALL	ErrIfNZero
		DEFB	40		;Undefined label
		LD	A,(L7B94)
		CP	(HL)
		CALL	ErrIfNZero
		DEFB	72		;Label not within current block
		EX	DE,HL
L5639:		CALL	WriteSymDE
		LD	A,(L7B95)
		CALL	WriteSymA
		CALL	CmpOutJPOP
		PUSH	IY
		POP	DE
		CALL	WriteSymDE
		JP	CmpOutHL

;'WITH'
WITHcc:		LD	A,(L7BC9)
		PUSH	AF
L5652:		LD	A,(L7BC6)
		LD	HL,L7BC9
		CP	(HL)
		CALL	ErrIfZero
		DEFB	97		;Too many nested WITHs
		CALL	L677F
		LD	A,(L7B5C)
		CP	2
		CALL	ErrIfNZero
		DEFB	29		;Record variable expected
		LD	HL,L7BC9
		LD	E,(HL)
		LD	D,0
		INC	(HL)
		LD	HL,L7BCC
		ADD	HL,DE
		LD	A,(L7B5D)
		LD	(HL),A
		LD	HL,(L7BCA)
		ADD	HL,DE
		ADD	HL,DE
		LD	A,22h		;LD (nn),HL
		CALL	CmpOutAHL
		CALL	ScanComma
		JR	Z,L5652
		CALL	CompareNam
		DEFW	DOnam
		CALL	ErrIfNZero
		DEFB	13		;DO expected
		CALL	Statement
		POP	AF
		LD	(L7BC9),A
		RET

;'INLINE'
INLINEcc:	CALL	NeedRundAuf
L569B:		LD	A,'>'
		CALL	ScanA
		LD	A,2		;word
		JR	Z,L56AE
		LD	A,'<'
		CALL	ScanA
		LD	A,1		;byte
		JR	Z,L56AE
		XOR	A		;according to value
L56AE:		LD	(L7BA6),A
		XOR	A
		LD	H,A
		LD	L,A
		LD	B,A
L56B5:		PUSH	BC
		PUSH	HL
		CALL	L6A0D
		JR	NZ,L56C5
		LD	A,B
		CP	10
		JR	Z,L5702
		CALL	ErrAlways
		DEFB	22		;Integer constant expected

L56C5:		LD	HL,L7BA6
		LD	A,(HL)
		OR	A
		JR	NZ,L56CE
		LD	(HL),2
L56CE:		LD	A,'*'
		CALL	ScanA
		JR	NZ,L56DA
		PUSH	IY
		POP	HL
		JR	L5702

L56DA:		LD	BC,0400h	;Variable
		CALL	ScanExistSym
		JR	NZ,L56EA
		CALL	L5276
		LD	HL,(L7B58)
		JR	L5702

L56EA:		LD	BC,0500h	;procedure
		CALL	ScanExistSym
		JR	Z,L56FC
		LD	BC,0600h	;function
		CALL	ScanExistSym
		CALL	ErrIfNZero
		DEFB	74		;INLINE error
L56FC:		DEC	HL
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
L5702:		POP	DE
		POP	BC
		DEC	B
		JR	NZ,L570A
		CALL	L6A30
L570A:		ADD	HL,DE
		LD	B,0
		LD	A,'+'
		CALL	ScanA
		JR	Z,L56B5
		INC	B
		LD	A,'-'
		CALL	ScanA
		JR	Z,L56B5
		LD	A,(L7BA6)
		CP	1
		JR	Z,L5729
		JR	NC,L572F
		INC	H
		DEC	H
		JR	NZ,L572F
L5729:		LD	A,L
		CALL	CmpOutA
		JR	L5732

L572F:		CALL	CmpOutHL
L5732:		LD	A,'/'
		CALL	ScanA
		JP	Z,L569B
		JP	NeedRundZu

L573D:		DEC	HL
		LD	B,(HL)
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		PUSH	DE
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		PUSH	DE
		DEC	HL
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		PUSH	DE
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		PUSH	DE
		INC	B
		DEC	B
		JP	Z,L57D6
		CALL	NeedRundAuf
L575E:		PUSH	BC
		LD	B,(HL)
		DEC	HL
		LD	A,(HL)
		DEC	HL
		LD	(L7B57),A
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		LD	C,B
L576B:		BIT	7,(HL)
		DEC	HL
		JR	Z,L576B
		DJNZ	L576B
		LD	B,C
		PUSH	HL
		EX	DE,HL
		CALL	L5287
L5778:		PUSH	BC
		LD	A,(L7B57)
		OR	A
		JR	NZ,L57A9
		LD	A,(L7B5C)
		CP	3
		JR	C,L57A1
		CALL	L5E84
		CALL	L5864
		LD	A,(L7B5C)
		CP	4
		JR	Z,L57BD
		CP	9
		JR	C,L57C0
		JR	NZ,L57BD
		CALL	CmpOutCopy
		  DEFB	2
		  PUSH	BC
		  PUSH	DE
		JR	L57BD

L57A1:		CALL	L6D2A
		CALL	L6749
		JR	L57AF

L57A9:		CALL	L6D2A
		CALL	L677F
L57AF:		CALL	L6D5D
		LD	A,(L7B69)
		CP	0
		CALL	NZ,L58C5
		CALL	L6D49
L57BD:		CALL	CmpOutPUSHHL
L57C0:		POP	BC
		DEC	B
		JR	Z,L57C9
		CALL	NeedComma
		JR	L5778

L57C9:		POP	HL
		POP	BC
		DEC	B
		JR	Z,L57D3
		CALL	NeedComma
		JR	L575E

L57D3:		CALL	NeedRundZu
L57D6:		POP	DE
		POP	HL
		LD	A,D
		OR	E
		JR	Z,L57E3
		CALL	CmpOutLDHL
		EX	DE,HL
		CALL	CmpOutLDDE
L57E3:		POP	DE
		POP	HL
		LD	A,0CDh		;CALL nn
		JP	CmpOutAHL

L57EA:		LD	A,(L7B5C)
		CP	0
		JR	Z,L57F9
		CP	5
		JR	C,L57FD
		CP	8
		JR	NC,L57FD
L57F9:		CALL	ErrAlways
		DEFB	54		;Illegal assignment

L57FD:		LD	A,(L7BBD)
		BIT	1,A
		JR	NZ,L5812
		BIT	0,A
		JR	Z,L580A
		LD	A,0FFh
L580A:		LD	HL,(L7BBE)
		LD	(L7B58),HL
		JR	L581A

L5812:		CALL	L678B
		CALL	CmpOutPUSHHL
		LD	A,1
L581A:		LD	(L7B57),A
		CALL	NeedAssign
		LD	A,(L7B5C)
		CP	3
		JP	NC,L593A
		CALL	L6D2A
		CALL	L6749
		CALL	L6D43
		CALL	L58C5
		LD	A,(L7B64)
		DEC	A
		JR	Z,L5852
		INC	A
		JR	Z,L5845
		CALL	CmpOutCopy
		  DEFB	2
		  DEFB	0EDh,5Bh	;LD DE,(nn)
		JR	L584A

L5845:		CALL	CmpOutCopy
		  DEFB	1
		  DEFB	11h		;LD DE,nn
L584A:		LD	HL,(L7B65)
		CALL	CmpOutHL
		JR	L5857

L5852:		CALL	CmpOutCopy
		  DEFB	1
		  POP	DE
L5857:		LD	HL,(L7B6F)
		CALL	CmpOutLDBC
		CALL	CmpOutCopy
		  DEFB	2
		  LDIR
		RET

L5864:		LD	A,(L7B5C)
		CP	9
		JR	NZ,L5877
		LD	A,B
		CP	10
		JR	NZ,L589D
		LD	B,9
		LD	HL,Int2Real
		JR	L589A

L5877:		CP	8
		JR	NZ,L588C
		LD	A,B
		CP	12
		JR	NZ,L589D
		LD	B,8
		CALL	CmpOutCopy
		  DEFB	4
		  LD	H,L
		  LD	L,1
		  PUSH	HL
		JR	L589D

L588C:		CP	12
		JR	NZ,L589D
		LD	A,B
		CP	8
		JR	NZ,L589D
		LD	B,12
		LD	HL,StrToChar
L589A:		CALL	CmpOutCALL
L589D:		LD	A,(L7B5C)
		CP	B
		JR	NZ,L58C1
		CP	3
		JR	NZ,L58B1
		LD	A,C
		OR	A
		RET	Z
		LD	HL,(L7B5E)
		CP	(HL)
		RET	Z
		JR	L58C1

L58B1:		CP	4
		RET	NZ
		LD	HL,(L7B8B)
		LD	A,H
		OR	L
		RET	Z
		LD	DE,(L7B5E)
		SBC	HL,DE
		RET	Z
L58C1:		CALL	ErrAlways
		DEFB	44		;Type mismatch

L58C5:		LD	A,(L7B5C)
		CP	0
		JR	Z,L591B
		LD	C,0BFh
		CP	10
		JR	NC,L5906
		LD	C,83h
		CP	8
		JR	NZ,L58E3
		LD	A,(WrkDirektiv)
		BIT	5,A
		JR	NZ,L5906
		LD	C,80h
		JR	L5906

L58E3:		CP	6
		JR	NC,L5906
		LD	C,0B3h
		CP	3
		JR	NC,L5906
		LD	C,0C3h
		CP	2
		JR	NC,L5906
		LD	HL,(L7B60)
		LD	A,H
		OR	L
		LD	C,0BFh
		JR	NZ,L5906
		LD	HL,(L7B6D)
		LD	A,(HL)
		CP	10
		JR	NZ,L591B
		LD	C,0B3h
L5906:		LD	HL,L7B5C
		LD	DE,L7B69
		LD	B,8
L590E:		RL	C
		JR	NC,L5916
		LD	A,(DE)
		CP	(HL)
		JR	NZ,L591B
L5916:		INC	HL
		INC	DE
		DJNZ	L590E
		RET

L591B:		CALL	ErrAlways
		DEFB	44		;Type mismatch

L591F:		LD	DE,-4
		ADD	HL,DE
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		PUSH	DE
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		LD	(L7B58),DE
		POP	HL
		CALL	L5287
		XOR	A
		LD	(L7B57),A
		CALL	NeedAssign
L593A:		CALL	L5E84
		CALL	L5864
		JP	L661B

;here: predefined precedures
;---------------------------

;'ASSIGN'
ASSIGNcc:	CALL	L5A0C
		LD	HL,AssignF
		CP	6		;text?
		JR	NZ,L5955	;no ->
		LD	HL,AssignT
		CALL	L5955
		JR	L5989

L5955:		PUSH	HL
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L5ED0
		POP	HL
L5960:		CALL	NeedRundZu
		JP	CmpOutCALL

;'RENAME'
RENAMEcc:	CALL	L5A0C
		LD	HL,Rename
		CALL	L5955
		JR	L5989

;'ERASE'
ERASEcc:	CALL	L5A0C
		LD	HL,Erase
		JR	L5960

;'CHAIN'
CHAINcc:	LD	HL,Chain
		JR	L5981

;'EXECUTE'
EXECUTEcc:	LD	HL,Execute
L5981:		PUSH	HL
		CALL	L5A0C
L5985:		POP	HL
L5986:		CALL	L5960
L5989:		JP	L5ABE

;'SEEK'
SEEKcc:		CALL	L5A0C
		CP	6		;text?
		CALL	ErrIfZero
		DEFB	63		;text files are not allowed here
		LD	HL,SeekFO
		CP	5		;file of?
		JR	Z,L599F
		LD	HL,SeekF
L599F:		PUSH	HL
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L5E97
		JR	L5985

;'FLUSH'
FLUSHcc:	CALL	L5A0C
		CP	5		;file of?
		CALL	ErrIfNZero
		DEFB	64		;text files and untyped files are not allowed here
		LD	HL,FlushFO
		JR	L5986

;'RESET'
RESETcc:	LD	HL,ResetTbl
		JR	L59C1

;'REWRITE'
REWRITEcc:	LD	HL,RewriteTbl
L59C1:		PUSH	HL
		CALL	L5A0C
		LD	A,(L7B5C)
		CP	5
		JR	NZ,L59D8
		LD	HL,(L7B5E)
		CALL	L5271
		LD	HL,(L7B6F)
		CALL	CmpOutLDDE
L59D8:		POP	HL
		JR	L59E1

;'CLOSE'
CLOSEcc:	CALL	L5A0C
		LD	HL,CloseTbl
L59E1:		CALL	NeedRundZu
		CALL	L59E9
		JR	L5989

L59E9:		LD	A,(L7B5C)
		SUB	5
		ADD	A,A
		LD	E,A
		LD	D,0
		ADD	HL,DE
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		EX	DE,HL
		JP	CmpOutCALL

ResetTbl:	DEFW	  ResetFO,   ResetT,   ResetF
RewriteTbl:	DEFW	RewriteFO, RewriteT, RewriteF
CloseTbl:	DEFW	  CloseFO,   CloseT,   CloseF

L5A0C:		CALL	NeedRundAuf
		CALL	L5A17
		RET	Z
		CALL	ErrAlways
		DEFB	21		;File variable expected

L5A17:		CALL	L67B2
L5A1A:		SCF
		RET	NZ		;Carry, NZero
		LD	A,(L7B5C)
		CP	5
		JR	C,L5A2F
		CP	8
		JR	NC,L5A2F
		CALL	L678B
		XOR	A		;set NCarry, Zero
		LD	A,(L7B5C)
		RET

L5A2F:		XOR	A
		DEC	A		;set NCarry, NZero
		RET

;END OF TP-C2.INC
;----------------
