;--------------------------------
;TP-C4.INC	ho	03-MAR-94
;--------------------------------
;64F2h-6C2Fh

		IDENT	TP-C4.INC

;'FILEPOS'
FILEPOScc:	LD	HL,FilePos
		LD	DE,FilePos
		JR	L6500

;'FILESIZE'
FILESIZEcc:	LD	HL,FileSizeHL
		LD	DE,FileSizeHL
L6500:		PUSH	HL
		PUSH	DE
		CALL	L65F7
		POP	DE
		POP	HL
		CP	6
		CALL	ErrIfZero
		DEFB	63		;Textfiles are not allowed here
		CP	5
		JR	Z,L64BF
		EX	DE,HL
		JR	L64BF

;'MEMAVAIL'
MEMAVAILcc:	LD	HL,MemAvail
		JR	L64BF

;'MAXAVAIL'
MAXAVAILcc:	LD	HL,MaxAvail
		JR	L64BF

;'BIOS' (procedure),'BIOSHL' (function)
BIOSHLcc:	DEFB	3Eh		;LD A,0AFh

;'BIOS' (function)
BIOScc:		XOR	A
		PUSH	AF
		CALL	NeedRundAuf
		CALL	L5E97
		CALL	CmpOutPUSHHL
		CALL	ScanComma
		JR	NZ,L6538
		CALL	L5E97
		CALL	CmpOutCopy
		  DEFB	2
		  LD	B,H
		  LD	C,L
L6538:		CALL	CmpOutCopy
		  DEFB	1
		  POP	DE
		LD	HL,Bios
L6540:		CALL	NeedRundZu
		CALL	CmpOutCALL
		POP	AF
		LD	B,10
		OR	A
		RET	NZ
	;extend A unsigned to integer (in HL)
		CALL	CmpOutCopy
		  DEFB	3
		  LD	L,A
		  LD	H,0
		RET

;'BDOS' (procedure),'BDOSHL' (function)
BDOSHLcc:	DEFB	3Eh		;LD A,0AFh

;'BDOS' (function)
BDOScc:		XOR	A
		PUSH	AF
		CALL	NeedRundAuf
		CALL	L5E97
		CALL	CmpOutPUSHHL
		CALL	ScanComma
		JR	NZ,L656C
		CALL	L5E97
		CALL	CmpOutCopy
		  DEFB	1
		  EX	DE,HL
L656C:		CALL	CmpOutCopy
		  DEFB	1
		  POP	BC
		LD	HL,BDOS
		JR	L6540

;'ADDR'
ADDRcc:		CALL	NeedRundAuf
		LD	BC,0500h
		CALL	ScanExistSym
		JR	Z,L6589
		LD	BC,0600h
		CALL	ScanExistSym
		JR	NZ,L6594
L6589:		DEC	HL
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
L658F:		CALL	CmpOutLDHL
		JR	L6597

L6594:		CALL	L677F
L6597:		CALL	NeedRundZu
		LD	B,10
		RET

;'SIZEOF'
SIZEOFcc:	CALL	NeedRundAuf
		LD	BC,0300h
		CALL	ScanExistSym
		JR	NZ,L65B1
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
		CALL	L5287
		JR	L65BA

L65B1:		PUSH	IY
		CALL	L677F
		POP	HL
		CALL	SeekObj
L65BA:		LD	HL,(L7B62)
		JR	L658F

;'PORT'
PORTcf:		CALL	L65D5
	;read from port array
		CALL	CmpOutCopy
		  DEFB	3
		  LD	C,L
		  IN	L,(C)
		RET

;'STACKPTR'
STACKPTRcf: ;get stackpointer into HL
		CALL	CmpOutCopy
		  DEFB	4
		  LD	HL,0
		  ADD	HL,SP
		LD	B,10
		RET

L65D5:		CALL	NeedEckAuf
		CALL	L5E97
		JP	NeedEckZu

L65DE:		CALL	NeedRundAuf
		CALL	L5E97
L65E4:		JP	NeedRundZu

L65E7:		CALL	NeedRundAuf
		CALL	L5EA2
		JR	L65E4

L65EF:		CALL	NeedRundAuf
		CALL	L5EBB
		JR	L65E4

L65F7:		CALL	ScanRundAuf
		JR	Z,L6608
		LD	HL,InputFIB
		CALL	CmpOutLDHL
		LD	A,6
		LD	(L7B5C),A
		RET

L6608:		CALL	L5A17
		CALL	ErrIfNZero
		DEFB	21		;File variable expected
		PUSH	AF
		CALL	NeedRundZu
		POP	AF
		RET

L6615:		DEFW	EndOfFileF
		DEFW	EndOfFileT
		DEFW	EndOfFileF

L661B:		LD	A,(L7B57)
		LD	C,A
		LD	HL,(L7B58)
		LD	A,(L7B5C)
		CP	3
		JR	NZ,L6634
		CALL	L6734
		LD	HL,StoreSetS
		LD	DE,StoreSet
		JR	L6648

L6634:		CP	8
		JR	NZ,L665E
		LD	A,(L7B62)
		DEC	A
		LD	H,A
		LD	L,6
		CALL	CmpOutHL
		LD	HL,StoreStringS
		LD	DE,StoreString
L6648:		DEC	C
		JR	Z,L665B
		EX	DE,HL
L664C:		LD	A,21h		;LD HL,nn
		INC	C
		JR	Z,L6653
		LD	A,2Ah		;LD HL,(nn)
L6653:		PUSH	HL
		LD	HL,(L7B58)
		CALL	CmpOutAHL
		POP	HL
L665B:		JP	CmpOutCALL

L665E:		CP	9
		JR	NZ,L6672
		CALL	CmpOutCopy
		  DEFB	1
		  EXX
		LD	HL,StoreReal
		DEC	C
		JR	NZ,L664C
		CALL	CmpOutPOPHL
		JR	L665B

L6672:		CP	4
		JR	Z,L669D
		LD	A,(WrkDirektiv)
		BIT	1,A
		JR	Z,L669D
		LD	HL,(L7B5E)
		LD	DE,(L7B60)
		INC	DE
		OR	A
		SBC	HL,DE
		ADD	HL,DE
		JR	Z,L669D
		DEC	DE
		CALL	CmpOutLDDE
		EX	DE,HL
		OR	A
		SBC	HL,DE
		INC	HL
		CALL	CmpOutLDBC
		LD	HL,SubrangeCheck
		CALL	CmpOutCALL
L669D:		DEC	C
		JR	NZ,L66B7
		CALL	CmpOutCopy
		  DEFB	2
		  EX	DE,HL
		  POP	HL
L66A6:		CALL	CmpOutCopy
		  DEFB	1
		  LD	(HL),E
		LD	A,(L7B62)
		DEC	A
		RET	Z
		CALL	CmpOutCopy
		  DEFB	2
		  INC	HL
		  LD	(HL),D
		RET

L66B7:		LD	HL,(L7B58)
		INC	C
		JR	NZ,L66CF
		LD	A,(L7B62)
		DEC	A
		LD	A,22h		;LD (nn),HL
		JR	NZ,L66CC
		CALL	CmpOutCopy
		  DEFB	1
		  LD	A,L
		LD	A,32h		;LD (nn),A
L66CC:		JP	CmpOutAHL

L66CF:		CALL	CmpOutCopy
		  DEFB	2
		  EX	DE,HL
		  DEFB	2Ah		;LD HL,(nn)
		CALL	CmpOutHL
		JR	L66A6

L66DA:		LD	A,(L7B5C)
		CP	10
		JR	NC,L6701
		CP	4
		JR	Z,L6701
		PUSH	AF
		CALL	L678B
		POP	AF
		LD	HL,LoadReal
		CP	9
		JR	Z,L66FE
		LD	HL,LoadString
		CP	8
		JR	Z,L66FE
		CALL	L6734
		LD	HL,LoadSet
L66FE:		JP	CmpOutCALL

L6701:		LD	A,(L7BBD)
		OR	A
		JR	NZ,L671B
		LD	A,2Ah		;LD HL,(nn)
		LD	HL,(L7BBE)
		CALL	CmpOutAHL
		LD	A,(L7B62)
		DEC	A
		RET	NZ
L6714:		CALL	CmpOutCopy
		  DEFB	2
		  LD	H,0
		RET

L671B:		CALL	L678B
		LD	A,(L7B62)
		DEC	A
		JR	NZ,L672B
		CALL	CmpOutCopy
		  DEFB	1
		  LD	L,(HL)
		JR	L6714

L672B:		CALL	CmpOutCopy
		  DEFB	4
		  LD	E,(HL)
		  INC	HL
		  LD	D,(HL)
		  EX	DE,HL
		RET

L6734:		LD	HL,(L7B5E)
		CALL	L5271
		LD	HL,(L7B62)
		LD	A,(L7B6B)
		RRA
		RRA
		RRA
		AND	1Fh
		LD	H,A
		JP	CmpOutLDBC

L6749:		CALL	L6A0D
		JR	NZ,L677F
		LD	A,B
		CP	8
		CALL	ErrIfNZero
		DEFB	60		;Constants are not allowed here
		LD	L,18h		;JR nn
		LD	H,C		;string length
		CALL	CmpOutHL
		LD	(L7B58),IY
		LD	A,1
		LD	(L7B5C),A
		LD	HL,CharTyp
		LD	(L7B5E),HL
		LD	HL,0
		LD	(L7B60),HL
		LD	L,C		;H=0
		LD	(L7B62),HL
		CALL	CmpOutChrArr
		LD	A,21h		;LD HL,nn
		LD	HL,(L7B58)
		JP	CmpOutAHL

L677F:		CALL	L6787
		RET	Z
		CALL	ErrAlways
		DEFB	41		;Unknown identifier or syntax error

L6787:		CALL	L67B2
		RET	NZ
L678B:		LD	A,(L7BBD)
		LD	HL,(L7BBE)
		BIT	1,A
		JR	NZ,L67A2
		BIT	0,A
		LD	A,21h		;LD HL,nn
		JR	Z,L679D
		LD	A,2Ah		;LD HL,(nn)
L679D:		CALL	CmpOutAHL
		JR	L67B0

L67A2:		BIT	0,A
		JR	NZ,L67B0
		LD	A,11h		;LD DE,nn
		CALL	CmpOutAHL
		CALL	CmpOutCopy
		  DEFB	1
		  ADD	HL,DE
L67B0:		XOR	A
		RET

L67B2:		CALL	L680C
		JR	Z,L67D9
		LD	BC,0400h
		CALL	ScanExistSym
		JR	NZ,L67ED
		CALL	L5276
		LD	A,(L7B57)
		OR	A
		LD	A,21h		;LD HL,nn
		LD	B,0
		JR	Z,L67CF
		LD	A,2Ah		;LD HL,(nn)
		INC	B
L67CF:		LD	HL,L7BBD
		LD	(HL),B
		LD	HL,(L7B58)
		LD	(L7BBE),HL
L67D9:		CALL	L683A
		JR	Z,L67D9
		CALL	L6931
		JR	Z,L67D9
		CALL	L6974
		JR	Z,L67D9
		CALL	L699F
		XOR	A
		RET

L67ED:		CALL	CompareNam
		DEFW	MEMnam
		RET	NZ
		CALL	L65D5
		LD	A,10		;type = int (byte = subrange)
		LD	(L7B5C),A
		LD	HL,1
		LD	(L7B62),HL	;size of entry
		DEC	L		;=0000h subrange 0-255 (byte)
		LD	(L7B5E),HL
		DEC	L		;=00FFh
		LD	(L7B60),HL
		JP	L6903

L680C:		LD	A,(L7BC9)
		LD	B,A
L6810:		DEC	B
		RET	M
		PUSH	BC
		LD	E,B
		LD	D,0
		LD	HL,L7BCC
		ADD	HL,DE
		LD	A,(HL)
		LD	C,A
		LD	B,4
		CALL	ScanExistSym
		POP	BC
		JR	NZ,L6810
		PUSH	HL
		LD	A,B
		ADD	A,A
		LD	E,A
		LD	D,0
		LD	HL,(L7BCA)
		ADD	HL,DE
		LD	(L7BBE),HL
		LD	HL,L7BBD
		LD	(HL),1
		POP	HL
		JP	L6948

L683A:		LD	A,(L7B5C)
		CP	1
		RET	NZ
		CALL	ScanEckAuf
		RET	NZ
		CALL	L678B
L6847:		CALL	CmpOutPUSHHL
		CALL	L5E84
		LD	HL,(L7B60)
		CALL	L5271
		LD	A,(L7B69)
		CP	B
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
	;up to 3 times INC/DEC HL, else LD DE,xx/ADD HL,DE
		LD	HL,(L7B6B)
		LD	A,H
		OR	A
		JR	NZ,L6874
		LD	A,L
		CP	4
		JR	NC,L6888
L6867:		OR	A
		JR	Z,L6893
		PUSH	AF
		CALL	CmpOutCopy
		  DEFB	1
		  DEC	HL
		POP	AF
		DEC	A
		JR	L6867

L6874:		INC	A
		JR	NZ,L6888
		LD	A,L
		CP	-3
		JR	C,L6888
L687C:		PUSH	AF
		CALL	CmpOutCopy
		  DEFB	1
		  INC	HL
		POP	AF
		INC	A
		JR	NZ,L687C
		JR	L6893

L6888:		CALL	L6A30
		CALL	CmpOutLDDE
		CALL	CmpOutCopy
		  DEFB	1
		  ADD	HL,DE
L6893:		LD	A,(WrkDirektiv)
		BIT	1,A
		JR	Z,L68AE
		LD	HL,(L7B6D)
		LD	DE,(L7B6B)
		OR	A
		SBC	HL,DE
		INC	HL
		CALL	CmpOutLDDE
		LD	HL,IndexCheck
		CALL	CmpOutCALL
L68AE:		LD	HL,(L7B5E)
		CALL	L5287
		LD	HL,(L7B62)	;size of entry
		LD	A,H
		OR	A		;>255?
		JR	NZ,L68D8	;yes -> then we have to multiply
		LD	A,L
		DEC	A		;=1?
		JR	Z,L68ED		;yes -> add only
		DEC	A		;=2?
		JR	NZ,L68C9	;no -> continue
	;special case x2 (e.g. integer)
		CALL	CmpOutCopy
		  DEFB	1
		  ADD	HL,HL
		JR	L68ED

L68C9:		CP	4		;=6?
		JR	NZ,L68D8	;no -> then multiply
	;special case x6 (e.g. real)
		CALL	CmpOutCopy
		  DEFB	5
		  ADD	HL,HL
		  LD	E,L
		  LD	D,H
		  ADD	HL,HL
		  ADD	HL,DE
		JR	L68ED

L68D8:	;HL= size of entry
		LD	A,(WrkDirektiv)
		BIT	4,A		;directive X?
		JR	NZ,L68EA	;yes -> max. speed (sacrificing memory)
	;minimum memory consumption (sacrificing speed)
		CALL	CmpOutLDDE
		LD	HL,MultInt
		CALL	CmpOutCALL
		JR	L68ED

L68EA:		CALL	L690A
L68ED:	;add to base address
		CALL	CmpOutCopy
		  DEFB	2
		  POP	DE
		  ADD	HL,DE
		LD	A,(L7B5C)
		CP	1
		JR	NZ,L6900
		CALL	ScanComma
		JP	Z,L6847
L6900:		CALL	NeedEckZu
L6903:		LD	A,3
		LD	(L7BBD),A
		XOR	A
		RET

;generate code for multiplication with constant
L690A:		LD	B,1
L690C:		LD	A,H
		OR	A
		JR	NZ,L6914
		LD	A,L
		DEC	A
		JR	Z,L6927
L6914:		BIT	0,L
		JR	Z,L691C
		CALL	CmpOutPUSHHL
		INC	B
L691C:		CALL	CmpOutCopy
		  DEFB	1
		  ADD	HL,HL
		SRL	H
		RR	L
		JR	L690C

L6927:		DEC	B
		RET	Z
		CALL	CmpOutCopy
		  DEFB	2
		  POP	DE
		  ADD	HL,DE
		JR	L6927


L6931:		LD	A,(L7B5C)
		CP	2
		RET	NZ
		CALL	ScanDot
		RET	NZ
		LD	A,(L7B5D)
		LD	C,A
		LD	B,4
		CALL	ScanExistSym
		CALL	ErrIfNZero
		DEFB	41		;Unknown identifier or syntax error
L6948:		CALL	L5276
		LD	HL,(L7B58)
		LD	A,H
		OR	L
		RET	Z
		LD	HL,L7BBD
		BIT	0,(HL)
		JR	Z,L6967
		PUSH	HL
		CALL	L678B
		POP	HL
		LD	(HL),2
		LD	HL,(L7B58)
		LD	(L7BBE),HL
		XOR	A
		RET

L6967:		LD	HL,(L7BBE)
		LD	DE,(L7B58)
		ADD	HL,DE
		LD	(L7BBE),HL
		XOR	A
		RET

L6974:		LD	A,(L7B5C)
		CP	4
		RET	NZ
		CALL	ScanCaret
		RET	NZ
		LD	HL,L7BBD
		LD	A,(HL)
		OR	A
		JR	NZ,L6988
		INC	(HL)
		JR	L6997

L6988:		PUSH	HL
		CALL	L678B
		POP	HL
		LD	(HL),3
		CALL	CmpOutCopy
		  DEFB	4
		  LD	E,(HL)
		  INC	HL
		  LD	D,(HL)
		  EX	DE,HL
L6997:		LD	HL,(L7B5E)
		CALL	L5287
		XOR	A
		RET

L699F:		LD	A,(L7B5C)
		CP	8
		RET	NZ
		CALL	ScanEckAuf
		RET	NZ
		CALL	L678B
		CALL	CmpOutPUSHHL
		LD	HL,(L7B62)
		PUSH	HL
		CALL	L5E97
		POP	HL
		LD	A,(WrkDirektiv)
		BIT	1,A
		JR	Z,L69C7
		CALL	CmpOutLDDE
		LD	HL,IndexCheck
		CALL	CmpOutCALL
L69C7:		CALL	CmpOutCopy
		  DEFB	2
		  POP	DE
		  ADD	HL,DE
		CALL	NeedEckZu
		LD	A,12		;type = char
		LD	(L7B5C),A
		LD	HL,1		;size of an entry
		LD	(L7B62),HL
		DEC	HL		;DEC L would have sufficed =0000
		LD	(L7B5E),HL
		DEC	L		;=00FFh
		LD	(L7B60),HL
		LD	A,3
		LD	(L7BBD),A
		XOR	A
		RET

L69EA:		CALL	L6A0D
		RET	Z
		CALL	ErrAlways
		DEFB	41		;Unknown identifier or syntax error

L69F2:		CALL	L69EA
		LD	A,B
		CP	10		;Int
		RET	Z
		CALL	ErrAlways
		DEFB	22		;Integer constant expected

L69FD:		CALL	L69EA
		LD	A,B
		CP	8		;String
		RET	Z
		CP	12		;Char
		CALL	ErrIfNZero
		DEFB	32		;String constant expected
		LD	B,8		;Character constant -> String con.
		RET

;R: <no return> if sign given but not allowed with this type,
;   or if neither constant nor sign given
;   else: E=0 and Zero if + (else E=-2 and Nzero)
L6A0D:		CALL	L6A39		;scan sign
		PUSH	DE
		CALL	L6A5C		;search constant
		POP	DE
		JR	Z,L6A1F		;found. Negate value according to sign
	;didn't find constant
		INC	E
		DEC	E		;sign was given?
		CALL	ErrIfNZero	;no -> error
		DEFB	25		;Integer or real constant expected
		DEC	E
		RET

;negate according to sign
;E: sign flag in E, type in B
;   when integer: value in HL, when real: value in BCDEHL'
;V: AF, E, HL, B'
;R: <no return> if sign given but not allowed with this type
;   else: E=0 and Zero if + or no sign (else E=-2 and Nzero)
;   value in HL or BCDEHL' resp. negated if negative sign
L6A1F:		CALL	L6A4A		;flip sign?
		RET	Z		;no -> do nothing
		LD	A,B
		CP	9
		JR	NZ,L6A30
	;negate real
		EXX
		LD	A,B		;flip sign
		XOR	80h
		LD	B,A
		EXX
		XOR	A
		RET

;negate integer (HL := 0-HL)
;E: HL / V: AF, HL / R: HL, A=0 and NCarry,Zero
L6A30:		LD	A,H
		CPL
		LD	H,A
		LD	A,L
		CPL
		LD	L,A
		INC	HL
		XOR	A
		RET

;scan sign
;V: AF, E, IX
;R: E=0 no sign, E=-1 stands for '-', E=1 for '+'
L6A39:		LD	E,-1
		LD	A,(IX)
		CP	'-'
		JR	Z,L6A47
		INC	E		;=0
		CP	'+'
		RET	NZ
		INC	E		;=1
L6A47:		JP	InpScanSpace

;look if we have to flip sign
;E: sign flag in E, type in B
;V: AF, E
;R: <no return> if sign given but not allowed with this type
;   else: E=0 and Zero if + or no sign (else E=-2 and Nzero)
L6A4A:		INC	E
		DEC	E		;sign?
		RET	Z		;no -> do nothing
		LD	A,B		;sign only allowed
		CP	10		;with integer or real
		JR	Z,L6A56
		CP	9
		JR	NZ,L6A58
L6A56:		DEC	E		;+ = 0, - =-2
		RET

L6A58:		CALL	ErrAlways
		DEFB	25		;Integer or real constant expected

;search constant (return type and value)
;E:- / V: AF, BC, DE, HL (IX advanced)
;R: NZero if nothing valid found, else
;   A=0 and Zero if ok and
;	B=8:  string length in C, string starts L7A57
;	B=9:  real number in BCDEHL'
;	B=10: integer number in HL
;	B=12: character unsigned extended in HL
L6A5C:		CALL	ScanUnsConst	;scan unsigned constant
		RET	Z		;return if ok
	;search constant
		LD	BC,0200h
		CALL	ScanExistSym
		RET	NZ
		LD	B,(HL)		;get type
		LD	A,B
		DEC	HL
		CP	10		;integer or character?
		JR	C,L6A74		;no, continue
	;return integer value in HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		EX	DE,HL
		XOR	A
		RET

L6A74:		CP	9		;real?
		JR	NZ,L6A88	;no, continue
	;return real value in BCDEHL'
		PUSH	BC		;save type
		LD	B,(HL)
		DEC	HL
		LD	C,(HL)
		DEC	HL
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		DEC	HL
		LD	A,(HL)
		DEC	HL
		LD	L,(HL)
		LD	H,A
		EXX
		POP	BC		;restore type
		RET

L6A88:	;copy other constant
		LD	C,(HL)		;get length
		LD	DE,L7A57
		PUSH	BC		;save type and length
		INC	C
L6A8E:		DEC	C
		JR	Z,L6A97
		DEC	HL
		LD	A,(HL)
		LD	(DE),A
		INC	DE
		JR	L6A8E

L6A97:		POP	BC
		RET

;scan unsigned constant (character, string, integer, real)
;E:- / V: AF, BC, DE, HL (IX advanced)
;R: A=-1 and NZero if nothing valid found, else
;   A=0 and Zero if ok and
;	B=8:  string length in C, string starts L7A57
;	B=9:  real number in BCDEHL'
;	B=10: integer number in HL
;	B=12: character unsigned extended in HL
ScanUnsConst: ;character or string constant?
		LD	A,(IX)		;has to begin with ' or ^ or #
		CP	''''
		JR	Z,ScanUnCo1
		CP	'^'
		JR	Z,ScanUnCo1
		CP	'#'
		JR	NZ,ScanUnCo10
ScanUnCo1: ;char/string constant.
	;Consists of a non-empty series of string elements (which
	;are: control characters of the form ^x, ascii codes of the
	;form #number and simple strings of the form 'xx')
		LD	HL,L7A57	;buffer
		LD	C,0		;string length
ScanUnCo2: ;next string element
		LD	A,(IX)
		CP	'^'		;control char?
		JR	Z,ScanUnCo5
		CP	'#'		;ascii code?
		JR	Z,ScanUnCo7
		CP	''''		;simple string?
		JR	NZ,ScanUnCo8	;no -> string finished
ScanUnCo3: ;simple string
		INC	IX
		LD	A,(IX)
		OR	A		;end of line?
		CALL	ErrIfZero
		DEFB	55		;String constant exceeds line
		CP	''''		;'?
		JR	NZ,ScanUnCo4	;no -> copy
		INC	IX
		LD	A,(IX)		;another '?
		CP	''''
		JR	NZ,ScanUnCo2	;no -> then end of simple string
ScanUnCo4: ;store char, continue simple string
		LD	(HL),A
		INC	HL
		INC	C
		JR	ScanUnCo3

ScanUnCo5: ;control char
	;(method is a bit complicated: first it is converted to
	;upper case and then XOR 40h. AND 1Fh would have been faster!)
		INC	IX
		LD	A,(IX)
		CALL	ToUpper
		OR	A		;end of line?
		CALL	ErrIfZero
		DEFB	55		;String constant exceeds line
		XOR	40h		;convert to control char
		INC	IX
ScanUnCo6: ;store char, end of string element
		LD	(HL),A
		INC	HL
		INC	C
		JR	ScanUnCo2

ScanUnCo7: ;ascii code
		INC	IX
		PUSH	BC
		PUSH	HL
		CALL	AtoI
		LD	A,L		;ignore HighByte
		POP	HL
		POP	BC
		CALL	ErrIfCarry
		DEFB	56		;Error in integer constant
		JR	ScanUnCo6

ScanUnCo8: ;end of string
		LD	B,8
		LD	A,C
		DEC	A		;length =1?
		JR	NZ,ScanUnCo9	;no -> string constant
	;character constant
		LD	H,A		;=0
		LD	A,(L7A57)
		LD	L,A		;return unsigned extended in HL
		LD	B,12
ScanUnCo9: ;end of constant
		JP	ScanSpace	;skip spaces/comments

ScanUnCo10: ;no character/string constant
	;look if integer or real constant
		CP	'$'		;hex number only allowed for integer
		JR	Z,ScanUnCo14
		CALL	IsNumber	;decimal digit?
		JR	NC,ScanUnCo11
	;no constant detected!
		XOR	A
		DEC	A		;A := -1, NZero
		RET

ScanUnCo11: ;no hex number. Look if integer or real constant
		PUSH	IX
		POP	DE
ScanUnCo12:	INC	DE		;scan number
		LD	A,(DE)
		CALL	IsNumber
		JR	NC,ScanUnCo12
		CALL	ToUpper
		CP	'E'		;E following?
		JR	Z,ScanUnCo13	;yes -> then it must be real
		CP	'.'		;. following?
		JR	NZ,ScanUnCo14	;no -> then it must be integer
		INC	DE		;normally we have a real here, but
		LD	A,(DE)		;we have two special cases:
		CP	'.'		;does a . follow after the .?
		JR	Z,ScanUnCo14	;yes -> then it is an integer!
		CP	')'		;same with )
		JR	Z,ScanUnCo14
ScanUnCo13: ;real constant
		CALL	AtoR
		CALL	ErrIfCarry
		DEFB	57		;Error in real constant
		EXX
		LD	B,9
		JR	ScanUnCo9

ScanUnCo14: ;integer constant
		CALL	AtoI
		CALL	ErrIfCarry
		DEFB	56		;Error in integer constant
		LD	B,10
		JR	ScanUnCo9

;issue series of bytes
;E: length of the series is directly behind the subroutine call,
;   the series of bytes follows directly behind
CmpOutCopy:	EX	(SP),HL
		PUSH	BC
		LD	B,(HL)
		INC	HL
CmpOutCo1:	LD	A,(HL)
		CALL	CmpOutA
		INC	HL
		DJNZ	CmpOutCo1
		POP	BC
		EX	(SP),HL
		RET

;issue string with length
;E: length in C, string starts 7A57h
CmpOutString:	LD	A,C
		CALL	CmpOutA

;issue string without length (array of character)
;E: string starts 7A57h
CmpOutChrArr:	LD	HL,L7A57
		INC	C
CmpOutChrA1:	DEC	C
		RET	Z
		LD	A,(HL)
		INC	HL
		CALL	CmpOutA
		JR	CmpOutChrA1

;issue opcode PUSH HL
CmpOutPUSHHL:	LD	A,0E5h		;PUSH HL
		JR	CmpOutA

;issue opcode POP HL
CmpOutPOPHL:	LD	A,0E1h		;POP HL
		JR	CmpOutA

;issue opcode JP nn (without the nn)
CmpOutJPOP:	LD	A,0C3h		;JP nn
		JR	CmpOutA

;issue DE to object (file), LowByte first
;E: DE
CmpOutDE:	LD	A,E
		CALL	CmpOutA
		LD	A,D
		JR	CmpOutA

;issue opcode JP nn
;E: nn in HL
CmpOutJP:	LD	A,0C3h		;JP nn
		JR	CmpOutAHL

;issue opcode CALL nn
;E: nn in HL
CmpOutCALL:	LD	A,0CDh		;CALL nn
		JR	CmpOutAHL

;issue opcode LD BC,nn
;E: nn in HL
CmpOutLDBC:	LD	A,01h		;LD BC,nn
		JR	CmpOutAHL

;issue opcode LD DE,nn
;E: nn in HL
CmpOutLDDE:	LD	A,11h		;LD DE,nn
		JR	CmpOutAHL

;issue opcode LD HL,nn
;E: nn in HL
CmpOutLDHL:	LD	A,21h		;LD HL,nn
;<fall through>

;issue A and then HL to object
;E: A, HL
CmpOutAHL:	CALL	CmpOutA
;<fall through>

;issue HL to object (file), LowByte first
;E: HL
CmpOutHL:	LD	A,L
		CALL	CmpOutA
		LD	A,H
;<fall through>

;issue one byte to object (file)
;E: byte in A, destination PC in IY
;V: AF / R: IY advanced
CmpOutA:	PUSH	BC
		LD	B,A		;sabe byte
		LD	A,(CCmpZiel)
		OR	A		;destination = memory?
		JR	NZ,CmpOutA1	;no -> don't store
		LD	(IY),B		;store
CmpOutA1:	INC	IY		;increase PC
		OR	A		;destination = memory?
		JR	Z,CmpOutA4	;yes -> 
		PUSH	HL
		PUSH	DE
		DEC	A		;destination = file?
		JR	Z,CmpOutA2	;yes ->
	;search error
		PUSH	IY		;get PC
		POP	DE
		DEC	DE
		LD	HL,(RelErrPos)
		OR	A
		SBC	HL,DE		;equal?
		CALL	ErrIfZero
		DEFB	200		;0C8h
		JR	CmpOutA3

CmpOutA2: ;output to file
		CALL	ObjOut
CmpOutA3:	POP	DE
		POP	HL
CmpOutA4:	POP	BC
;<fall through>

;look if we have an overflow somewhere
ChkCOverflow:	PUSH	HL
		PUSH	DE
		PUSH	IY		;get PC
		POP	DE
		LD	A,(CCmpZiel)	;destination = memory?
		OR	A
		JR	Z,ChkCOverf1	;yes ->
		LD	DE,(PatchList)
		DEC	A		;destination = file?
		JR	NZ,ChkCOverf1	;no ->
		LD	DE,(L7BE1)
		LD	A,(CInclude)
		OR	A
		JR	Z,ChkCOverf1
		LD	DE,(InclBufEnd)
ChkCOverf1:	LD	HL,(TmpSymStart)
		SCF
		SBC	HL,DE
		CALL	ErrIfCarry
		DEFB	99		;Compiler Overflow
		PUSH	IY		;get PC
		POP	DE
		LD	HL,(CDatStart)
		DEC	H
		DEC	H
		SBC	HL,DE
		CALL	ErrIfCarry
		DEFB	98		;Memory Overflow
		POP	DE
		POP	HL
		RET

;write byte to object file
;E: byte in A
ObjOut:		LD	HL,ObjSecFlags
		SET	1,(HL)		;have to write back that sector later
		BIT	0,(HL)		;need to read it in first?
		JR	Z,ObjOut1	;no, continue
	;read in sector
		RES	0,(HL)
		PUSH	BC
		CALL	ReadObjSec
		POP	BC
ObjOut1: ;store byte in sector buffer
		LD	A,(ObjSecPtr)
		LD	E,A
		LD	D,0
		LD	HL,SecBuf
		ADD	HL,DE
		LD	(HL),B
		INC	A		;increase counter. <128 (SecSize)?
		JP	P,ObjOut2	;yes -> sector not yet full
	;write back sector
		CALL	WriteObjSec
		LD	HL,(ObjFCB+33)
		INC	HL
		LD	(ObjFCB+33),HL
		XOR	A
ObjOut2:	LD	(ObjSecPtr),A
		RET

;END OF TP-C4.INC
;----------------
