;--------------------------------
;TP-ME3.INC	ho	03-MAR-94
;--------------------------------
;V2.00: 3409h-417Eh
;V3.00: 34EDh-429Dh	V3.01: 34CFh-427Fh

		IDENT	TP-ME3.INC

;Write block to disk
ECmd37:		BIT	0,(IY+20)
		RET	NZ
		CALL	L3E40
		CALL	ECmd41		;Restore line
		LD	HL,(L4460)
		LD	DE,(L4462)
		CALL	L3BE2
		RET	NC
		CALL	L363C
		CALL	ECmd41		;Restore line
L3509:		CALL	L3E04
		DEFB	'Write block to file',0
		CALL	L3566
		RET	Z
		CALL	ParsePAS
		LD	C,OpenFile
		CALL	DefSBDOS
		INC	A
		JR	Z,L3551
		CALL	L3E07
		DEFB	'Overwrite old ',0
		LD	DE,DefaultFCB
		CALL	PrintFName
		CALL	YesNo
		JR	Z,L3509
		LD	C,DeleteFile
		CALL	DefSBDOS
L3551:		LD	HL,(L4462)
		LD	A,(HL)
		PUSH	AF
		PUSH	HL
		LD	(HL),EOF
		CALL	L3E0D
		LD	HL,(L4460)
		CALL	MSave1
		POP	HL
		POP	AF
		LD	(HL),A
		RET

L3566:		LD	DE,L44DF
		CALL	L313B
		LD	DE,L44E1
		LD	A,(DE)
		CP	EOF
		RET

;Read block from disk
ECmd36:		CALL	L3E04
		DEFB	'Read block from file',0
		CALL	L3566
		RET	Z
		CALL	ParsePAS
		LD	C,OpenFile
		CALL	DefSBDOS
		INC	A
		JR	NZ,L35A8
		CALL	L3E0D
		LD	DE,DefaultFCB
		CALL	L2E3E
		CALL	L3F12
		JR	ECmd36

L35A8:		RES	0,(IY+20)	;=4480h
		CALL	L363C
		LD	HL,(TextEnd)
		LD	DE,(MaxMem)
		LD	BC,00FEh
		ADD	HL,BC
		OR	A
		SBC	HL,DE
		PUSH	HL
		LD	B,H
		LD	C,L
		LD	HL,(L448C)
		SCF
		CALL	L3F18
		POP	DE
		LD	HL,L35DD
		PUSH	HL
		LD	HL,(L448C)
		PUSH	HL
		XOR	A
		SBC	HL,DE
		PUSH	HL
		LD	HL,L35F1
		LD	(TooBigJp+1),HL
		JP	ReadFile1

L35DD:		LD	(L4462),HL
		EX	DE,HL
		LD	HL,(L448C)
		LD	(L4460),HL
L35E7:		LD	HL,(L7B6D)
		OR	A
		SBC	HL,DE
		LD	B,H
		LD	C,L
		JR	L3612

L35F1:		LD	DE,(L448C)
		CALL	L35E7
		JP	L3ED9

;Move block
ECmd34:		CALL	L363C
		JP	NC,ECmd41	;Restore line
		CALL	L3687
		LD	HL,(L448C)
		LD	DE,(L4460)
		LD	(L4460),HL
		ADD	HL,BC
		LD	(L4462),HL
L3612:		EX	DE,HL
		OR	A
		CALL	L3F18
IF TPVers2
		JR	L3633
ELSE
		LD	HL,(L4460)
		CALL	L33A9
		JP	L3762
ENDIF

;Copy block
ECmd33:		CALL	L363C
		JP	NC,ECmd41	;Restore line
		CALL	L3687
		LD	HL,(L448C)
		LD	(L4460),HL
		ADD	HL,BC
		LD	(L4462),HL
L3633:		CALL	L401F
		CALL	ECmd41		;Restore line
		JP	L3762

L363C:		BIT	0,(IY+20)
		JR	Z,L3644
		XOR	A
		RET

L3644:		CALL	L3E23
		INC	HL
		LD	DE,(L4452)
		PUSH	DE
		CALL	L4191
		EX	DE,HL
		CALL	L3E44
		POP	HL
		LD	DE,L7B74
		OR	A
		SBC	HL,DE
		LD	DE,(L4450)
		ADD	HL,DE
		LD	(L448C),HL
		PUSH	HL
		LD	DE,(L4460)
		INC	DE
		CALL	L3BE2
		LD	DE,(L4462)
		JR	C,L367A
		CALL	L3BE2
		JR	NC,L367A
		OR	A
		JR	L3685

L367A:		LD	HL,(L4460)
		OR	A
		SBC	HL,DE
		LD	(L448E),HL
		LD	C,L
		LD	B,H
L3685:		POP	HL
		RET

L3687:		CALL	L3F18
		LD	BC,(L448E)
		LD	A,C
		CPL
		LD	C,A
		LD	A,B
		CPL
		LD	B,A
		INC	BC
		LD	DE,(L448C)
		LD	HL,(L4460)
		PUSH	BC
		LDIR
		POP	BC
		RET

;Delete block
ECmd35:		BIT	0,(IY+20)
		RET	NZ
		CALL	L3E40
		LD	HL,(L4460)
		CALL	L3BF5
		LD	(L4450),HL
		LD	HL,(L4454)
		LD	DE,(L4460)
		INC	DE
		CALL	L3BE2
		JR	C,L36CE
		LD	DE,(L4462)
		CALL	L3BE2
		JR	NC,L36CE
		LD	HL,(L4450)
		LD	(L4454),HL
L36CE:		LD	HL,(L4462)
		LD	DE,(L4460)
		OR	A
		SBC	HL,DE
		JP	C,ECmd41	;Restore line
		LD	C,L
		LD	B,H
		EX	DE,HL
		PUSH	HL
		PUSH	BC
		PUSH	AF
		CALL	L401F
		POP	AF
		POP	BC
		POP	HL
		CALL	L3F18
		LD	HL,(L4450)
		LD	(L4460),HL
		LD	(L4462),HL
		CALL	ECmd41		;Restore line
		JP	L3762

;Hide/display block
ECmd32:		LD	HL,L4480
		CALL	L3796
		JP	L3762

;Mark block end
ECmd30:
IF TPVers2
		RES	0,(IY+20)
ENDIF
		LD	HL,(L4452)
		LD	(L4466),HL
		LD	HL,(L4450)
		LD	(L4462),HL
		BIT	1,(IY+01)	;=446Dh
		SET	1,(IY+01)
IF TPVers2
		JR	Z,L3762
		JR	L374E
ELSE
L3716:		EX	AF,AF'
		BIT	0,(IY+20)
		RES	0,(IY+20)
		JR	NZ,L3762
		EX	AF,AF'
		JR	Z,L3762
		JR	L374E
ENDIF

;Mark block begin
ECmd29:
IF TPVers2
		RES	0,(IY+20)
ENDIF
		LD	HL,(L4452)
		LD	(L4464),HL
		LD	HL,(L4450)
		LD	(L4460),HL
		BIT	0,(IY+01)
		SET	0,(IY+01)
IF TPVers2
		JR	Z,L3762
		JR	L374E
ELSE
		JR	L3716
ENDIF

;To begining of block
ECmd18:		CALL	L3E40
		LD	HL,(L4460)
		JP	L33A9

;To end of block
ECmd19:		CALL	L3E40
		LD	HL,(L4462)
		JP	L33A9

L374E:		LD	H,0
		CALL	L37A7
		LD	HL,L7B74
		SET	0,(IY+16)	;=447Ch
		CALL	L3C1A
		RES	0,(IY+16)
		RET

L3762:		CALL	L374E
		JP	L4147

;To end of file
ECmd17:		CALL	L3E40
		LD	HL,(TextEnd)
		JP	L33A9

;To left on line
ECmd12:		LD	HL,L7B74
		LD	(L4452),HL
		JP	L3FE7

;To right on line
ECmd13:		CALL	L3E23
		INC	HL
		LD	DE,L7BF3
		CALL	L3BE2
		JR	C,L3789
		LD	HL,L7BF2
L3789:		LD	(L4452),HL
		JP	L3FE7

;Insert mode on/off
ECmd21:		LD	(IY+08),0	;=4474h
		LD	HL,L4472
L3796:		LD	A,(HL)
		XOR	1
		LD	(HL),A
		RET

;Auto tab on/off
ECmd40:		LD	(IY+08),0
		LD	HL,L4479
		JR	L3796

L37A4:		LD	H,(IY+04)
L37A7:		LD	L,(IY+05)
		JP	CsrXY

;Line down
ECmd07:		LD	HL,(L4450)
		CALL	L41B1
		RET	C
		CALL	L3E40
		LD	HL,(L4450)
		CALL	L41B1
L37BD:		LD	(L4450),HL
		RES	0,(IY+14)	;=447Ah
		SET	0,(IY+21)	;=4481h
		CALL	L401F
		RES	0,(IY+21)
		JP	ECmd41		;Restore line

;Line up
ECmd06:		LD	HL,(L4450)
		CALL	L41D0
		RET	C
		PUSH	HL
		CALL	L3E40
		POP	HL
		JR	L37BD

;Scroll down
ECmd08:		LD	HL,(L446A)
		LD	DE,(TextStart)
		CALL	L3BE2
		RET	Z
		CALL	L3E40
		LD	B,0
		LD	HL,(L4450)
L37F3:		LD	DE,(L446A)
		CALL	L3BE2
		JR	Z,L3802
		CALL	L41D0
		INC	B
		JR	L37F3

L3802:		LD	DE,(L4450)
		LD	(L4450),HL
		EX	DE,HL
		LD	A,(Height)
		SUB	3
		CP	B
		JR	NZ,L3815
		CALL	L41D0
L3815:		PUSH	HL
		LD	HL,(L4450)
		CALL	L41D0
		CALL	L37BD
		POP	HL
L3820:		JR	L37BD

;Scroll up
ECmd09:		CALL	L3E40
		LD	HL,(L4450)
		PUSH	HL
		LD	HL,(L446A)
		LD	A,(Height)
		SUB	2
		LD	B,A
L3832:		CALL	L41B1
		DJNZ	L3832
		PUSH	AF
		CALL	L37BD
		POP	AF
		POP	HL
		JR	C,L3820
		LD	DE,(L446A)
		CALL	L3BE2
		JR	NC,L3820
		CALL	L41B1
		JR	L3820

;To top of page
ECmd14:		LD	HL,(L446A)
		LD	DE,(L4450)
		CALL	L3BE2
		RET	Z
		PUSH	HL
		CALL	L3E40
		POP	HL
		JR	L3820

;To bottom of page
ECmd15:		CALL	L3E40
		LD	HL,(L446A)
		LD	A,(Height)
		SUB	3
		LD	B,A
L386B:		CALL	L41B1
		DJNZ	L386B
		JR	L3820

;Page down
ECmd11:		CALL	L3E40
		LD	A,(Height)
		SUB	2
		LD	C,A
		LD	B,A
		LD	HL,(L446A)
L387F:		CALL	L41B1
		DJNZ	L387F
		LD	(L446A),HL
		LD	B,C
		LD	HL,(L4450)
L388B:		CALL	L41B1
		DJNZ	L388B
L3890:		LD	(L4450),HL
		CALL	L401F
		CALL	L4147
		JP	ECmd41		;Restore line

;Page up
ECmd10:		CALL	L3E40
		LD	A,(Height)
		SUB	2
		LD	B,A
		LD	C,A
		LD	HL,(L446A)
L38A9:		CALL	L41D0
		DJNZ	L38A9
		LD	(L446A),HL
		LD	B,C
		LD	HL,(L4450)
L38B5:		CALL	L41D0
		DJNZ	L38B5
		JR	L3890

;To top of file
ECmd16:		LD	HL,(L446A)
		LD	DE,(TextStart)
		CALL	L3BE2
		JR	Z,L38CB
		CALL	L4147
L38CB:		CALL	L3E40
		LD	HL,(TextStart)
		LD	(L4450),HL
		LD	(L446A),HL
		CALL	L401F
		CALL	ECmd41		;Restore line
		LD	HL,L7B74
		LD	(L4452),HL
		JP	L3FE7

;<Return>
ECmd00:		BIT	0,(IY+06)	;Insert?
		JR	Z,L38F2
		CALL	ECmd07		;Line down
		JP	ECmd12		;To left on line

L38F2:		SET	0,(IY+19)	;=447Dh
		XOR	A
		LD	(CompFlag),A
		LD	A,LF
		CALL	SConOut
		CALL	L3918
		CALL	L37A4
		BIT	0,(IY+13)	;=4479h Auto-Tab?
		RET	NZ
		CALL	L3A6B
		RET	C
		LD	DE,L43F2
		CALL	L412E
		JP	C,ECmd39	;Tab
		RET

L3918:		CALL	L3950
		LD	HL,(L4450)
		PUSH	HL
		CALL	ECmd41		;Restore line
		CALL	L3E40
		POP	HL
		CALL	L41B1
		LD	(L4450),HL
		LD	HL,L7B74
L392F:		LD	(L4452),HL
		CALL	L3FE7
		CALL	L401F
		JP	ECmd41		;Restore line

;Insert line
ECmd22:		CALL	L3950
		CALL	Print
		DEFB	CR,LF,0
		LD	HL,(L4450)
		CALL	L41B1
		CALL	L3C1A
		JP	ECmd41		;Restore line

L3950:		CALL	L3E40
		LD	A,(InsLineStr)
		OR	A
		PUSH	AF
		CALL	NZ,InsLine
		POP	AF
		CALL	Z,L4139
		CALL	L3E23
		INC	HL
		LD	DE,(L4452)
		CALL	L4191
		LD	DE,L7B74
		OR	A
		SBC	HL,DE
L3970:		EX	DE,HL
		LD	HL,(L4450)
		ADD	HL,DE
		PUSH	HL
		SCF
		LD	BC,-2
		CALL	L3F18
		POP	HL
		LD	(HL),CR
		INC	HL
		LD	(HL),LF
		RET

;Character left (+ Alternative)
ECmd01:
ECmd02:		LD	HL,(L4452)
		CALL	L3C02
		RET	C
L398B:		LD	(L4452),HL
		JP	L3FE7

;Character right
ECmd03:		LD	HL,(L4452)
		CALL	L3BE8
		RET	NC
		JR	L398B

;To last cursor position
ECmd20:		CALL	L3E40
		LD	HL,(L4458)
		CALL	L3BF5
		LD	(L4450),HL
		LD	HL,(L445A)
		JP	L392F

;Mark single word
ECmd31:		CALL	ECmd05		;Word right
		CALL	ECmd04		;Word left
		LD	HL,(L4452)
L39B5:		CALL	L412A
		JR	C,L39BF
		CALL	L3BE8
		JR	C,L39B5
L39BF:		LD	(L4452),HL
		CALL	ECmd30		;Mark block end
		CALL	ECmd04		;Word left
		JP	ECmd29		;Mark block begin

L39CB:		LD	HL,(L4450)
		CALL	L41D0
		JR	C,L3A05
		PUSH	HL
		CALL	L3E40
		POP	HL
		LD	(L4450),HL
		RES	0,(IY+14)
		CALL	L401F
		CALL	ECmd41		;Restore line
		CALL	L3E23
		JR	L3A01

;Word left
ECmd04:		LD	HL,(L4452)
L39ED:		CALL	L3C02
		JR	C,L39CB
		CALL	L412A
		JR	C,L39ED
L39F7:		CALL	L3C02
		JR	C,L3A01
		CALL	L412A
		JR	NC,L39F7
L3A01:		INC	HL
L3A02:		LD	(L4452),HL
L3A05:		LD	HL,(L4452)
		JP	L3FE7

;Word right
ECmd05:		CALL	L3E23
		LD	DE,(L4452)
		PUSH	DE
		XOR	A
		SBC	HL,DE
		JR	NC,L3A19
		INC	A
L3A19:		LD	(L7B71),A
		POP	HL
L3A1D:		DEC	HL
L3A1E:		CALL	L3BE8
		JR	C,L3A4E
L3A23:		LD	HL,(L4450)
		CALL	L41B1
		RET	C
		CALL	L3E40
		LD	HL,(L4450)
		CALL	L41B1
		LD	(L4450),HL
		RES	0,(IY+14)
		CALL	L401F
		CALL	ECmd41		;Restore line
		LD	HL,L7B74
		LD	(L4452),HL
		CALL	L412A
		JR	C,L3A1D
		JP	L3FE7

L3A4E:		CALL	L412A
		JR	NC,L3A1E
L3A53:		CALL	L3BE8
		JR	C,L3A64
		LD	A,(L7B71)
		OR	A
		JR	NZ,L3A23
		CALL	L3E23
		INC	HL
		JR	L3A02

L3A64:		CALL	L412A
		JR	C,L3A53
		JR	L3A02

L3A6B:		LD	HL,(L4450)
		CALL	L41D0
		RET

;Tab
ECmd39:		CALL	L3A6B
		RET	C
		LD	A,(L4471)
		PUSH	AF
		LD	HL,(L4452)
		LD	(L4468),HL
		RES	0,(IY+07)
		CALL	L3E40
		LD	HL,(L4450)
		PUSH	HL
		CALL	L41D0
		LD	(L4450),HL
		CALL	ECmd41		;Restore line
		LD	HL,L43F2
		LD	(L7B72),HL
		CALL	ECmd05		;Word right
		LD	HL,L43DE	;table of separators
		LD	(L7B72),HL
		POP	HL
		POP	AF
		LD	(L4471),A
		LD	(L4450),HL
		CALL	ECmd41		;Restore line
		SET	0,(IY+07)
		BIT	0,(IY+06)
		JP	NZ,L374E
		LD	HL,(L4452)
		LD	DE,(L4468)
		SBC	HL,DE
		RET	C
		RET	Z
		EX	DE,HL
L3AC5:		PUSH	DE
		CALL	L41EB
		LD	(HL),' '	;20H
		POP	DE
		DEC	E
		JR	NZ,L3AC5
		JP	L374E

;Delete to end of line
ECmd24:		LD	HL,(L4452)
		PUSH	HL
		CALL	L3FC5
		POP	HL
		PUSH	HL
		LD	DE,L7BF2
L3ADE:		LD	(HL),' '	;20H
		CALL	L3BE2
		JR	Z,L3AE8
		INC	HL
		JR	L3ADE

L3AE8:		POP	HL
		JP	L4197

;Delete line
ECmd23:		LD	HL,L7B74
		LD	(L4452),HL
		CALL	L3FE7
		CALL	ECmd24		;Delete to end of line
		CALL	L3E40
		LD	HL,(L4450)
		PUSH	HL
		PUSH	HL
		CALL	L41B1
		POP	DE
		JR	C,L3B10
		OR	A
		SBC	HL,DE
		LD	C,L
		LD	B,H
		POP	HL
		JP	NZ,L3B26
		RET

L3B10:		POP	HL
		JP	ECmd41		;Restore line

L3B14:		CALL	L3E44
		LD	HL,(L4450)
		CALL	L41B1
		JP	C,ECmd41	;Restore line
		DEC	HL
		DEC	HL
		LD	BC,2
		OR	A
L3B26:		CALL	L3F18
		LD	A,(DelLineStr)
		OR	A
		JR	Z,L3B3C
		CALL	DelLine
		LD	A,(Height)
		DEC	A
		CALL	L3BBC
		JP	ECmd41		;Restore line

L3B3C:		CALL	L4139
		JP	ECmd41		;Restore line

;Delete right word
ECmd25:		CALL	L3E23
		LD	DE,(L4452)
		CALL	L3BE2
		EX	DE,HL
		JR	C,L3B14
		LD	A,(HL)
		CP	' '		;20H
		JR	Z,L3B8C
		CALL	L412A
		JR	C,L3B83
L3B59:		CALL	L4173
		CALL	L412A
		JR	C,L3B86
		JR	L3B59

L3B63:		LD	HL,(L4450)
		CALL	L41D0
		RET	C
		CALL	ECmd06		;Line up
		CALL	ECmd13		;To right on line
		JP	ECmd25		;Delete right word

;Delete character under cursor
ECmd26:		LD	HL,(L4452)
		JR	L3B83

;Delete left character (+ Alternative)
ECmd27:
ECmd28:		LD	HL,(L4452)
		CALL	L3C02
		JR	C,L3B63
		LD	(L4452),HL
L3B83:		CALL	L4173
L3B86:		CALL	L3FE7
		JP	L4197

L3B8C:		CALL	L4173
		LD	A,(HL)
		CP	' '		;20H
		JR	Z,L3B8C
		JR	L3B86

L3B96:		CALL	TypeAEmpty	;look if TypeAhead buffer empty
		JP	NZ,L37A4
		CALL	L3BAC
		JR	NC,L3B96
		JP	L37A4

L3BA4:		CALL	L3BAC
		JR	NC,L3BA4
		JP	L37A4

L3BAC:		LD	A,(L4475)
		LD	HL,Height
		CP	(HL)
		SCF
		RET	Z
		INC	(IY+09)
		CP	(IY+05)
		RET	Z
L3BBC:		LD	H,0
		LD	L,A
		PUSH	AF
		CALL	CsrXY
		POP	AF
		LD	HL,(L446A)
		LD	B,A
L3BC8:		DEC	B
IF TPVers2
		JR	NZ,L3BD0
		CALL	L3C1A
		XOR	A
		RET
L3BD0:
ELSE
		JR	Z,L3BD8
ENDIF
		CALL	L41B1
		JR	NC,L3BC8
		CALL	XNormVideo
		CALL	L3C12
		XOR	A
		RET
IF TPVers3
L3BD8:		CALL	L3C1A
		XOR	A
		RET
ENDIF

L3BDD:		INC	HL
		LD	DE,(TextEnd)
L3BE2:		PUSH	HL
		OR	A
		SBC	HL,DE
		POP	HL
		RET

L3BE8:		INC	HL
		LD	DE,L7BF1
		JR	L3BE2

L3BEE:		DEC	HL
		LD	DE,(TextStart)
		JR	L3BE2

L3BF5:		LD	A,LF
L3BF7:		CALL	L3BEE
		RET	Z
		JR	C,L3C00
		CP	(HL)
		JR	NZ,L3BF7
L3C00:		INC	HL
		RET

L3C02:		DEC	HL
		LD	DE,L7B74
		JR	L3BE2

L3C08:		CP	CR
		RET	NZ
		LD	A,(HL)
		CALL	L3BDD
		RET	NC
		JR	L3C08

L3C12:		LD	A,(Width)
		DEC	A
		LD	B,A
L3C17:		JP	L3CF9

L3C1A:		CALL	L3CA1
		CALL	L3CC0
		LD	A,(L446C)
		LD	B,A
		OR	A
		JR	Z,L3C36
L3C27:		LD	A,(HL)
		CALL	L3BDD
		JR	NC,L3C12
		CALL	L3C08
		CP	LF
		JR	Z,L3C12
		DJNZ	L3C27
L3C36:		LD	A,(Width)
		DEC	A
		LD	B,A
		BIT	0,(IY+16)
		JR	Z,L3C5E
L3C41:		CALL	L3CA1
		CALL	L3CC0
		PUSH	HL
		CALL	L3E23
IF TPVers3
		LD	DE,(L4452)
		CALL	L4191
		EX	DE,HL
ENDIF
		INC	HL
		LD	(L4486),HL
		EX	DE,HL
		POP	HL
		CALL	L3BE2
		JR	NC,L3C89
L3C5E:		CALL	L3CA1
		CALL	L3CC0
		LD	DE,(L4486)
		CALL	L3BE2
		JR	Z,L3C89
		LD	A,(HL)
		CALL	L3BDD
		JR	NC,L3C17
		CALL	L3C08
		CP	LF
		JR	Z,L3C17
		CALL	L3C8B
		DJNZ	L3C5E
L3C7F:		LD	A,(HL)
		CALL	L3BDD
		JR	NC,L3C89
		CP	LF
		JR	NZ,L3C7F
L3C89:		JR	L3C17

L3C8B:		CP	' '		;20H
		JR	NC,L3C96
		ADD	A,'@'		;40H
		PUSH	AF
		CALL	L3C99
		POP	AF
L3C96:		JP	SConOut

L3C99:		LD	A,(HLightFlag)
		OR	A
		JR	Z,XNormVideo
		JR	XLowVideo

L3CA1:		BIT	0,(IY+16)
		RET	Z
		BIT	0,(IY+20)
		JR	NZ,XNormVideo
		LD	DE,(L4464)
		CALL	L3BE2
		JR	C,XNormVideo
		LD	DE,(L4466)
		CALL	L3BE2
		JR	C,XLowVideo
		JR	XNormVideo

L3CC0:		BIT	0,(IY+16)
		RET	NZ
		BIT	0,(IY+20)
		JR	NZ,XNormVideo
		LD	DE,(L4460)
		CALL	L3BE2
		JR	C,XNormVideo
		LD	DE,(L4462)
		CALL	L3BE2
		JR	Z,XNormVideo
		JR	NC,XNormVideo

XLowVideo:	LD	A,(HLightFlag)
		OR	A
		RET	Z
		BIT	0,(IY+07)
		RET	Z
		JP	LowVideo

XNormVideo:	LD	A,(HLightFlag)
		OR	A
		RET	NZ
		BIT	0,(IY+07)
		RET	Z
		JP	NormVideo

L3CF9:		INC	B
		DEC	B
		RET	Z
		LD	A,(EraToEolStr)
		OR	A
		JP	NZ,ClrEol
L3D03:		LD	A,' '		;20H
		CALL	SConOut
		DJNZ	L3D03
		RET

L3D0B:		LD	A,(DelLineStr)
		OR	A
		JR	NZ,L3D23
		LD	(L4474),A
		LD	A,(Height)
		DEC	A
		LD	L,A
		LD	H,0
		CALL	CsrXY
		LD	A,LF
		JP	SConOut

L3D23:		LD	HL,0001h
		CALL	CsrXY
		JP	DelLine

;Restore line
ECmd41:		LD	HL,(L4450)
		LD	DE,0
		LD	(L4464),DE
		LD	(L4466),DE
		LD	B,7FH
		LD	IX,L7B74
		LD	(IY+01),0
L3D44:		LD	A,(HL)
		LD	DE,(L4460)
		CALL	L3BE2
		JR	NZ,L3D56
		LD	(L4464),IX
		SET	0,(IY+01)
L3D56:		LD	DE,(L4462)
		CALL	L3BE2
		JR	NZ,L3D67
		LD	(L4466),IX
		SET	1,(IY+01)
L3D67:		CP	CR
		JR	NZ,L3DC3
		LD	(IX),' '
		INC	IX
		DEC	B
		JR	Z,L3DD9
		CALL	L3BDD
		JR	NC,L3D44
L3D79:		LD	DE,(L4462)
		CALL	L3BE2
		JR	NC,L3D8A
		PUSH	HL
		LD	HL,-1
		LD	(L4466),HL
		POP	HL
L3D8A:		LD	DE,(L4460)
		CALL	L3BE2
		JR	NC,L3D99
		LD	HL,-1
		LD	(L4464),HL
L3D99:		LD	A,7Fh
		SUB	B
		LD	(L446F),A
L3D9F:		LD	(IX),' '
		INC	IX
		DJNZ	L3D9F
		LD	HL,(L4452)
		CALL	L3FE7
		BIT	0,(IY+14)
		SET	0,(IY+14)
		JP	NZ,L374E
		LD	A,(L4475)
		DEC	A
		CP	(IY+05)
		RET	NC
		JP	L374E

L3DC3:		CP	LF
		JR	Z,L3D79
		LD	(IX),A
		INC	IX
		DEC	B
		JR	NZ,L3DD1
		JR	L3DD9

L3DD1:		CALL	L3BDD
		JR	NC,L3D79
		JP	L3D44

L3DD9:		CALL	L3E04
		DEFB	'Line too long - CR inserted',0
		CALL	L3F12
		LD	HL,125
		CALL	L3970
		JP	ECmd41		;Restore line

L3E04:		CALL	L3BA4
L3E07:		CALL	L3E0D
		JP	L4211

L3E0D:		LD	(IY+08),0
		LD	HL,0
		CALL	CsrXY
		CALL	L3C12
		LD	HL,0
		CALL	CsrXY
		JP	XLowVideo

L3E23:		LD	A,' '		;20H
		LD	HL,L7BF2
		LD	DE,L7B73
L3E2B:		CP	(HL)
		RET	NZ
		DEC	HL
		CALL	L3BE2
		JR	NZ,L3E2B
		RET

L3E34:		LD	DE,L7BF3
		CALL	L3BE2
		RET	NC
		LD	D,B
		LD	E,C
		JP	L4191

L3E40:		CALL	L3E23
		INC	HL
L3E44:		LD	C,L
		LD	B,H
		LD	HL,(L4464)
		CALL	L3E34
		LD	(L4464),HL
		LD	HL,(L4466)
L3E52:		CALL	L3E34
		LD	(L4466),HL
		LD	L,C
L3E59:		LD	H,B
		INC	HL
		LD	DE,L7B74
		OR	A
		SBC	HL,DE
		PUSH	HL
		LD	A,(L446F)
		SUB	L
		LD	C,A
		LD	B,0
		JR	NC,L3E6D
		LD	B,0FFh
L3E6D:		LD	HL,(L4450)
		CALL	NZ,L3F18
		POP	BC
		LD	IX,(L4450)
		LD	HL,L7B74
		LD	B,C
		DEC	B
		INC	B
		JR	Z,L3EA5
L3E80:		LD	A,(HL)
		LD	DE,(L4464)
		CALL	L3BE2
		JR	NZ,L3E8E
		LD	(L4460),IX
L3E8E:		LD	DE,(L4466)
		CALL	L3BE2
		JR	NZ,L3E9B
		LD	(L4462),IX
L3E9B:		LD	(IX),A
		INC	HL
		INC	IX
		DJNZ	L3E80
		DEC	IX
L3EA5:		LD	A,CR
		LD	(IX),A
		RET

L3EAB:		LD	HL,(MaxMem)
		OR	A
		SBC	HL,DE
		JR	C,L3ED9
		LD	BC,254
		SBC	HL,BC
		RET	NC
		ADD	HL,BC
		PUSH	HL
		CALL	L3E0D
		POP	HL
		LD	B,0
		CALL	L30FE
		CALL	L4211
		DEFB	' byte(s) left',0
		CALL	L3F12
		RET

L3ED9:		CALL	L3E04
		DEFB	'ERROR: Out of space',0
		CALL	L3F12
		JP	L2EBD

L3EF6:		CP	21
		RET	NZ
		CALL	L3E04
		DEFB	'*** INTERRUPTED',0
		CALL	L3F12
		JP	L2EBD

L3F12:		CALL	ClearTypeA
		JP	PressEscape

L3F18:		PUSH	HL
		PUSH	BC
		JR	NC,L3F96
		LD	DE,(TextEnd)
		PUSH	DE
		PUSH	DE
		EX	DE,HL
		OR	A
		SBC	HL,DE
		EX	(SP),HL
		OR	A
		SBC	HL,BC
		JP	NC,L3ED9
		LD	E,L
		LD	D,H
		PUSH	DE
		CALL	L3EAB
		POP	DE
		POP	BC
		INC	BC
		POP	HL
		LD	(TextEnd),DE
		LD	A,B
L3F3C:		SUB	' '		;20H
		JR	C,L3F4D
		LD	B,A
L3F41:		PUSH	BC
		LD	BC,2000h
		LDDR
		POP	BC
		CALL	STypeAhead
		JR	L3F3C

L3F4D:		LD	A,C
		OR	B
		JR	Z,L3F53
		LDDR
L3F53:		POP	BC
		POP	HL
		EX	DE,HL
		INC	DE
L3F57:		LD	HL,(L4460)
		CALL	L3F8E
		LD	(L4460),HL
		LD	HL,(L4462)
		CALL	L3F8E
		LD	(L4462),HL
		LD	HL,(L446A)
		CALL	L3F8E
		LD	(L446A),HL
		LD	HL,(L4450)
		CALL	L3F8E
		LD	(L4450),HL
		LD	HL,(L4454)
		CALL	L3F8E
		LD	(L4454),HL
		LD	HL,(L4458)
		CALL	L3F8E
		LD	(L4458),HL
		RET

L3F8E:		CALL	L3BE2
		RET	C
		OR	A
		SBC	HL,BC
		RET

L3F96:		PUSH	HL
		ADD	HL,BC
		PUSH	HL
		LD	DE,(TextEnd)
		INC	DE
		EX	DE,HL
		OR	A
		SBC	HL,DE
		LD	C,L
		LD	B,H
		POP	HL
		POP	DE
		LD	A,B
L3FA7:		SUB	' '		;20H
		JR	C,L3FB8
		LD	B,A
		PUSH	BC
		LD	BC,2000h
		LDIR
		POP	BC
		CALL	STypeAhead
		JR	L3FA7

L3FB8:		LD	A,C
		OR	B
		JR	Z,L3FBF
		LDIR
		DEC	DE
L3FBF:		LD	(TextEnd),DE
		JR	L3F53

L3FC5:		PUSH	HL
		LD	DE,(L4464)
		CALL	L4191
		BIT	0,(IY+01)
		JR	Z,L3FD6
		LD	(L4464),HL
L3FD6:		POP	HL
		BIT	1,(IY+01)
		RET	Z
		LD	DE,(L4466)
		CALL	L4191
		LD	(L4466),HL
		RET

L3FE7:		LD	DE,L7B74
		LD	A,(Width)
		DEC	A
		LD	C,A
		OR	A
		SBC	HL,DE
		LD	A,L
		SUB	(IY)
		JR	C,L4012
		CP	C
		JR	C,L400E
		SUB	C
		INC	A
		ADD	A,(IY)
		LD	(L446C),A
		LD	A,(Width)
		DEC	A
		DEC	A
		LD	(L4470),A
		JP	L3762

L400E:		LD	(L4470),A
		RET

L4012:		ADD	A,(IY)
		LD	(L446C),A
		LD	(IY+04),0
		JP	L3762

L401F:		BIT	0,(IY+07)
		RET	Z
IF TPVers2
		LD	DE,(L4450)
		LD	HL,(L446A)
		LD	BC,1
ELSE
		LD	HL,(L446A)
		LD	DE,(TextStart)
		CALL	L4191
		EX	DE,HL
		LD	(L446A),HL
		LD	BC,1
		LD	DE,(L4450)
ENDIF
		CALL	L3BE2
		JP	Z,L40DA
		JR	C,L4086
L4041:		LD	DE,(L4450)
		CALL	L3BE2
		JR	Z,L4055
		CALL	L41D0
		INC	BC
		LD	A,C
		OR	A
		CALL	Z,STypeAhead
		JR	L4041

L4055:		LD	(L446A),HL
		LD	(IY+05),1
		SET	0,(IY+14)
		LD	A,B
		OR	A
		JR	NZ,L4083
		LD	A,(InsLineStr)
		OR	A
		JR	Z,L4083
		LD	A,(Height)
		DEC	A
		CP	C
		JR	C,L4083
		DEC	C
		LD	HL,1
		CALL	CsrXY
		DEC	C
		PUSH	AF
		INC	C
L407B:		CALL	InsLine
		DEC	C
		JR	NZ,L407B
		POP	AF
		RET	Z
L4083:		JP	L4147

L4086:		LD	DE,(L4450)
		CALL	L3BE2
		JR	Z,L409A
		CALL	L41B1
		INC	BC
		LD	A,C
		OR	A
		CALL	Z,STypeAhead
		JR	L4086

L409A:		LD	A,B
		OR	A
		JR	NZ,L40DE
		LD	A,(Height)
		DEC	A
		LD	E,A
		LD	A,C
		SUB	E
		LD	D,A
		INC	D
		JR	C,L40DA
		DEC	D
		JR	NZ,L40B3
		BIT	0,(IY+21)
		JP	NZ,L4103
L40B3:		INC	D
		SUB	E
		JR	NC,L40DE
		LD	A,(L4475)
		SUB	D
		JR	C,L40DE
		JR	Z,L40DE
		LD	(L4475),A
		LD	HL,(L446A)
		LD	B,D
		PUSH	DE
L40C7:		CALL	L41B1
		PUSH	HL
		CALL	L3D0B
		POP	HL
		DJNZ	L40C7
		LD	(L446A),HL
		POP	DE
L40D5:		DEC	E
		LD	(IY+05),E
		RET

L40DA:		LD	(IY+05),C
		RET

L40DE:		LD	HL,(L446A)
		DEC	BC
		LD	A,(Height)
		SUB	3
		LD	E,A
		LD	A,C
		SUB	E
		LD	C,A
		JR	NC,L40EE
		DEC	B
L40EE:		CALL	L41B1
		DEC	BC
		LD	A,C
		OR	B
		JR	NZ,L40EE
		LD	(L446A),HL
		CALL	L4147
		SET	0,(IY+14)
		JP	L401F

L4103:
IF TPVers3
		CALL	L40D5
		LD	A,(L4475)
		LD	L,A
		LD	A,(Height)
		CP	L
		LD	A,L
		JR	Z,L4117
		DEC	A
		JR	Z,L4117
		LD	(L4475),A
ENDIF
L4117:		LD	HL,(L446A)
		CALL	L41B1
		LD	(L446A),HL
		CALL	L3D0B
		LD	A,(Height)
		DEC	A
		JP	L3BBC

L412A:		LD	DE,(L7B72)
L412E:		LD	A,(DE)
		OR	A
		RET	Z
		CP	(HL)
		JR	Z,L4137
		INC	DE
		JR	L412E

L4137:		SCF
		RET

L4139:		PUSH	AF
		LD	A,(L4471)
		CP	(IY+09)
		JR	NC,L4145
		LD	(L4475),A
L4145:		POP	AF
		RET

L4147:		LD	(IY+09),1
		RET

L414C:		EX	DE,HL
		BIT	0,(IY+01)
		JR	Z,L415F
		LD	HL,(L4464)
		CALL	L3BE2
		JR	C,L415F
		ADD	HL,BC
		LD	(L4464),HL
L415F:		BIT	1,(IY+01)
		JR	Z,L4171
		LD	HL,(L4466)
		CALL	L3BE2
		JR	C,L4171
		ADD	HL,BC
		LD	(L4466),HL
L4171:		EX	DE,HL
		RET

L4173:		PUSH	HL
		LD	BC,-1
		CALL	L414C
		EX	DE,HL
		LD	HL,L7BF2
		OR	A
		SBC	HL,DE
		JR	Z,L418A
		LD	C,L
		LD	B,H
		LD	L,E
		LD	H,D
		INC	HL
		LDIR
L418A:		LD	HL,L7BF2
		LD	(HL),' '	;20H
		POP	HL
		RET

L4191:		CALL	L3BE2
		RET	C
		EX	DE,HL
		RET

L4197:		CALL	L37A4
		LD	A,(Width)
		DEC	A
		SUB	(IY+04)
		LD	HL,(L4452)
		LD	B,A
		SET	0,(IY+16)
		CALL	L3C41
		RES	0,(IY+16)
		RET

L41B1:		PUSH	BC
IF TPVers2
		LD	C,L
		LD	B,H
L41B4:		LD	A,(HL)
		CALL	L3BDD
		JR	NC,L41CC
		CP	LF
		JR	NZ,L41B4
ELSE	;TPVers3
		EX	DE,HL
		LD	HL,(TextEnd)
		DEC	HL
		OR	A
		SBC	HL,DE
		LD	B,H
		LD	C,L
		INC	BC
		EX	DE,HL
		LD	D,H
		LD	E,L
		JR	C,L41CC
		LD	A,LF
		CPIR
		JP	PO,L41CC
		OR	A
ENDIF
		POP	BC
		RET

L41CC:
IF TPVers2
		LD	L,C
		LD	H,B
ENDIF
		SCF
IF TPVers3
		EX	DE,HL
ENDIF
		POP	BC
		RET

L41D0:		PUSH	BC
		LD	C,L
		LD	B,H
		LD	A,LF
		CALL	L3BEE
		JR	C,L41E7
L41DA:		CALL	L3BEE
		JR	Z,L41E5
		JR	C,L41E7
		CP	(HL)
		JR	NZ,L41DA
		INC	HL
L41E5:		POP	BC
		RET

L41E7:		LD	H,B
		LD	L,C
		POP	BC
		RET

L41EB:		PUSH	HL
		LD	BC,1
		CALL	L414C
		LD	DE,L7BF2
		EX	DE,HL
		OR	A
		SBC	HL,DE
		DEC	HL
		LD	C,L
		LD	B,H
		LD	DE,L7BF1
		LD	L,E
		LD	H,D
		DEC	HL
		LD	A,C
		OR	B
		JR	Z,L420C
		PUSH	DE
		LDDR
		POP	HL
		LD	(HL),' '	;20H
L420C:		POP	HL
		RET

L420E:		CALL	CsrXY
L4211:		JP	PrintH

EdiConOut:	POP	HL
		EX	(SP),HL
		BIT	0,(IY+07)	;suppress output?
		JR	Z,EdiConO1	;yes ->
		PUSH	HL
		CALL	1234
OldConOut	EQU	$-2
EdiConO1:	LD	A,(L4543)
		SUB	2
		LD	(L4543),A
		RET	NZ		;look every 128 characters
		JR	TypeAhead

;clear TypeAhead buffer
ClearTypeA:	LD	HL,(TypeARead)
		LD	(TypeAWrite),HL
		RET

;TypeAhead (with saving registers)
STypeAhead:	PUSH	AF
		PUSH	BC
		PUSH	DE
		PUSH	HL
		CALL	TypeAhead
		POP	HL
		POP	DE
		POP	BC
		POP	AF
		RET

;If still space in TypeAhead buffer that look if user made a keystroke.
;If so, read key in and put it in TypeAhead buffer.
;E: TypeARead, TypeAWrite
;V: AF, vmtl. BC, DE, HL / R:-
TypeAhead:	LD	HL,(TypeAWrite)
		CALL	TypeAInc
		LD	DE,(TypeARead)
		EX	DE,HL
		SBC	HL,DE		;still space?
		EX	DE,HL
		RET	Z		;no, leave
		PUSH	HL
		PUSH	IX
		PUSH	IY
		CALL	ConSta		;keystroke?
		POP	IY
		POP	IX
		POP	HL
		RET	Z		;no, leave
		CALL	SConInp
		LD	(HL),A
		LD	(TypeAWrite),HL
		RET

;E: TypeA pointer in HL
;V: F, DE
;R: pointer advanced
TypeAInc:	INC	HL
		LD	DE,TypeABuf+20
		OR	A
		EX	DE,HL
		SBC	HL,DE		;does pointer point behind end?
		EX	DE,HL
		RET	NZ		;no, ok
		LD	HL,TypeABuf	;yes, point to beginning
		RET

;get character
L4271:		PUSH	HL
		PUSH	DE
		LD	DE,(TypeARead)
		LD	HL,(TypeAWrite)
		OR	A
		SBC	HL,DE		;TypeAhead buffer empty?
		EX	DE,HL
		JR	Z,L4289		;yes, wait for user to enter something
		CALL	TypeAInc
		LD	A,(HL)
		LD	(TypeARead),HL
		JR	L428C

L4289:		CALL	SConInp
L428C:		POP	DE
		POP	HL
		RET

;Look if TypeAhead buffer is empty
;E:- / V: F
;R: Zero if empty, else NZero
TypeAEmpty:	PUSH	HL
		PUSH	DE
		LD	DE,(TypeARead)
		LD	HL,(TypeAWrite)
		OR	A
		SBC	HL,DE
		POP	DE
		POP	HL
		RET

;END OF TP-ME3.INC
;-----------------
