;--------------------------------
;TP-C3.INC	ho	02-MAR-94
;--------------------------------
;5A32h-64F1h

		IDENT	TP-C3.INC

;'READLN'
READLNcc:	DEFB	3Eh		;LD A,0AFh

;'READ'
READcc:		XOR	A
		LD	(L7BA3),A
		CALL	ScanRundAuf
		JR	Z,L5A41
		CALL	L5ACA
		JR	L5AB4

L5A41:		CALL	L5A17
		JR	C,L5A63
		JR	NZ,L5A5B
		CP	5
		JP	Z,L5BD8
		CP	6
		CALL	ErrIfNZero
		DEFB	65		;Untyped files are not allowed here
		LD	HL,PrepInpText
		CALL	CmpOutCALL
		JR	L5AAC

L5A5B:		CALL	L678B
		CALL	L5ACA
		JR	L5A69

L5A63:		CALL	L5ACA
L5A66:		CALL	L677F
L5A69:		LD	A,(L7B5C)
		CP	8
		JR	C,L5A78
		CP	11
L5A72:		JR	Z,L5A78
		CP	13
		JR	C,L5A7C
L5A78:		CALL	ErrAlways
		DEFB	66		;I/O not allowed here

L5A7C:		CP	8
		JR	NZ,L5A8F
		LD	A,(L7B62)
		DEC	A
		LD	H,A
		LD	L,6
		CALL	CmpOutHL
		LD	HL,ReadString
		JR	L5AA9

L5A8F:		LD	HL,ReadReal
		CP	9
		JR	Z,L5AA9
		LD	HL,ReadChar
		CP	12
		JR	Z,L5AA9
		LD	HL,ReadInt
		LD	A,(L7B62)
		DEC	A
		JR	NZ,L5AA9
		LD	HL,ReadByte
L5AA9:		CALL	CmpOutCALL
L5AAC:		CALL	ScanComma
		JR	Z,L5A66
		CALL	NeedRundZu
L5AB4:		LD	HL,ReadLine
L5AB7:		LD	A,(L7BA3)
		OR	A
		CALL	NZ,CmpOutCALL
L5ABE:		LD	A,(WrkDirektiv)
		BIT	0,A
		RET	Z
		LD	HL,ChkIORes
		JP	CmpOutCALL

L5ACA:		LD	HL,PrepOutput
		LD	A,(WrkDirektiv)
		BIT	6,A
		JR	Z,L5AE4
		LD	HL,PrepInput
		LD	A,(L7BA3)
		OR	A
		JR	Z,L5AE4
		LD	HL,PrepInpLine
		XOR	A
		LD	(L7BA3),A
L5AE4:		JP	CmpOutCALL

;'WRITELN'
WRITELNcc:	DEFB	3Eh

;'WRITE'
WRITEcc:	XOR	A
		LD	(L7BA3),A
		CALL	ScanRundAuf
		JR	Z,L5AFA
		LD	HL,PrepOutput
		CALL	CmpOutCALL
		JP	L5BD2

L5AFA:		CALL	L5A17
		JR	C,L5B20
		JR	NZ,L5B15
		CP	5
		JP	Z,L5BDD
		CP	6
		CALL	ErrIfNZero
		DEFB	65		;Untyped files are not allowed here
		LD	HL,PrepOutText
		CALL	CmpOutCALL
		JP	L5BC9

L5B15:		CALL	L620F
		LD	HL,PrepOutput
		CALL	CmpOutCALL
		JR	L5B4F

L5B20:		LD	HL,PrepOutput
		CALL	CmpOutCALL
L5B26:		CALL	L6A5C
		JR	NZ,L5B4C
		LD	A,B
		CP	8
		JR	NZ,L5B47
		LD	A,(IX)
		CP	','
		JR	Z,L5B3B
		CP	')'
		JR	NZ,L5B47
L5B3B:		LD	HL,WriteCString
		CALL	CmpOutCALL
		CALL	CmpOutString
		JP	L5BC9

L5B47:		CALL	L6201
		JR	L5B4F

L5B4C:		CALL	L5EE8
L5B4F:		LD	A,B
		CP	8
		JR	C,L5B58
		CP	13
		JR	C,L5B5C
L5B58:		CALL	ErrAlways
		DEFB	66		;I/O not allowed here

L5B5C:		CP	12
		JR	NZ,L5B6A
		CALL	ScanColon
		JR	NZ,L5BA6
		CALL	L5EDD
		JR	L5B72

L5B6A:		CALL	L6148
		CALL	ScanColon
		JR	NZ,L5B8B
L5B72:		PUSH	BC
		CALL	L5E97
		POP	BC
		LD	A,B
		CP	9
		JR	NZ,L5BA6
		CALL	ScanColon
		JR	NZ,L5B9D
		PUSH	BC
		CALL	CmpOutPUSHHL
		CALL	L5E97
		POP	BC
		JR	L5BA6

L5B8B:		LD	HL,0
		LD	A,B
		CP	9
		JR	NZ,L5B95
		LD	L,18
L5B95:		CALL	CmpOutLDHL
		LD	A,B
		CP	9
		JR	NZ,L5BA6
L5B9D:		CALL	CmpOutPUSHHL
		LD	HL,-1
		CALL	CmpOutLDHL
L5BA6:		LD	A,B
		LD	HL,WriteString
		CP	8
		JR	Z,L5BC6
		LD	HL,WriteReal
		CP	9
		JR	Z,L5BC6
		LD	HL,WriteInt
		CP	10
		JR	Z,L5BC6
		LD	HL,WriteBool
		CP	11
		JR	Z,L5BC6
		LD	HL,WriteChar
L5BC6:		CALL	CmpOutCALL
L5BC9:		CALL	ScanComma
		JP	Z,L5B26
		CALL	NeedRundZu
L5BD2:		LD	HL,WriteLine
		JP	L5AB7

L5BD8:		LD	HL,ReadFO
		JR	L5BE0

L5BDD:		LD	HL,WriteFO
L5BE0:		LD	(L7BA7),HL
		LD	A,(L7BA3)
		OR	A
		CALL	ErrIfNZero
		DEFB	35		;text file expected
		LD	HL,PrepFO
		CALL	CmpOutCALL
		LD	HL,(L7B5E)
		CALL	L5271
L5BF7:		CALL	ScanComma
		JR	NZ,L5C10
		CALL	L6D24
		CALL	L677F
		CALL	L6D43
		CALL	L58C5
		LD	HL,(L7BA7)
		CALL	CmpOutCALL
		JR	L5BF7

L5C10:		CALL	NeedRundZu
		JP	L5ABE

;'BLOCKREAD'
BLOCKREADcc:	LD	HL,BlockRd4
		LD	DE,BlockRd3
		JR	L5C24

;'BLOCKWRITE'
BLOCKWRITEcc:	LD	HL,BlockWr4
		LD	DE,BlockWr3
L5C24:		PUSH	HL
		PUSH	DE
		CALL	L5A0C
		CP	7
		CALL	ErrIfNZero
		DEFB	37		;Untyped file expected
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L677F
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L5E97
		CALL	ScanComma
		POP	DE
		POP	HL
		JR	Z,L5C4B
		PUSH	DE
		JR	L5C63

L5C4B:		PUSH	HL
		CALL	CmpOutPUSHHL
		CALL	L677F
		LD	A,(L7B5C)
		CP	10
		JR	NZ,L5C5F
		LD	A,(L7B62)
		DEC	A
		JR	NZ,L5C63
L5C5F:		CALL	ErrAlways
		DEFB	24		;Integer variable expected

L5C63:		JP	L5985

;'DELETE'
DELETEcc:	CALL	NeedRundAuf
		CALL	L5CAD
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L5E97
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L5E97
		LD	HL,Delete
L5C81:		CALL	NeedRundZu
		JP	CmpOutCALL

;'INSERT'
INSERTcc:	CALL	NeedRundAuf
		CALL	L5ED0
		CALL	NeedComma
		CALL	L5CAD
		CALL	CmpOutPUSHHL
		LD	A,(L7B62)
		DEC	A
		LD	H,A
		LD	L,6
		PUSH	HL
		CALL	NeedComma
		CALL	L5E97
		POP	HL
		CALL	CmpOutHL
		LD	HL,Insert
		JR	L5C81

L5CAD:		CALL	L677F
		LD	A,(L7B5C)
		CP	8
		RET	Z
		CALL	ErrAlways
		DEFB	34		;String variable expected

;'STR'
STRcc:		CALL	NeedRundAuf
		CALL	L5EA2
		CALL	L6148
		CALL	ScanColon
		JR	NZ,L5CE4
		PUSH	BC
		CALL	L5E97
		CALL	CmpOutPUSHHL
		POP	BC
		LD	A,B
		CP	10
		JR	Z,L5D02
		CALL	ScanColon
		JR	NZ,L5CF9
		PUSH	BC
		CALL	L5E97
		CALL	CmpOutPUSHHL
		POP	BC
		JR	L5D02

L5CE4:		LD	HL,0
		LD	A,B
		CP	10
		JR	Z,L5CEE
		LD	L,18
L5CEE:		CALL	CmpOutLDHL
		CALL	CmpOutPUSHHL
		LD	A,B
		CP	10
		JR	Z,L5D02
L5CF9:		LD	HL,-1
		CALL	CmpOutLDHL
		CALL	CmpOutPUSHHL
L5D02:		CALL	NeedComma
		PUSH	BC
		CALL	L5CAD
		LD	A,(L7B62)
		DEC	A
		LD	H,A
		LD	L,6
		CALL	CmpOutHL
		POP	BC
		LD	HL,StrInt
		LD	A,B
		CP	10
		JR	Z,L5D1F
		LD	HL,StrReal
L5D1F:		JP	L5C81

;'VAL'
VALcc:		CALL	NeedRundAuf
		CALL	L5ED0
		CALL	NeedComma
		CALL	L677F
		LD	A,(L7B5C)
		CP	9
		JR	Z,L5D45
		CP	10
		JR	NZ,L5D41
		LD	A,(L7B62)
		DEC	A
		LD	A,10
		JR	NZ,L5D45
L5D41:		CALL	ErrAlways
		DEFB	27		;Integer or real variable expected

L5D45:		PUSH	AF
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L677F
		LD	A,(L7B5C)
		CP	10
		JR	NZ,L5D5C
		LD	A,(L7B62)
		DEC	A
		JR	NZ,L5D60
L5D5C:		CALL	ErrAlways
		DEFB	24		;Integer variable expected

L5D60:		POP	AF
		LD	HL,ValInt
		CP	10
		JR	Z,L5D1F
		LD	HL,ValReal
		JR	L5D1F

;'GOTOXY'
GOTOXYcc:	CALL	NeedRundAuf
		CALL	L5E97
		LD	HL,GotoXY
L5D76:		PUSH	HL
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L5E97
		POP	HL
		JR	L5DB1

;'RANDOMIZE'
RANDOMIZEcc:	LD	HL,Randomize
		JP	CmpOutCALL

;'DELAY'
DELAYcc:	CALL	NeedRundAuf
		CALL	L5E97
		LD	HL,Delay
		JR	L5DB1

;'GETMEM'
GETMEMcc:	CALL	L5DE3
		CALL	NeedComma
		CALL	L5E97
		JR	L5DAE

;'NEW'
NEWcc:		CALL	L5DE3
		LD	HL,(L7B5E)
		CALL	L5271
		LD	HL,(L7B6F)
		CALL	CmpOutLDHL
L5DAE:		LD	HL,GetMem
L5DB1:		JP	L5960

;'FREEMEM'
FREEMEMcc:	CALL	L5DE3
		CALL	NeedComma
		CALL	L5E97
		JR	L5DCE

;'DISPOSE'
DISPOSEcc:	CALL	L5DE3
		LD	HL,(L7B5E)
		CALL	L5271
		LD	HL,(L7B6F)
		CALL	CmpOutLDHL
L5DCE:		LD	HL,FreeMem
		JP	L5960

;'MARK'
MARKcc:		LD	HL,Mark
		JR	L5DDC

;'RELEASE'
RELEASEcc:	LD	HL,Release
L5DDC:		PUSH	HL
		CALL	L5DE9
		POP	HL
		JR	L5DB1

L5DE3:		CALL	L5DE9
		JP	CmpOutPUSHHL

L5DE9:		CALL	NeedRundAuf
		CALL	L677F
		LD	A,(L7B5C)
		CP	4
		RET	Z
		CALL	ErrAlways
		DEFB	28		;Pointer variable expected

;'OVRDRIVE'
OVRDRIVEcc:	CALL	NeedRundAuf
		CALL	L5E97
		LD	HL,OvrDrive
		JP	L5960

;'MOVE'
MOVEcc:		CALL	NeedRundAuf
		CALL	L677F
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L677F
		LD	HL,Move
		JP	L5D76

;'FILLCHAR'
FILLCHARcc:	CALL	NeedRundAuf
		CALL	L677F
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L5E97
		CALL	CmpOutPUSHHL
		CALL	NeedComma
		CALL	L5EBB
		LD	HL,FillChar
		JP	L5DB1

;'CRTINIT'
CRTINITcc:	LD	HL,CrtInit
		JR	L5E45

;'CRTEXIT'
CRTEXITcc:	LD	HL,CrtExit
		JR	L5E45

;'CLRSCR'
CLRSCRcc:	LD	HL,ClrScr
L5E45:		JP	CmpOutCALL

;'CLREOL'
CLREOLcc:	LD	HL,ClrEol
		JR	L5E45

;'NORMVIDEO', 'HIGHVIDEO'
NORMVIDEOcc:
HIGHVIDEOcc:	LD	HL,NormVideo
		JR	L5E45

;'LOWVIDEO'
LOWVIDEOcc:	LD	HL,LowVideo
		JR	L5E45

;'INSLINE'
INSLINEcc:	LD	HL,InsLine
		JR	L5E45

;'DELLINE'
DELLINEcc:	LD	HL,DelLine
		JR	L5E45

;'EXIT'
EXITcc:		LD	DE,0
		JP	L5639

;'HALT'
HALTcc:		LD	HL,HaltProgram
		JP	CmpOutJP

;'PORT'
PORTcc:		CALL	L5E8E
		CALL	CmpOutCopy
		  DEFB	3
		  POP	BC
		  OUT	(C),L
		RET

;'STACKPTR'
STACKPTRcc:	CALL	NeedAssign
		CALL	L5E97
		CALL	CmpOutCopy
		  DEFB	1
		  LD	SP,HL
		RET

L5E84:		CALL	L6D2A
		CALL	L5EE8
		CALL	L6D49
		RET

L5E8E:		CALL	L65D5
		CALL	NeedAssign
		CALL	CmpOutPUSHHL
L5E97:		CALL	L5EE8
		LD	A,B
		CP	10
		RET	Z
		CALL	ErrAlways
		DEFB	23		;Integer expression expected

L5EA2:		CALL	L5EE8
		LD	A,B
		CP	10
		RET	Z
		CP	9
		RET	Z
		CALL	ErrAlways
		DEFB	26		;Integer or real expression expected

L5EB0:		CALL	L5EE8
		LD	A,B
		CP	11
		RET	Z
		CALL	ErrAlways
		DEFB	20		;Boolean expression expected

L5EBB:		CALL	L5EE8
L5EBE:		LD	A,B
		CP	10
		RET	NC
		CP	8
		CALL	ErrIfNZero
		DEFB	31		;Simple expression expected
		LD	B,12
		LD	HL,StrToChar
		JP	CmpOutCALL

L5ED0:		CALL	L5EE8
		LD	A,B
		CP	8
		RET	Z
		CP	12
		CALL	ErrIfNZero
		DEFB	33		;String expression expected
L5EDD:		LD	B,8
		CALL	CmpOutCopy
		  DEFB	4
		  LD	H,L
		  LD	L,1
		  PUSH	HL
		RET

L5EE8:		CALL	L5F98
L5EEB:		PUSH	BC
		CALL	CompareTbl
		dbw	1,ExprTbl
		POP	BC
		RET	NZ
		LD	A,(HL)
		INC	A
		JR	Z,L5F34
		DEC	A
		PUSH	AF
		PUSH	BC
		CALL	L6148
		LD	HL,(L7B8B)
		PUSH	HL
		CALL	L5F98
		POP	HL
		LD	(L7B8D),HL
		POP	DE
		CALL	L6160
		POP	AF
		LD	E,A
		LD	D,0
		LD	HL,L5F68
		ADD	HL,DE
		LD	A,B
		CP	3
		JR	Z,L5F28
		INC	HL
		INC	HL
		CP	9
		JR	Z,L5F28
		INC	HL
		INC	HL
		CP	8
		JR	Z,L5F28
		INC	HL
		INC	HL
L5F28:		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		LD	A,D
		OR	E
		CALL	ErrIfZero
		DEFB	47		;Operand type(s) does not match operator
		EX	DE,HL
		JR	L5F62

L5F34:		LD	A,B
		CP	10
		JR	NC,L5F47
		CP	8
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
		LD	HL,StrToChar
		CALL	CmpOutCALL
		LD	B,12
L5F47:		PUSH	BC
		CALL	CmpOutPUSHHL
		CALL	L5F98
		POP	DE
		LD	A,B
		CP	3
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
		LD	A,C
		OR	A
		JR	Z,L5F5F
		CP	D
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
L5F5F:		LD	HL,InSet
L5F62:		CALL	CmpOutCALL
		LD	B,11
		RET

L5F68:		DEFW	EQSet
		DEFW	EQReal
		DEFW	EQString
		DEFW	EQInt

		DEFW	NESet
		DEFW	NEReal
		DEFW	NEString
		DEFW	NEInt

		DEFW	GESet
		DEFW	GEReal
		DEFW	GEString
		DEFW	GEInt

		DEFW	LESet
		DEFW	LEReal
		DEFW	LEString
		DEFW	LEInt

		DEFW	0
		DEFW	GTReal
		DEFW	GTString
		DEFW	GTInt

		DEFW	0
		DEFW	LSReal
		DEFW	LSString
		DEFW	LSInt

L5F98:		CALL	L6054
L5F9B:		PUSH	BC
		CALL	CompareTbl
		dbw	1,SimpleTbl
		POP	BC
		RET	NZ
		LD	A,B
		CP	4
		CALL	ErrIfZero
		DEFB	47		;Operand type(s) does not match operator
		LD	A,(HL)
		PUSH	AF
		PUSH	BC
		CALL	L6148
		CALL	L6054
		POP	DE
		POP	AF
		PUSH	AF
		OR	A
		JR	NZ,L5FC9
		LD	A,B
		CP	12
		JR	NZ,L5FC9
		CALL	CmpOutCopy
		  DEFB	4
		  LD	H,L
		  LD	L,1
		  PUSH	HL
		LD	B,8
L5FC9:		CALL	L6160
		POP	AF
		CP	2
		JR	NC,L601B
		PUSH	AF
		LD	A,B
		LD	HL,AddSet
		LD	DE,SubSet
		CP	3
		JR	Z,L6006
		LD	HL,AddReal
		LD	DE,SubReal
		CP	9
		JR	Z,L6006
		CP	8
		JR	Z,L6010
		CP	10
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
		POP	AF
		DEC	A
		JR	Z,L5FFC
		CALL	CmpOutCopy
		  DEFB	1
		  ADD	HL,DE
		JR	L5F9B

L5FFC:		CALL	CmpOutCopy
		  DEFB	4
		  EX	DE,HL
		  OR	A
		  SBC	HL,DE
		JR	L5F9B

L6006:		POP	AF
		DEC	A
		JR	NZ,L600B
		EX	DE,HL
L600B:		CALL	CmpOutCALL
		JR	L5F9B

L6010:		POP	AF
		DEC	A
		CALL	ErrIfZero
		DEFB	47		;Operand type(s) does not match operator
		LD	HL,Concat
		JR	L600B

L601B:		LD	A,B
		JR	NZ,L6039
		CP	11
		JR	Z,L602F
		CP	10
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
		CALL	CmpOutCopy
		  DEFB	3
		  LD	A,H
		  OR	D
		  LD	H,A
L602F:		CALL	CmpOutCopy
		  DEFB	3
		  LD	A,L
		  OR	E
		  LD	L,A
		JP	L5F9B

L6039:		CP	11
		JR	Z,L604A
		CP	10
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
		CALL	CmpOutCopy
		  DEFB	3
		  LD	A,H
		  XOR	D
		  LD	H,A
L604A:		CALL	CmpOutCopy
		  DEFB	3
		  LD	A,L
		  XOR	E
		  LD	L,A
		JP	L5F9B

L6054:		CALL	L60E9
L6057:		PUSH	BC
		CALL	CompareTbl
		dbw	1,TermTbl
		POP	BC
		RET	NZ
		LD	A,B
		CP	4
		CALL	ErrIfZero
		DEFB	47		;Operand type(s) does not match operator
		LD	A,(HL)
		PUSH	AF
		PUSH	BC
		CALL	L6148
		CALL	L60E9
		POP	DE
		POP	AF
		PUSH	AF
		DEC	A
		JR	NZ,L6083
		LD	A,B
		CP	0AH
		JR	NZ,L6083
		LD	HL,Int2Real
		CALL	CmpOutCALL
		LD	B,9
L6083:		CALL	L6160
		POP	AF
		LD	E,A
		LD	A,B
		INC	E
		DEC	E
		JR	NZ,L60A9
		LD	HL,MultSet
		CP	3
		JR	Z,L60A4
		LD	HL,MultInt
		CP	0AH
		JR	Z,L60A4
		LD	HL,MultReal
L609E:		CP	9
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
L60A4:		CALL	CmpOutCALL
		JR	L6057

L60A9:		LD	HL,DivReal
		DEC	E
		JR	Z,L609E
		DEC	E
		JR	NZ,L60CC
		CP	0BH
		JR	Z,L60C3
		CP	0AH
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
		CALL	CmpOutCopy
		  DEFB	3
		  LD	A,H
		  AND	D
		  LD	H,A
L60C3:		CALL	CmpOutCopy
		  DEFB	3
		  LD	A,L
		  AND	E
		  LD	L,A
		JR	L6057

L60CC:		CP	0AH
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
		LD	HL,DivInt
		DEC	E
		JR	Z,L60A4
		LD	HL,ModInt
		DEC	E
		JR	Z,L60A4
		LD	HL,ShLeft
		DEC	E
		JR	Z,L60A4
		LD	HL,ShRight
		JR	L60A4

L60E9:		CALL	CompareNam
		DEFW	NOTnam
		JR	NZ,L6112
		CALL	L6112
		LD	A,B
		CP	0AH
		JR	Z,L6107
		CP	0BH
		CALL	ErrIfNZero
		DEFB	47		;Operand type(s) does not match operator
		CALL	CmpOutCopy
		  DEFB	4
		  LD	A,L
		  XOR	1
		  LD	L,A
		RET

L6107:		CALL	CmpOutCopy
		  DEFB	6
		  LD	A,L
		  CPL
		  LD	L,A
		  LD	A,H
		  CPL
		  LD	H,A
		RET

L6112:		LD	A,(L7BA1)
		PUSH	AF
		CALL	L6A39
		LD	A,E
		LD	(L7BA1),A
		CALL	L621D
		LD	A,(L7BA1)
		LD	E,A
		CALL	L6A4A
		JR	Z,L6143
		LD	A,B
		CP	0AH
		JR	NZ,L613B
		CALL	CmpOutCopy
		  DEFB	7
		  LD	A,L
		  CPL
		  LD	L,A
		  LD	A,H
		  CPL
		  LD	H,A
		  INC	HL
		JR	L6143

L613B:		CALL	CmpOutCopy
		  DEFB	4
		  LD	A,B
		  XOR	80h
		  LD	B,A
L6143:		POP	AF
		LD	(L7BA1),A
		RET

L6148:		LD	A,B
		CP	0AH
		JR	NC,L615D
		CP	4
		JR	Z,L615D
		CP	8
		RET	Z
		CP	3
		RET	Z
	;put real number on stack
		CALL	CmpOutCopy
		  DEFB	2
		  PUSH	BC
		  PUSH	DE
L615D:		JP	CmpOutPUSHHL

L6160:		LD	A,D
		CP	9
		JR	NZ,L6174
		LD	A,B
		CP	0AH
		JR	NZ,L6187
		LD	HL,Int2Real
		CALL	CmpOutCALL
		LD	B,9
		JR	L6187

L6174:		CP	8
		JR	NZ,L6187
		LD	A,B
		CP	0CH
		JR	NZ,L6187
	;convert single character into string of length 1
		CALL	CmpOutCopy
		  DEFB	4
		  LD	H,L
		  LD	L,01h
		  PUSH	HL
		LD	B,8
L6187:		LD	A,B
		CP	9
		JR	NZ,L6193
		CALL	CmpOutCopy
		  DEFB	1
		  EXX
		JR	L61A4

L6193:		CP	8
		JR	NZ,L61A4
		LD	A,D
		CP	0CH
		JR	NZ,L61A4
		LD	HL,CharToStr
		CALL	CmpOutCALL
		LD	D,8
L61A4:		LD	A,D
		CP	0AH
		JR	Z,L61BC
		JR	NC,L61CE
		CP	4
		JR	Z,L61CE
		CP	9
		JR	C,L61D3
	;get real number of stack
		CALL	CmpOutCopy
		  DEFB	3
		  POP	HL
		  POP	DE
		  POP	BC
		JR	L61D3

L61BC:		LD	A,B
		CP	9
		JR	NZ,L61CE
		CALL	CmpOutPOPHL
		LD	HL,Int2Real
		CALL	CmpOutCALL
		LD	D,9
		JR	L61D3

L61CE:		CALL	CmpOutCopy
		  DEFB	1
		  POP	DE
L61D3:		LD	A,B
		CP	D
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
		CP	3
		JR	NZ,L61EA
		LD	A,E
		CP	C
		RET	Z
		OR	A
		RET	Z
		LD	A,C
		LD	C,E
		OR	A
		RET	Z
		CALL	ErrAlways
		DEFB	44		;Type mismatch

L61EA:		CP	4
		RET	NZ
		LD	HL,(L7B8B)
		LD	A,H
		OR	L
		RET	Z
		LD	DE,(L7B8D)
		LD	A,D
		OR	E
		RET	Z
		SBC	HL,DE
		RET	Z
		CALL	ErrAlways
		DEFB	44		;Type mismatch

L6201:		LD	DE,L5EEB
		PUSH	DE
		LD	DE,L5F9B
		PUSH	DE
		LD	DE,L6057
		PUSH	DE
		JR	L622D

L620F:		LD	DE,L5EEB
		PUSH	DE
		LD	DE,L5F9B
		PUSH	DE
		LD	DE,L6057
		PUSH	DE
		JR	L6276

L621D:		CALL	L6A5C
		JR	NZ,L6257
		LD	A,(L7BA1)
		LD	E,A
		CALL	L6A1F
		XOR	A
		LD	(L7BA1),A
L622D:		LD	A,B
		CP	9
		JR	NZ,L6249
		EXX
	;load real constant (into BCDEHL)
	;generates LD HL,../LD DE,../LD BC,..
		PUSH	BC
		PUSH	DE
		PUSH	HL
		LD	BC,0331h	;Code of LD HL,nn+10h
L6239:		LD	A,C
		SUB	10H
		LD	C,A
		CALL	CmpOutA
		POP	HL
		CALL	CmpOutHL
		DJNZ	L6239
		LD	B,9
		RET

L6249:		CP	8
		JP	NZ,CmpOutLDHL
		LD	HL,LoadCString
		CALL	CmpOutCALL
		JP	CmpOutString

L6257:		LD	BC,0600h
		CALL	ScanExistSym
		JR	NZ,L6271
		CALL	L573D
		EX	DE,HL
		CALL	L5287
		LD	HL,(L7B5E)
		LD	(L7B8B),HL
		LD	A,(L7B5C)
		LD	B,A
		RET

L6271:		CALL	L67B2
		JR	NZ,L62D2
L6276:		LD	A,(L7B5C)
		CP	8
		JR	NC,L6285
		CP	3
		JR	Z,L6285
		CP	4
		JR	NZ,L629D
L6285:		CALL	L66DA
		LD	HL,(L7B5E)
		LD	(L7B8B),HL
		LD	A,(L7B5C)
		LD	B,A
		CP	3
		RET	NZ
		CALL	L5287
		LD	A,(L7B5C)
		LD	C,A
		RET

L629D:		CP	1
		CALL	ErrIfNZero
		DEFB	62		;Structured variables are not allowed here
		CALL	L678B
		LD	HL,(L7B5E)
		LD	A,(HL)
		CP	0CH
		CALL	ErrIfNZero
		DEFB	62		;Structured variables are not allowed here
		LD	HL,(L7B60)
		LD	A,(HL)
		CP	0AH
		CALL	ErrIfNZero
		DEFB	62		;Structured variables are not allowed here
		LD	HL,(L7B62)
		LD	A,H
		OR	A
		CALL	ErrIfNZero
		DEFB	62		;Structured variables are not allowed here
		LD	H,L
		LD	L,6
		CALL	CmpOutHL
		LD	HL,LoadCharArr
		CALL	CmpOutCALL
		LD	B,8
		RET

L62D2:		CALL	ScanEckAuf
		JR	NZ,L631C
		LD	HL,EmptySet
		CALL	CmpOutCALL
		CALL	ScanEckZu
		LD	BC,0300h
		RET	Z
L62E4:		PUSH	BC
		CALL	L5EBB
		LD	A,B
		POP	BC
		INC	C
		DEC	C
		JR	NZ,L62EF
		LD	C,A
L62EF:		CP	C
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
		PUSH	BC
		CALL	CompareNam
		DEFW	DOTDOTnam
		LD	HL,ElemToSet
		JR	NZ,L6310
		CALL	CmpOutPUSHHL
		CALL	L5EBB
		LD	A,B
		POP	BC
		PUSH	BC
		CP	C
		CALL	ErrIfNZero
		DEFB	44		;Type mismatch
		LD	HL,RangeToSet
L6310:		CALL	CmpOutCALL
		POP	BC
		CALL	ScanComma
		JR	Z,L62E4
		JP	NeedEckZu

L631C:		CALL	ScanRundAuf
		JR	NZ,L6327
		CALL	L5EE8
		JP	NeedRundZu

L6327:		CALL	CompareTbl
		dbw	2,FuncTbl
		JR	NZ,L6335
		LD	E,(HL)
		INC	HL
		LD	D,(HL)
		EX	DE,HL
		XOR	A
		JP	(HL)

L6335:		CALL	CompareNam
		DEFW	NILnam
		JR	NZ,L6345
		LD	HL,0
		CALL	CmpOutLDHL
		JP	L642E

L6345:		LD	BC,0300h
		CALL	ScanExistSym
		CALL	ErrIfNZero
		DEFB	41		;Unknown identifier or syntax error
		LD	D,(HL)
		DEC	HL
		LD	E,(HL)
		LD	A,(DE)
		CP	0AH
		CALL	ErrIfCarry
		DEFB	30		;Simple type expected
		PUSH	AF
		CALL	L65EF
		POP	AF
		LD	B,A
		RET

;here: predefined functions
;--------------------------

;'SQR'
SQRcc:		CALL	L65E7
		LD	HL,SqrInt
		LD	A,B
		CP	0AH
		JR	Z,L636E
		LD	HL,SqrReal
L636E:		JP	CmpOutCALL

;'ABS'
ABScc:		CALL	L65E7
		LD	A,B
		CP	0AH
		JR	Z,L6380
	;determine absolute value of a real number
		CALL	CmpOutCopy
		  DEFB	2
		  RES	7,B
		RET

L6380:		LD	HL,AbsoluteHL
		JR	L63CF

;'SQRT'
SQRTcc:		LD	HL,SqrtReal
		JR	L63AB

;'SIN'
SINcc:		LD	HL,SinReal
		JR	L63AB

;'COS'
COScc:		LD	HL,CosReal
		JR	L63AB

;'ARCTAN'
ARCTANcc:	LD	HL,AtanReal
		JR	L63AB

;'LN'
LNcc:		LD	HL,LnReal
		JR	L63AB

;'EXP'
EXPcc:		LD	HL,ExpReal
		JR	L63AB

;'INT'
INTcc:		LD	HL,IntReal
		JR	L63AB

;'FRAC'
FRACcc:		LD	HL,FracReal
L63AB:		PUSH	HL
		CALL	L65E7
		LD	HL,Int2Real
		LD	A,B
		CP	0AH
		CALL	Z,CmpOutCALL
		POP	HL
		LD	B,9
		JP	CmpOutCALL

;'TRUNC'
TRUNCcc:	LD	HL,TruncReal
		JR	L63C6

;'ROUND'
ROUNDcc:	LD	HL,RoundReal
L63C6:		PUSH	HL
		CALL	L65E7
		POP	HL
		LD	A,B
		CP	0AH
		RET	Z
L63CF:		LD	B,10
		JP	CmpOutCALL

;'SUCC'
SUCCcc:		LD	A,23h		;INC HL
		DEFB	11H		;LD DE,2B3Eh

;'PRED'
PREDcc:		LD	A,2Bh		;DEC HL
		PUSH	AF
		CALL	L65EF
		POP	AF
		JP	CmpOutA

;'LO'
LOcc:		CALL	L65DE
	;LowByte of an integer
		CALL	CmpOutCopy
		  DEFB	2
		  LD	H,0
		RET

;'HI'
HIcc:		CALL	L65DE
	;HighByte of an integer
		CALL	CmpOutCopy
		  DEFB	3
		  LD	L,H
		  LD	H,0
		RET

;'SWAP'
SWAPcc:		CALL	L65DE
	;Swap High- and LowByte in integer
		CALL	CmpOutCopy
		  DEFB	3
		  LD	A,L
		  LD	L,H
		  LD	H,A
		RET

;'ODD'
ODDcc:		CALL	L65DE
		LD	HL,OddInt
L6407:		LD	B,11
L6409:		JP	CmpOutCALL

;'KEYPRESSED'
KEYPRESSEDcc:	LD	HL,ConSta
		JR	L6407

;'ORD'
ORDcc:		CALL	NeedRundAuf
		CALL	L5EE8
		CALL	NeedRundZu
		LD	A,B
		CP	4
		JR	Z,L6422
		CALL	L5EBE
L6422:		LD	B,0AH
		RET

;'CHR'
CHRcc:		CALL	L65DE
		LD	B,12
		RET

;'PTR'
PTRcc:		CALL	L65DE
L642E:		LD	HL,0
		LD	(L7B8B),HL
		LD	B,4
		RET

;'UPCASE'
UPCASEcc:	CALL	L65EF
		LD	B,0CH
		LD	HL,UpCase
		JR	L6409

;'LENGTH'
LENGTHcc:	CALL	NeedRundAuf
		LD	HL,Length
L6447:		PUSH	HL
		CALL	L5ED0
		CALL	NeedRundZu
		POP	HL
		JP	L63CF

;'POS'
POScc:		CALL	NeedRundAuf
		CALL	L5ED0
		CALL	NeedComma
		LD	HL,Pos
		JR	L6447

;'COPY'
COPYcc:		CALL	NeedRundAuf
		CALL	L5ED0
		CALL	NeedComma
		CALL	L5E97
		CALL	NeedComma
		CALL	CmpOutPUSHHL
		CALL	L5E97
		CALL	NeedRundZu
		LD	HL,Copy
		CALL	CmpOutCALL
L647E:		LD	B,8
		RET

;'CONCAT'
CONCATcc:	CALL	NeedRundAuf
		CALL	L5ED0
L6487:		CALL	ScanComma
		JR	NZ,L6497
		CALL	L5ED0
		LD	HL,Concat
		CALL	CmpOutCALL
		JR	L6487

L6497:		CALL	NeedRundZu
		JR	L647E

;'PARAMCOUNT'
PARAMCOUNTcc:	LD	HL,ParamCount
		JR	L64BF

;'PARAMSTR'
PARAMSTRcc:	CALL	L65DE
		LD	HL,ParamStr
		LD	B,8
		JP	CmpOutCALL

;'RANDOM'
RANDOMcc:	CALL	ScanRundAuf
		LD	HL,RandReal
		LD	B,9
		JR	NZ,L64C1
		CALL	L5E97
		CALL	NeedRundZu
		LD	HL,RandInt
L64BF:		LD	B,0AH
L64C1:		JP	CmpOutCALL

;'IORESULT'
IORESULTcc:	LD	HL,IOResult
		JR	L64BF

;'EOF'
EOFcc:		CALL	L65F7
		LD	HL,L6615
		CALL	L59E9
L64D2:		LD	B,0BH
		RET

;'SEEKEOF'
SEEKEOFcc:	LD	HL,SeekEof
		JR	L64E2

;'SEEKEOLN'
SEEKEOLNcc:	LD	HL,SeekEoln
		JR	L64E2

;'EOLN'
EOLNcc:		LD	HL,EndOfLine
L64E2:		PUSH	HL
		CALL	L65F7
		CP	6
		CALL	ErrIfNZero
		DEFB	35		;Text file expected
		POP	HL
		CALL	CmpOutCALL
		JR	L64D2

;END OF TP-C3.INC
;----------------
