;--------------------------------
;TP-ME2.INC	ho	03-MAR-94
;--------------------------------
;V2.00: 2AB4h-3408h
;V3.00: 2B93h-34ECh	V3.01: 2B72h-34CEh

		IDENT	TP-ME2.INC

MDir:		CALL	Print
		DEFB	'Dir mask',0
		CALL	GetLine
		CALL	ParseAFN
		LD	C,GetDrive
		CALL	SBDOS
		PUSH	AF
		PUSH	AF
		LD	A,(DefaultFCB)
		OR	A
		JR	Z,L2BBB
		POP	HL
		DEC	A
		LD	E,A
		PUSH	AF
		LD	C,DriveSelect
		CALL	SBDOS
L2BBB:		POP	AF
		ADD	A,'A'
		LD	(L2C8D),A
		LD	DE,SecBuf
		LD	C,SetDMA
		CALL	SBDOS
		LD	DE,0
		LD	C,SearchFirst
L2BCE:		PUSH	DE
		CALL	DefSBDOS
		POP	DE
		LD	C,A
		INC	A
		JR	Z,L2C29
		LD	A,C
		ADD	A,A
		ADD	A,A
		ADD	A,A
		ADD	A,A
		ADD	A,A
		LD	C,A
		LD	B,0
		LD	HL,SecBuf+10	;t2
		ADD	HL,BC
		BIT	7,(HL)		;t2' system attribute
		JR	NZ,L2C25
		LD	D,0FFh
		LD	HL,SecBuf
		ADD	HL,BC
		INC	E
		DEC	E
		JR	NZ,L2BFF
		LD	A,(Width)
		DEC	A
		LD	E,0FFh
L2BF8:		INC	E
		SUB	0Fh
		JR	NC,L2BF8
		JR	L2C05

L2BFF:		CALL	Print
		DEFB	': ',0
L2C05:		LD	B,11
L2C07:		INC	HL
		LD	A,(HL)
		AND	7Fh
		CALL	SConOut
		LD	A,B
		CP	4
		LD	A,' '
		CALL	Z,SConOut
		DJNZ	L2C07
		DEC	E
		JR	Z,L2C22
		LD	A,' '
		CALL	SConOut
		JR	L2C25

L2C22:		CALL	NewLine
L2C25:		LD	C,SearchNext
		JR	L2BCE

L2C29:		INC	E
		DEC	E
		CALL	NZ,NewLine
		INC	D
		JR	Z,L2C3E
		CALL	Print
		DEFB	'No file',CR,LF,0
L2C3E:		CALL	NewLine
		LD	C,GetDPB
		CALL	BDOS
		PUSH	HL
		POP	IX
		LD	A,(IX+03)	;BLM block mask
		INC	A		;convert to KByte per block:
		RRA			;07h = 1, 0Fh = 2
		RRA			;1Fh = 4, 3Fh = 8
		RRA			;7Fh = 16
		AND	1Fh
		LD	(L7B71),A
		LD	L,(IX+05)	;DSM number of blocks = capacity
		LD	H,(IX+06)
		LD	(L7B6F),HL
		INC	HL
		CALL	L2CC6
		PUSH	HL
		LD	C,GetALV
		CALL	BDOS
		EX	DE,HL
		LD	HL,(L7B6F)
		LD	BC,0
		CALL	L2CA5
		LD	H,B
		LD	L,C
		CALL	L2CC6
		CALL	Print
		DEFB	'Bytes Remaining On '
L2C8D:		DEFB	'X: ',0
		EX	DE,HL
		POP	HL
		OR	A
		SBC	HL,DE
		CALL	PrintInt1
		LD	A,'k'
		CALL	SConOut
		POP	AF
		LD	E,A
		LD	C,DriveSelect
		JP	SBDOS

L2CA5:		PUSH	BC
		LD	BC,0FFF8h
		ADD	HL,BC
		POP	BC
		LD	A,H
		OR	A
		LD	A,(DE)
		JP	P,L2CB8
L2CB1:		INC	L
		JR	Z,L2CBD
		OR	A
		RRA
		JR	L2CB1

L2CB8:		CALL	L2CBD
		JR	L2CA5

L2CBD:		INC	DE
L2CBE:		OR	A
		RET	Z
		RRA
		JR	NC,L2CBE
		INC	BC
		JR	L2CBE

L2CC6:		LD	A,(L7B71)
L2CC9:		RRA
		RET	C
		ADD	HL,HL
		JR	L2CC9

MLogged:	CALL	Print
		DEFB	'New drive',0
		CALL	GetLine
		LD	A,(DE)
		CP	EOF		;any input?
		JR	NZ,L2CE8	;yes -> evaluate
		LD	A,(CurrDU)	;no, use current drive
		JR	L2CF1

L2CE8:		CALL	ToUpper
		SUB	'A'
		RET	C
		CP	16
		RET	NC
L2CF1:		PUSH	AF
		LD	C,Reset
		CALL	SBDOS
		POP	AF
		LD	(CurrDU),A
		LD	E,A
		LD	C,DriveSelect
		JP	SBDOS

;Ask yes/no
;E:- / V: AF
;R: Zero if 'N' was entered, NZero if 'Y' was entered
;   The letter is echoed on screen
YesNo:		CALL	Print
		DEFB	' (Y/N)? ',0
YesNo1:		CALL	SConInp
		CALL	ToUpper
		CP	'Y'
		JR	Z,YesNo2
		CP	'N'
		JR	NZ,YesNo1
YesNo2:		CALL	SConOut
		SUB	'N'
		RET

;Ask yes/no with new line
;E:- / V: AF
;R: Zero if 'N' was entered, NZero if 'Y' was entered
;   The letter is echoed on screen and a new line is started
YesNoCR:	CALL	YesNo
		PUSH	AF		;save result
		CALL	NewLine
		POP	AF
		RET

	;PATCH>> change default extension of editor
	;PATCH>> 2D2Bh 50h -> xx
	;PATCH>> 2D2Dh 41h -> xx
	;PATCH>> 2D2Eh 53h -> xx
;E: DE points to file name
;R: DE points to separator
ParsePAS:	LD	A,'P'
		LD	HL,'SA'
;<fall through>

;E: extension in A/HL, DE points to file name
;R: DE points to separator
ParseEXT:	LD	(DefaultFCB+9),A
		LD	(DefaultFCB+10),HL
		LD	C,0		;WildCards are not allowed
		CALL	ParseFN
		LD	A,(DefaultFCB)
		OR	A		;was a drive designator given?
		RET	NZ		;yes -> finished
		PUSH	DE		;no, insert current drive
		LD	C,GetDrive
		CALL	SBDOS
		INC	A
		LD	(DefaultFCB),A
		POP	DE
		RET

;E:- / V: AF
;R: A=0 and Zero if no WorkFile given,
;   else A<>0 and NZero
WorkFGiven:	LD	A,(WorkFCB+1)
		OR	A
		RET

L2D50:		CALL	WorkFGiven
		JR	NZ,L2D6F
		CALL	MainFGiven
		JR	NZ,L2D5F
		CALL	MWorkF
		JR	L2D6F

L2D5F:		LD	DE,WorkFCB
		LD	HL,MainFCB
		LD	BC,FCBSize
		LDIR
		LD	A,1
		LD	(L44F1),A
L2D6F:		LD	A,(L44F1)
		OR	A
		RET	Z
		CALL	AutoSave
		JP	MWorkF2

;E:- / V: AF
;R: A=0 and Zero if no MainFile given,
;   else A<>0 and NZero
MainFGiven:	LD	A,(MainFCB+1)
		OR	A
		RET

;Compare WorkFile name and MainFile name
;E:- / V: AF, B, DE, HL
;R: Zero if WorkFile = MainFile, else NZero
CmpFiles:	LD	DE,WorkFCB
		LD	HL,MainFCB
		LD	B,12
CmpFil1:	LD	A,(DE)
		SUB	(HL)
		RET	NZ
		INC	DE
		INC	HL
		DJNZ	CmpFil1
		RET

ClearText:	LD	HL,(TextStart)
		LD	(HL),' '
		INC	HL
		LD	(TextEnd),HL
		XOR	A
		LD	(WorkDirty),A
		LD	(L44F1),A
ClearCompFlag:	XOR	A
		LD	(CompFlag),A
		RET

;Read in MSG file
ReadMSG:	LD	HL,(L429E)
		LD	(TextStart),HL
		LD	DE,WhoAmI
		LD	A,'M'
		LD	HL,'GS'
		CALL	L2E20
		LD	(MSGPresent),A
		CALL	Z,PressEscape
		JR	Z,ReadMSG1
		LD	HL,FNotFound
		LD	(NotFoundJp+1),HL ;InTheCode!
		LD	HL,FTooBig
		LD	(TooBigJp+1),HL	;InTheCode!
		LD	DE,DefaultFCB
		CALL	ReadTextFile
ReadMSG1:	LD	HL,(TextEnd)
		LD	(HL),EOF
		INC	HL
		LD	(TextStart),HL
		RET

;Convert hex number to integer
;E: pointer to number in DE
;V: AF, DE, HL
;R: value in HL, pointer to first non-digit in DE
HexToInt:	LD	HL,0		;initialise value
HexToIn1:	LD	A,(DE)
		CALL	ToUpper
		SUB	'0'		;smaller than '0'?
		RET	C		;yes -> not allowed
		CP	10		;greater then '9'?
		JR	C,HexToIn2	;no -> is ok
		SUB	7		;yes, close gap
		CP	10		;was it between '9' and 'A'?
		RET	C		;yes -> not allowed
		CP	16		;was it greater then 'F'?
		RET	NC		;yes -> not allowed
	;now value of nibble in A
HexToIn2:	ADD	HL,HL		;former value times 16
		ADD	HL,HL		;(make space for new nibble)
		ADD	HL,HL
		ADD	HL,HL
		OR	L
		LD	L,A		;insert new nibble
		INC	DE		;advance pointer
		JR	HexToIn1

;Output file name
;E: pointer to FCB in DE
;V: AF, B, DE / R:-
PrintFName:	INC	DE
		LD	A,(DE)		;look if file name
		DEC	DE		;given
		OR	A
		RET	Z		;no -> do nothing
		LD	A,(DE)		;get drive
		ADD	A,'@'		;convert to letter
		CP	'@'		;was it current drive?
		CALL	NZ,SConOut	;if so then
		LD	A,':'		;don't output drive
		CALL	NZ,SConOut
		LD	B,11		;length of the file name
PrintFN1:	INC	DE
		LD	A,(DE)
		AND	7Fh		;suppress flags
		CP	' '
		CALL	NZ,SConOut	;suppress spaces
		LD	A,B
		CP	4		;after 8 characters?
		LD	A,'.'		;yes -> insert point
		CALL	Z,SConOut
		DJNZ	PrintFN1
		RET

;E: extension in A/HL
;R: NZero if found, Zero if not
L2E20:		CALL	ParseEXT
		LD	HL,DefaultFCB
		CALL	OpenDefault
		RET	NZ		;not found?
		LD	A,(LoggedDrive)	;then try current drive
		CP	(HL)		;if different
		LD	(HL),A
		CALL	NZ,OpenDefault
		RET	NZ		;no success?
		LD	A,1		;then try it with drive A:
		CP	(HL)		;if different
		LD	(HL),A
		CALL	NZ,OpenDefault
		RET	NZ		;neither?
		LD	(HL),0		;then we give up
		EX	DE,HL
L2E3E:		CALL	PrintFName
		CALL	Print
		DEFB	' not found',0
		XOR	A
		RET

;Open the file, which FCB is in DefaultFCB
;E:- / V: AF / R: Zero if error
OpenDefault:	PUSH	DE
		PUSH	HL
		LD	C,OpenFile
		CALL	DefSBDOS
		POP	HL
		POP	DE
		INC	A
		RET

;Output an integer decimal 5 digits
;E: value in HL
;V: AF, BC, DE, HL / R:-
PrintInt5:	LD	DE,-5
		JR	PrintInt

;output an integer decimal flush-left
;E: value in HL
;V: AF, BC, DE, HL / R:-
PrintInt1:	LD	DE,-1
;<fall through>

;E: value in HL, output format in DE
;V: AF, BC, DE, HL / R:-
PrintInt:	PUSH	IX		;save registers
		PUSH	IY
		PUSH	HL		;value on stack
		PUSH	DE
		CALL	PrepOutput
		POP	HL		;output format to HL
		CALL	WriteInt
		POP	IY		;restore registers
		POP	IX
		RET

;Wait for ESC key pressed
;E:- / V:- / R:-
PressEscape:	PUSH	AF
		CALL	Print
		DEFB	'. Press <ESC>',0
PressEsc1:	CALL	SConInp
		CP	ESC
		JR	NZ,PressEsc1
		POP	AF
		RET

L2E91:		PUSH	HL		;Editor
IF TPVers2
		LD	HL,(TextEnd)
		LD	(HL),LF
		DEC	HL
		LD	(HL),CR
ELSE	;TPVers3
		LD	DE,LF*256 +CR
		LD	HL,(TextEnd)
		LD	(HL),D
		DEC	HL
		LD	(HL),E
		LD	(L7BF3),DE
ENDIF
		XOR	A
		LD	(L4474),A
		INC	A
		LD	(L4475),A
		LD	HL,L43DE	;List of separators
		LD	(L7B72),HL
		LD	IY,L446C
		CALL	ClrScr
		POP	DE
		INC	DE
		LD	HL,(TextStart)
		ADD	HL,DE
		CALL	L33A9
L2EBD:		LD	A,(L4482)
		DEC	A
		JR	Z,L2ED5
		LD	HL,0
		CALL	CsrXY
		LD	A,(L4482)
		ADD	A,A
		LD	B,A
		LD	A,' '
L2ED0:		CALL	SConOut
		DJNZ	L2ED0
L2ED5:		CALL	L3B96
		CALL	L2FF7
		CALL	L2F3A		;get key or command sequence
		JR	NC,L2F0E	;single char ->
		JR	Z,L2EBD
		LD	HL,L2EBD
		LD	A,D
		CP	7Fh
		JR	C,L2EF4
		LD	(WorkDirty),A
		AND	7Fh
		LD	D,A
		XOR	A
		LD	(CompFlag),A
L2EF4:		PUSH	HL
		PUSH	DE
		LD	HL,L4456+1
		LD	DE,L445A+1
		LD	BC,8
		LDDR
		RET

;Control character prefix
ECmd45:		CALL	L2F8A
		LD	(IY+22),3	;=4483h
		CALL	L4271
		JR	L2F16

L2F0E:		LD	(WorkDirty),A
		LD	HL,CompFlag
		LD	(HL),0
L2F16:		LD	HL,(L4452)
		LD	DE,L7BF1
		CALL	L3BE2
		JR	NC,L2EBD
		BIT	0,(IY+06)	;=4472h
		PUSH	AF
		CALL	Z,L41EB
		POP	AF
		LD	(HL),A
		INC	HL
		PUSH	HL
		CALL	L4197
		POP	HL
		LD	(L4452),HL
		CALL	L3FE7
		JP	L2EBD

;Get key or command sequence
;R: NCarry and key in A
;   Carry and Zero (A=0) if sequence not found
;   Carry and NZero (A<>0) if sequence found, destination in DE
L2F3A:		CALL	L4271		;get key
		CP	DEL
IF TPVersion EQ 301
		JR	NC,L2F44
ELSE
		JR	Z,L2F44
ENDIF
		CP	' '
		RET	NC		;leave if neither DEL nor Control
L2F44:		LD	HL,L4482	;store as string
		LD	(HL),1
		INC	HL
		LD	(HL),A
L2F4B:		PUSH	HL
		LD	HL,L4482
		LD	DE,ECmdInst
		LD	B,0FFh
		CALL	L2FC1
		POP	HL
		OR	A		;found something?
		JR	NZ,L2F6B	;yes -> don't search other table
		PUSH	HL
		LD	HL,L4482
		LD	DE,ECmdOrg
		LD	B,1Fh		;make no distinction between control char or
		CALL	L2FC1		;letter and irgnore case
		POP	HL
		OR	A		;found something?
		SCF
		RET	Z		;no -> return with Carry, Zero
L2F6B:		DEC	A		;prefix?
		JR	Z,L2F78		;yes -> maybe echo it, then next key
	;sequence entered completely, BC has number
		LD	HL,EJumps	;jump table
		ADD	HL,BC
		ADD	HL,BC		;does not change Zero
		LD	E,(HL)		;get entry
		INC	HL
		LD	D,(HL)
		SCF			;return with Carry, NZero
		RET

;Maybe output sequence so far, wait for next key
L2F78:		CALL	L2F8A		;output
		PUSH	AF
		CALL	L4271		;get key
		INC	(IY+22)		;=4482h
		INC	HL
		LD	(HL),A
		POP	AF		;maybe output again, if
		CALL	Z,L2F8A		;something different was output before
		JR	L2F4B

;If TypeAhead empty then output in upper left corner sequence at 4482h
;R: Zero if something was output, else NZero
L2F8A:		CALL	STypeAhead
		CALL	TypeAEmpty	;something there?
		RET	NZ		;yes -> execute at once
	;show fist char of a command sequence (e.g. '^Q' when ^Q^C)
		PUSH	HL
		LD	HL,0000h
		CALL	CsrXY
		LD	HL,L4482
		LD	A,(HL)
L2F9C:		PUSH	AF
		INC	HL
		LD	A,(HL)
		CALL	L2FA8		;output char
		POP	AF
		DEC	A
		JR	NZ,L2F9C
		POP	HL		;Zero
		RET

;Output character HighLighted
;E: character in A
;V: F / R:-
L2FA8:		PUSH	AF
		CALL	XNormVideo
		POP	AF
IF TPVersion EQ 301
		CP	DEL
		RET	NC
ENDIF
		CP	' '		;control character?
		JP	NC,SConOut	;no -> output directly
		PUSH	AF		;yes, output as ^x
		PUSH	AF
		LD	A,'^'
		CALL	SConOut
		POP	AF
		ADD	A,40h		;convert to letter
		CALL	SConOut
		POP	AF
		RET

;E: HL= pointer to search string, DE= pointer to compact series of strings,
;    B= bit mask for comparison
;V: AF, BC, DE
;R: A=0 if string not found
;   A=1 if prefix of a string and BC is its number (first =0)
;   A=-1 if whole string found and   "
L2FC1:		LD	C,-1
		PUSH	BC
		PUSH	HL
L2FC5:		POP	HL
		POP	BC
		LD	A,(DE)		;look into table
		INC	DE
		OR	A		;length 0?
		RET	Z		;this is the end of the table
		INC	C		;increment counter
		PUSH	BC
		PUSH	HL
		LD	C,(HL)		;get string length
		SUB	C		;smaller than table entry?
		INC	HL
		JR	NC,L2FD7	;yes -> compare
		ADD	A,C		;no, impossible
		LD	C,A		;advance
		JR	L2FF0

L2FD7:		PUSH	AF
L2FD8:		LD	A,(DE)
		SUB	(HL)		;character equal except
		AND	B		;mask?
		JR	NZ,L2FED	;no -> advance
		INC	DE
		INC	HL
		DEC	C
		JR	NZ,L2FD8
	;found string
		POP	AF
		POP	HL
		POP	BC
		LD	B,0
		LD	A,-1		;-1 if length matches too
		RET	Z
		LD	A,1		;1 if only prefix
		RET

L2FED:		POP	AF
		ADD	A,C
		LD	C,A
L2FF0:		LD	B,0
		EX	DE,HL
		ADD	HL,BC
		EX	DE,HL
		JR	L2FC5

L2FF7:		CALL	STypeAhead
		CALL	TypeAEmpty
		RET	NZ
		LD	HL,L4474
		LD	A,(HL)
		OR	A
		JR	NZ,L3078
		LD	(HL),0FFh
		LD	HL,0
		LD	(L4476),HL
		XOR	A
		LD	(L4478),A
		CALL	CsrXY
		CALL	L3C12
		CALL	XLowVideo
		LD	A,(Width)
		CP	56
		JR	C,L302A
		LD	HL,42*256+0
		CALL	CsrXY
		CALL	PrintWorkFN
L302A:		LD	HL,0600h
		CALL	L420E
		DEFB	'Line ',0
		LD	HL,1000h
		CALL	L420E
		DEFB	'Col ',0
		LD	HL,1800h
		LD	A,(L4472)
		OR	A
		JR	NZ,L305A
		CALL	L420E
		DEFB	'Insert    ',0
		JR	L3068

L305A:		CALL	L420E
		DEFB	'Overwrite ',0
L3068:		LD	A,(L4479)
		OR	A
		JR	NZ,L3078
		CALL	L4211
		DEFB	'Indent',0
L3078:		LD	A,(L446C)
		ADD	A,(IY+04)
		INC	A
		LD	HL,(L4478)
		CP	L
		JR	Z,L309B
		LD	(L4478),A
		PUSH	AF
		LD	HL,1400h
		CALL	CsrXY
		CALL	XLowVideo
		POP	AF
		LD	L,A
		LD	H,0
		LD	A,3
		CALL	L30EC
L309B:		LD	DE,(L4476)
		LD	HL,(L4450)
		CALL	L3BE2
		JP	Z,L37A4
		CALL	L37A4
		LD	DE,(TextStart)
		LD	HL,(L4450)
		OR	A
		SBC	HL,DE
		LD	C,L
		LD	B,H
		EX	DE,HL
		LD	DE,1
		LD	A,C
		OR	B
		JR	Z,L30D3
L30BF:		LD	A,LF
		INC	DE
		CPIR
		JP	PO,L30D3
		DEC	E
		INC	E
		CALL	Z,STypeAhead
		CALL	TypeAEmpty
		JR	NZ,L30E9
		JR	L30BF

L30D3:		LD	HL,0B00h
		PUSH	DE
		CALL	CsrXY
		CALL	XLowVideo
		POP	HL
		LD	A,5
		CALL	L30EC
		LD	HL,(L4450)
		LD	(L4476),HL
L30E9:		JP	L37A4

;Output number decimal, flush-left, with suppression of leading zeros
;E: number in HL, field width in A
;V: AF, B, DE, HL
L30EC:		PUSH	AF		;save field width
		LD	B,0		;suppress zeros
		CALL	L30FE		;output number
		POP	AF
		ADD	A,B		;remaining field width
		RET	Z		;=0? Then finished
		LD	B,A		;no, fill up with spaces
		LD	A,' '
L30F8:		CALL	SConOut
		DJNZ	L30F8
		RET

;Output number decimal, with suppression of leading zeros
;E: number in HL, flag 'zero suppression' in B: 0= yes, <>0= no
;V: AF, B, DE, HL
;R: B is B.previous minus characters output
L30FE:		LD	A,H
		OR	L		;special case =0?
		LD	A,'0'
		JR	Z,DezDig3	;yes -> output 0
		LD	DE,10000
		CALL	DezDigit
		LD	DE,1000
		CALL	DezDigit
		LD	DE,100
		CALL	DezDigit
		LD	DE,10
		CALL	DezDigit
		LD	DE,1		;not much efficient
;<fall through>

;E: remainder of number in HL, divisor in DE, flag 'zero suppression' in B
;V: AF, B, HL
;R: B is B.previous-1 if a character was output
;   HL is HL.previous mod divisor
DezDigit:	XOR	A		;set counter to 0, set NCarry
DezDig1		SBC	HL,DE		;look how often it fits in
		JR	C,DezDig2
		INC	A
		JR	DezDig1

DezDig2:	ADD	HL,DE		;correct
		ADD	A,'0'
		CP	'0'		;zero?
		JR	NZ,DezDig3	;no -> output and switch off zero suppression
		INC	B
		DEC	B		;suppress zeros?
		RET	Z		;yes -> do not output
DezDig3:	DEC	B
		JP	SConOut

PrintWorkFN:	LD	DE,WorkFCB
		JP	PrintFName

L313B:		CALL	Print
		DEFB	': ',0
		EX	DE,HL
		PUSH	HL
		POP	IX
		INC	HL
		LD	D,(HL)
		LD	(HL),0
		INC	HL
L314A:		RES	0,(IY+07)	;=4473h
		PUSH	DE
		PUSH	HL
		CALL	L2F3A
		POP	HL
		POP	DE
		SET	0,(IY+07)
		JR	NC,L31B9
		JR	NZ,L3165
		LD	A,(L4483)
		CALL	L3EF6
		JR	L314A

L3165:		LD	A,C
		CP	0
		JR	NZ,L316D
		LD	(HL),EOF
		RET

L316D:		CP	3
		JR	NZ,L317C
		LD	A,(IX+01)
		CP	D
		JR	NC,L314A
		INC	(IX+01)
		JR	L31C6

L317C:		CP	5
		JR	NZ,L3190
L3180:		LD	A,(IX+01)
		CP	D
		JR	Z,L314A
		LD	A,(HL)
		CALL	L2FA8
		INC	HL
		INC	(IX+01)
		JR	L3180

L3190:		CP	4
		JR	NZ,L319B
L3194:		CALL	L31D7
		JR	NZ,L3194
		JR	L314A

L319B:		CP	'-'		;2DH
		JR	NZ,L31A4
		CALL	L4271
		JR	L31B9

L31A4:		CP	1BH
		JR	Z,L31B4
		CP	1CH
		JR	Z,L31B4
		CP	1
		JR	Z,L31B4
		CP	2
		JR	NZ,L314A
L31B4:		CALL	L31D7
L31B7:		JR	L314A

L31B9:		LD	E,A
		LD	A,(IX+01)
		CP	(IX)
		JR	NC,L314A
		INC	(IX+01)
		LD	(HL),E
L31C6:		LD	A,(HL)
		INC	HL
		CALL	L2FA8
		LD	A,(IX+01)
		CP	D
		JR	C,L31B7
		LD	D,(IX+01)
		JP	L31B7

L31D7:		LD	A,(IX+01)
		OR	A
		RET	Z
		DEC	(IX+01)
		DEC	HL
		LD	A,(HL)
		CP	' '		;20H
		CALL	C,L31E6
L31E6:		CALL	L4211
		DEFB	BS@,SPC@,BS@,0
		LD	A,0FFH
		OR	A
		RET

;Find
ECmd42:		XOR	A
		LD	(L447E),A
		CALL	L31FD
		CALL	L3220
		JR	L3252

L31FD:		CALL	L3E04
		DEFB	'Find',0
		LD	DE,L4490
L3208:		JP	L313B

L320B:		CALL	L3E07
		DEFB	'Replace with',0
		LD	DE,L44B1
		JR	L3208

L3220:		CALL	L3E07
		DEFB	'Options',0
		LD	DE,L44D2
		CALL	L313B
		LD	A,(Width)
		LD	H,A
		DEC	H
		LD	L,0
		JP	CsrXY

;Find & replace
ECmd43:		LD	A,0FFH
		LD	(L447E),A
		CALL	L31FD
		CALL	L320B
		CALL	L3220
		JR	L3252

;Repeat last find
ECmd44:		CALL	L2F8A
		LD	(IY+22),3	;=4482h
L3252:		CALL	L3E40
		CALL	L3E23
		INC	HL
		LD	DE,(L4452)
		CALL	L4191
		LD	DE,L7B74
		OR	A
		SBC	HL,DE
		LD	DE,(L4450)
		ADD	HL,DE
		LD	(L4488),HL
		LD	DE,0
		LD	HL,L44D3
		LD	B,(HL)
		LD	(IY+17),0	;=447Dh
		INC	B
		DEC	B
		JR	Z,L32C0
L327D:		INC	HL
		LD	A,(HL)
		CP	'0'
		JR	C,L3293
		CP	'9'+1
		JR	NC,L3293
		CALL	L3426
		SUB	'0'
		ADD	A,E
		LD	E,A
		JR	NC,L32BE
		INC	D
		JR	L32BE

L3293:		CALL	ToUpper
		CP	'W'
		JR	NZ,L329E
		SET	0,(IY+17)
L329E:		CP	'U'
		JR	NZ,L32A6
		SET	2,(IY+17)
L32A6:		CP	'N'
		JR	NZ,L32AE
		SET	1,(IY+17)
L32AE:		CP	'G'
		JR	NZ,L32B6
		SET	3,(IY+17)
L32B6:		CP	'B'
		JR	NZ,L32BE
		SET	4,(IY+17)
L32BE:		DJNZ	L327D
L32C0:		LD	A,E
		OR	D
		JR	NZ,L32C7
		LD	DE,1
L32C7:		LD	(L448A),DE
		LD	HL,(TextStart)
		LD	A,(L447D)
		BIT	4,A
		JR	Z,L32D8
		LD	HL,(TextEnd)
L32D8:		BIT	3,A
		JR	NZ,L32DF
		LD	HL,(L4488)
L32DF:		LD	(L4488),HL
		BIT	4,(IY+17)
		JR	NZ,L32F5
		LD	DE,(TextEnd)
		DEC	DE
		CALL	L3BE2
		JP	NC,L3380
		JR	L32FB

L32F5:		CALL	L3BEE
		JP	C,L3380
L32FB:		LD	DE,L4492
		LD	A,(L4491)
		LD	B,A
		BIT	4,(IY+17)
		JR	Z,L330E
		DEC	A
		ADD	A,E
		LD	E,A
		JR	NC,L330E
		INC	D
L330E:		BIT	0,(IY+17)
		JR	Z,L3323
		PUSH	DE
		PUSH	HL
		CALL	L33FB
		LD	A,(HL)
		POP	HL
		POP	DE
		JR	C,L3323
		CALL	L33E4
		JR	C,L3377
L3323:		DEC	B
		INC	B
		JR	Z,L332E
L3327:		CALL	L340F
		JR	NZ,L3377
		DJNZ	L3364
L332E:		BIT	0,(IY+17)
		JR	Z,L3341
		PUSH	HL
		CALL	L3406
		LD	A,(HL)
		POP	HL
		JR	C,L3341
		CALL	L33E4
		JR	C,L3377
L3341:		BIT	4,(IY+17)
		CALL	Z,L3BDD
		LD	A,(L447E)
		OR	A
		CALL	NZ,L3430
		BIT	3,(IY+17)
L3353:		JR	NZ,L32DF
		LD	BC,(L448A)
		DEC	BC
		LD	(L448A),BC
		LD	A,B
		OR	C
		JR	NZ,L3353
		JR	L33A9

L3364:		PUSH	DE
		CALL	L3406
		POP	DE
		JR	C,L3380
		BIT	4,(IY+17)
		JR	Z,L3374
		DEC	DE
		JR	L3327

L3374:		INC	DE
		JR	L3327

L3377:		LD	HL,(L4488)
		CALL	L3406
		JP	NC,L32DF
L3380:		CALL	L33D6
		CALL	L33A9
		BIT	3,(IY+17)
		RET	NZ
		CALL	L3E04
		DEFB	'Search string not found',0
		JP	L3F12

L33A9:		CALL	L33AF
		JP	ECmd41		;Restore line

L33AF:		LD	DE,(TextEnd)
		DEC	DE
		CALL	L3BE2
		JR	C,L33BA
		EX	DE,HL
L33BA:		PUSH	HL
		PUSH	HL
		CALL	L3BF5
		LD	(L4450),HL
		OR	A
		EX	DE,HL
		POP	HL
		SBC	HL,DE
		LD	DE,L7B74
		ADD	HL,DE
		LD	(L4452),HL
		CALL	L3FE7
		CALL	L401F
		POP	HL
		RET

L33D6:		LD	DE,(TextStart)
		CALL	L4191
		LD	HL,(TextEnd)
		DEC	HL
		JP	L4191

;E: character in A / V: F
;R: Carry if character in ['0'..'9','A'..'Z','a'..'z']
;   else NCarry
;IsAlphaNum:
L33E4:		CP	'0'
		JR	C,L33F9		;smaller than '0' is not good
		CP	'9'+1
		RET	C		;between '0' and '9' (incl) is ok
		CP	'A'
		JR	C,L33F9		;between '9' and 'A' (excl) is not good
		CP	'Z'+1
		RET	C		;between 'A' and 'Z' (incl) is ok
		CP	'a'
		JR	C,L33F9		;between 'Z' and 'a' (excl) is not good
		CP	'z'+1
		RET	C		;between 'a' and 'z' (incl) is ok
					;greater than 'z' is not good
L33F9:		OR	A		;set NCarry
		RET

L33FB:		BIT	4,(IY+17)
		JR	Z,L340C
L3401:		CALL	L3BDD
		CCF
		RET

L3406:		BIT	4,(IY+17)
		JR	Z,L3401
L340C:		JP	L3BEE

L340F:		LD	A,(DE)
		CP	1
		RET	Z
		CP	(HL)
		RET	Z
		BIT	2,(IY+17)
		JR	Z,L3424
		CALL	L33E4
		JR	NC,L3424
		XOR	(HL)
		AND	0DFH
		RET

L3424:		CP	(HL)
		RET

;E: number in DE / V: F
;R: number * 10 in DE
L3426:		PUSH	HL
		LD	L,E
		LD	H,D
		ADD	HL,HL	;x 2
		ADD	HL,HL	;x 4
		ADD	HL,DE	;x 5
		ADD	HL,HL	;x 10
		EX	DE,HL
		POP	HL
		RET

L3430:		PUSH	HL
		CALL	TypeAEmpty
		JR	Z,L343C
		BIT	1,(IY+17)
		JR	NZ,L349D
L343C:		CALL	L33A9
		CALL	L3B96
		BIT	1,(IY+17)
		JR	NZ,L349D
		CALL	L3E07
		DEFB	'Replace (',Y@,'/',N@,'): ',0
L345B:		LD	L,(IY+05)
		LD	H,(IY+04)
		CALL	CsrXY
		LD	BC,07D0h
L3467:		CALL	STypeAhead
		CALL	TypeAEmpty
		JR	NZ,L348C
		DEC	BC
		LD	A,C
		OR	B
		JR	NZ,L3467
		LD	HL,0F00h
		CALL	CsrXY
		LD	BC,07D0h
L347D:		CALL	STypeAhead
		CALL	TypeAEmpty
		JR	NZ,L348C
		DEC	BC
		LD	A,C
		OR	B
		JR	NZ,L347D
		JR	L345B

L348C:		CALL	L4271
		CALL	L3EF6
		CALL	ToUpper
		CP	'Y'
		JR	Z,L349D
		CP	CtlY
		JR	NZ,L34EB
L349D:		SET	0,(IY+19)
		XOR	A
		LD	(CompFlag),A
		LD	A,(L44B2)
		LD	C,A
		LD	B,0
		POP	HL
		PUSH	HL
		PUSH	BC
		LD	A,(L4491)
		SUB	C
		LD	C,A
		PUSH	AF
		JR	NC,L34B7
		DEC	B
L34B7:		BIT	4,(IY+17)
		JR	NZ,L34C0
		LD	HL,(L4488)
L34C0:		POP	AF
		PUSH	HL
		CALL	NZ,L3F18
		POP	DE
		POP	BC
		LD	A,B
		OR	C
		JR	Z,L34D0
		LD	HL,L44B3
		LDIR
L34D0:		CALL	TypeAEmpty
		PUSH	AF
		CALL	NZ,L4147
		POP	AF
		JR	NZ,L34E2
		PUSH	DE
		CALL	ECmd41		;Restore line
		CALL	L4139
		POP	DE
L34E2:		BIT	4,(IY+17)
		JR	NZ,L34EB
		POP	HL
		EX	DE,HL
		RET

L34EB:		POP	HL
		RET

;END OF TP-ME2.INC
;-----------------
